===============================================================
Tag name:  clm3_5_00
Originator(s):  erik (Erik Kluzek)
Date: Thu May  3 12:03:53 MDT 2007
Date:One-line Summary: New surface datasets, improved canopy integration, and various improvements to Hydrology

Purpose of changes (Since CLM3.0):

  CLM3.5 is considerably different to CLM3.0, particularly with respect to its 
  simulation of the hydrologic cycle.   The modifications consist of new surface 
  datasets based on Moderate Resolution Imaging Spectroradiometer (MODIS) products 
  (Lawrence and Chase 2007), an improved canopy integration scheme 
  (Thornton and Zimmermann 2007), scaling of canopy interception (Lawrence et al. 2007), 
  a simple TOPMODEL-based model for surface and sub-surface runoff (Niu et al. 2005), a 
  simple groundwater model for determining water table depth (Niu et al. 2007), and a 
  new frozen soil scheme (Niu and Yang 2006).  

  There are four additional modifications.  Three of these, an improved description of 
  soil water availability, a resistance term to reduce excessive soil evaporation, and the
  introduction of a factor to simulate nitrogen limitation on plant productivity, can be 
  categorized as new or improved parameterizations from the perspective of CLM3.  The 
  other may be categorized as fixing an algorithmically defective existing parameterization
  (correction to snowage calculation so that snowage increases monotonically) 
  (Dickinson et al. 2006).

  See:

  http://www.cgd.ucar.edu/tss/clm/distribution/clm3.5/

  for more information, and for technical and scientific papers that describe CLM3.5.

  Lastly, we are distributing a new forcing dataset with the new code.  This
  dataset was derived by combining observation-based analyses of monthly precipitation and
  surface air temperature with intramonthly variations from the NCEP/NCAR reanalysis 
  (Qian et al., 2006)

  If you would like to run CLM-CN, please contact Peter Thornton (thornton@ucar.edu).
  If you would like to run CLM-DGVM, please contact Sam Levis (slevis@ucar.edu).
  If you would like to run CLM-CASA', please contact Forrest Hoffman (hof@ornl.gov).

Describe any bug fixes:

  o A revision of RTM-subcycling and corrections to a few land-locked grid cells.
  o A more efficient soil evaporation calculation based on PFT demand.
  o A fix to aggregation of LAI from high-resolution source data to CLM surface data.
  o Changing Temperature of freezing of water from 273.16 (triple point of water) to 273.15.

Summarize any software engineering improvements:

  o Add option to run CLM at a finer resolution than the atmospheric model coupled to
     (Tony Craig and others)
  o MCT (Model Coupling Toolkit) used to describe decompositions and do redistributions.
  o Remove dependences on CAM modules and data structures.
  o Use csm_share clocks and CCSMInit objects for simulation time information and
    initialization information needed by all CCSM models.
  o Update time-management to ESMF_2_2_2r interfaces and use the WRF implementation of
    ESMF time-management modules.
  o Made restart datasets double precision NetCDF rather than binary 
    (except history restarts).
  o Add interface layers to link to Sequential CCSM (formally standalone CAM) using MCT.
  o Parallelize RTM, by Tony Craig and Pat Worley.
  o Add a new testing suite to do automated testing for any code changes.
  o Improve memory scaling with a new decomposition from Tony Craig.
  o Move make surface dataset capability to an offline tool (mksurfdata).
  o Add an offline tool to create grid datasets needed for initialization (mkgriddata).
  o Add ability to run concurrent CCSM in single-executable mode.
  o Running with SCAM (Single Column Atmospheric Model) mode modularized better.

Versions of any externally defined libraries: (under src/utils)

  o csm_share:        share3_070321 (add flds, eshr and dshr directories, 
                                     add shr_inputinfo_mod, eshr_timemgr_mod, 
                                     other modules for shared data work)
  o esmf_wrf_timemgr: esmf_wrf_timemgr_060616 (or can link to full ESMF_2_2_2r)
  o timing:           timing_070328 (extensive updates and utilize PAPI and new namelist)
  o mct:              MCT2_3_0_070206 (allow to build with code, Cray mods, misc.)

Describe any changes made to build system: 

  o A configure script was created to create files needed to build the model. 
  o There are also cshell run scripts for different platforms to: 
       configure, build and run the model.
  o Remove SPMD CPP token -- use src/utils/mct/mpi-serial library for serial mode.
  o Remove HIDE_MPI token.
  o Remove CAM and COUP_CAM CPP tokens -- replace with SEQ_MCT and SEQ_ESMF.
  o Remove NOCOMPETE CPP token.
  o Most SCAM #ifdef's removed.
  o Remove TIMING_BARRIERS CPP token -- add option to prof_inparm namelist.
  o See src/utils/timing for new tokens added for timing library 
     (HAVE_PAPI, THREADED_OMP, DIAG, HASH).
  o MCT included with offline CLM.

Describe any changes made to the namelist:

  Main namelist name changed from clmexp to clm_inparm

  Option to run clm at a finer mesh than the atmosphere added several namelist items.

  flndtopo        = 256 character land topography file name
  fatmgrid        = 256 character atmosphere grid data file name
  fatmlndfrc      = 256 character landfrac (on atm grid) file name
  fatmtopo        = 256 character atmosphere topography file name

  Decomposition/performance control:

  nsegspc         = Number of segments per clump for new decomp. 
                    1 will produce poor loadbalance, infinity yields too many
                    segments per pe but good load balance. (default 20)

  All mksrf_* options moved to the mksurfdata offline tool. So instead of
  creating surface datasets by running clm -- you run the mksurfdata tool
  to create them.

  mksrf_* = Removed from namelist.

  Miscellaneous:

  rest_flag            = logical, turns restart file writing on (default .true.)
  wrtdia               = true if want output written  (default .false.)
  create_crop_landunit = true => separate crop landunit is not created by default
                         (currently broken see KnownBugs) (default .false.)

  New prof_inparm namelist added for timing library.

   profile_single_file  = Write timing output to single file or file per task 
                          (default single)
   profile_disable      = Turn timing off. (default .false.)
   profile_barrier      = Turn MPI barriers on in t_barrierf calls. (default .false.)
   profile_depth_limit  = Integer indicating maximum number of levels of timer nesting 
                          (default 99999)
   profile_detail_limit = integer indicating maximum detail level to profile (default 0)
   profile_timer        = integer indicating which timer to use
      GPTLwall           = 1
      GPTLcpu            = 2
      GPTLabort_on_error = 3
      GPTLoverhead       = 4
      GPTLdepthlimit     = 5
      GPTLgettimeofday   = 6
      GPTLnanotime       = 7
      GPTLrtc            = 8
      GPTLmpiwtime       = 9
      GPTLclockgettime   = 10
      GPTLpapitime       = 11
      (default is 9, except on UNICOSMP where it is 8)

List any changes to the defaults for the boundary datasets:

 Use following files for T42 resolution:

 finidat        = '$CSMDATA/inidata_3.1/offline/clmi_0000-01-01_064x128_c070403.nc'
 fsurdat        = '$CSMDATA/surfdata/surfdata_64x128_c070501.nc'
 fatmgrid       = '$CSMDATA/griddata/griddata_64x128_060829.nc'
 fatmlndfrc     = '$CSMDATA/griddata/fracdata_64x128_USGS_070110.nc'
 fpftcon        = '$CSMDATA/pftdata/pft-physiology.c070207'
 offline_atmdir = '$CSMDATA/NCEPDATA.Qian.T62.c051024'
 frivinp_rtm    = '$CSMDATA/rtmdata/rdirc.05.061026'

Code reviewed by: 
   bonan, dlawren, erik, mvertens, nanr, oleson, pworley, slevis, tcraig, thornton

Summary of testing: Other than bugs documented in KnownBugs works on following machines:

   bluevista.ucar.edu ---- IBM/SP running AIX
   blueice.ucar.edu ------ IBM/SP running AIX
   bangkok.cgd.ucar.edu -- Linux cluster (both PGI and Lahey compilers)

  MSS location of control simulations used to validate new climate:

	OFFLINE: /OLESON/csm/hydp2_off_communn_hk44
        CAM/CLM: /OLESON/csm/hydp2_communn_hk44a
        CCSM:    /CCSM/csm/b31.020ws
   
  URL for LMWG diagnostics output used to validate new climate:

OFFLINE:
http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk44a-hyd_off_con3d/setsIndex.html

CAM/CLM:
http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_communn_hk44aa-hyd_sstb/setsIndex.html

CCSM:
http://www.cgd.ucar.edu/tss/clm/diagnostics/ccsm2_prod/b31.020wsb-b31.002b/setsIndex.html

===============================================================
===============================================================
Tag name:  clm3_4_2
Originator(s):  erik (Erik Kluzek)
Date: Wed May  2 15:09:41 MDT 2007
Date:One-line Summary: Use new surfdatasets, add new tests, fix newcprnc makefile, fix bugs, and documentation, add script to query XML file 

Purpose of changes: Bug-fixes in preparation of clm3_5_00

        Use new surface datasets created by Nan R.
        Add new sets of regression tests
	Fix so that newcprnc will work on pathscale
        Fix so that newcprnc can be tested
        Fix so that PGI mode can be tested on bangkok
        Fix so that run-pc script runs for both lahey and pgi
        Fix some documentation
        Add script to query the Namelist XML file

Bugs fixed (include bugzilla ID): 461, 463, 468

Describe any changes made to build system: None

Describe any changes made to the namelist: surface datasets updated

List any changes to the defaults for the boundary datasets: surface datasets updated

Describe any substantial timing or memory changes: None

Code reviewed by: self, had nanr review query script

List any svn externals directories updated (csm_share, mct, etc.): None

List all subroutines eliminated: Remove convert_ascii as no longer needed
   (Can use earlier CLM versions if needed in the future)

List all subroutines added and what they do:

---------> Add a set of regression tests that will do almost all tests in the list
A test/system/tests_posttag_hybrid_regression
A test/system/tests_posttag_purempi_regression
---------> Add a script to query the contents to the DefaultCLM_INPARM_Namelist.xml file
---------> to ensure it is read correctly. Also can be used to copy files as well.
A bld/queryDefaultNamelist.pl
---------> Add files so that newcprnc uses the standard tools Makefile and can be tested by
---------> test_driver.sh
A tools/newcprnc/misc.h
A tools/newcprnc/Filepath
A tools/newcprnc/newcprnc.runoptions
A tools/newcprnc/preproc.h
A tools/newcprnc/cprnc.F90
A tools/newcprnc/Srcfiles

List all existing files that have been modified, and describe the changes:

M test/system/nl_files/t31_cnall
M test/system/nl_files/t31_dgvm
M test/system/nl_files/1.9x2.5
M test/system/nl_files/10x15_cnall
M test/system/nl_files/10x15_dgvm
M test/system/nl_files/t31_casa
M test/system/nl_files/10x15_pftdyn
M test/system/nl_files/t31_dgvm_long
M test/system/nl_files/t31
M test/system/nl_files/10x15
M test/system/input_tests_master
M test/system/README
M test/system/tests_pretag_bangkok
M test/system/test_driver.sh
M test/system/tests_pretag_tempest
M tools/newcprnc/Makefile ----> Use standard tools Makefile
---------> Update datasets get right surface dataset, get working on bangkok
M bld/run-pc.csh
M bld/DefaultCLM_INPARM_Namelist.xml
M bld/run-lightning.csh
M bld/run-ibm.csh
M bld/run-frost.csh
---------> Add an update date option
M doc/UpDateChangeLog.pl
---------> Fix minor problems in documenation
M src/biogeochem/DGVMMod.F90
M src/main/initializeMod.F90
M src/main/scam_setlatlonidx.F90
M src/main/program_off.F90
M src/main/surfrdMod.F90

Summary of testing:

All standard tests PASS (10x15, and 1.9x2.5 tests are different because of new surfdata files)*

  bluevista: All tests PASS except
  For regression tests the following fail because of changes in surfdata sets
054 bl551 TBL.sh _dh 10x15 48 .....................................FAIL! rc= 7
058 bl563 TBL.sh _h 1.9x2.5 -10 ...................................FAIL! rc= 7
062 bl552 TBL.sh _ds 10x15 24 .....................................FAIL! rc= 7
082 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 4

  blueice: All tests PASS except
  For regression tests the following fail because of changes in surfdata sets
054 bl551 TBL.sh _dh 10x15 48 .....................................FAIL! rc= 7
058 bl563 TBL.sh _h 1.9x2.5 -10 ...................................FAIL! rc= 7
062 bl552 TBL.sh _ds 10x15 24 .....................................FAIL! rc= 7
082 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 4

  For regression tests the following fail because of changes in surfdata sets

054 bl551 TBL.sh _dh 10x15 48 .....................................FAIL! rc= 7
058 bl563 TBL.sh _h 1.9x2.5 -10 ...................................FAIL! rc= 7
062 bl552 TBL.sh _ds 10x15 24 .....................................FAIL! rc= 7
082 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 4

  lightning: All PASS except (because of earlier reported bug 444)

019 sm551 TSM.sh _dh 10x15 48 .....................................FAIL! rc= 8
020 er551 TER.sh _dh 10x15 10+38 ..................................FAIL! rc= 5
021 br551 TBR.sh _dh 10x15 24+24 ..................................FAIL! rc= 5

  jaguar: Build of first test works (need datasets to do more testing)
  robin/phoenix: Build of all standard tests work (need datasets to do more testing)
  bangkok: All standard tests PASS*

PGI testing:

011 sm132 TSM.sh 4p_vodsr_dm t42half 48 ...........................FAIL! rc= 8
012 er132 TER.sh 4p_vodsr_dm t42half 10+38 ........................FAIL! rc= 5
013 br132 TBR.sh 4p_vodsr_dm t42half 24+24 ........................FAIL! rc= 5
014 bl132 TBL.sh 4p_vodsr_dm t42half 48 ...........................FAIL! rc= 4
015 sm135 TSM.sh 4p_vodsr_m t42half 48 ............................FAIL! rc= 8
022 er212 TER.sh 17p_cnn_dm t31_cnall 10+38 .......................FAIL! rc= 9
038 sm471 TSM.sh 10p_dgvm_s singlept_dgvm_long -730 ...............FAIL! rc= 8
039 er471 TER.sh 10p_dgvm_s singlept_dgvm_long -334+-396 ..........FAIL! rc= 5
040 bl471 TBL.sh 10p_dgvm_s singlept_dgvm_long -730 ...............FAIL! rc= 4
046 er564 TER.sh _m 1.9x2.5 -5+-5 .................................FAIL! rc= 9
060 bl711 TBLtools.sh mksurfdata namelist .........................FAIL! rc= 7
062 bl771 TBLtools.sh mksurfdata singlept .........................FAIL! rc= 7
063 sm811 TSMtools.sh interpinic runoptions .......................FAIL! rc= 6
068 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 4

Test 046 and 022 restart testis fail because restart IC file was NOT in the right place
Tests 038-040 "singlept_dgvm_long" test fails because needs more input NCEPDATA
Test 063 interpinic FAIL's because file using does NOT exist on bangkok

Lahey testing:

011 sm132 TSM.sh 4p_vodsr_dm t42half 48 ...........................FAIL! rc= 8
012 er132 TER.sh 4p_vodsr_dm t42half 10+38 ........................FAIL! rc= 5
013 br132 TBR.sh 4p_vodsr_dm t42half 24+24 ........................FAIL! rc= 5
014 bl132 TBL.sh 4p_vodsr_dm t42half 48 ...........................FAIL! rc= 4
015 sm135 TSM.sh 4p_vodsr_m t42half 48 ............................FAIL! rc= 8
022 er212 TER.sh 17p_cnn_dm t31_cnall 10+38 .......................FAIL! rc= 11
023 br212 TBR.sh 17p_cnn_dm t31_cnall 24+24 .......................FAIL! rc= 11
029 bl312 TBL.sh 4p_casa_dm t31_casa 48 ...........................FAIL! rc= 7
034 bl412 TBL.sh 10p_dgvm_dm t31_dgvm 48 ..........................FAIL! rc= 7
044 bl552 TBL.sh _ds 10x15 24 .....................................FAIL! rc= 7
048 bl564 TBL.sh _m 1.9x2.5 -10 ...................................FAIL! rc= 7
063 sm811 TSMtools.sh interpinic runoptions .......................FAIL! rc= 6
066 sm982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 4
067 bl982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 2
068 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 4

Test 022 (CN restart test) fails -- because answers are different! (Documented as bug 469)
TBL tests fail because of change in surfdata files
Tests 038-040 "singlept_dgvm_long" test fails because needs more input NCEPDATA
Test 063 interpinic FAIL's because file using does NOT exist on bangkok
Tests 067-068 fail because of a variable defined in CAM is not initialized.

  tempest: All standard tests PASS*

  CCSM tests FAIL because we currently don't have a version of CCSM that will work with 
  this version of CLM (because of the timing library updates and incomptabilities).
  run scripts work on bluevista and bangkok (for Lahey and PGI)

===============================================================
===============================================================
Tag name:  clm3_4_1
Originator(s):  erik (KLUZEK ERIK 1326 CGD)
Date: Mon Apr 30 14:18:46 MDT 2007
One-line Summary: Add documentation to code from Keith Oleson, and set keywords on files so Version will be given

Purpose of changes: Add documentation to code and set keywords on files that keep track of versions on output NetCDF files

Bugs fixed (include bugzilla ID): 453, 458

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: self

List any svn externals directories updated (csm_share, mct, etc.): None

List all subroutines eliminated: None

List all subroutines added and what they do:

A         DefaultCLM_INPARM_Namelist.xml   ! Add XML file that CAM will use to reference what datasets to point to

	This file will later be used by both CCSM and CLM

List all existing files that have been modified, and describe the changes:

M      test/system/TER.sh
M      test/system/TSM.sh

 ----------------> Remove files with RCS keywords, and activate keywords for files that use them
M      src/main/abortutils.F90
MM     src/main/histFileMod.F90
MM     src/main/restFileMod.F90
M      src/main/scam_setlatlonidx.F90
M      src/main/decompMod.F90
M      tools/mkgriddata/creategridMod.F90
M      tools/mksurfdata/mkfileMod.F90
M      tools/mksurfdata/mksurfdata.namelist
M      tools/mksurfdata/mksurfdata.regional
M      tools/mksurfdata/mksurfdata.singlept
M      tools/interpinic/interpinic.F90
M      tools/interpinic/addglobal.F90
M      tools/interpinic/clmi_1999-01-02_10x15_c070330.nc   ! Put descriptive data on file

 ----------------> Add documentation to code from Keith Oleson
M      src/main/iniTimeConst.F90
M      src/main/clmtype.F90
M      src/main/histFldsMod.F90
M      src/main/mkarbinitMod.F90
M      src/biogeophys/BalanceCheckMod.F90
M      src/biogeophys/SoilTemperatureMod.F90
M      src/biogeophys/Biogeophysics1Mod.F90
M      src/biogeophys/Hydrology1Mod.F90
M      src/biogeophys/Hydrology2Mod.F90
M      src/biogeophys/SoilHydrologyMod.F90
M      src/biogeophys/BareGroundFluxesMod.F90
M      src/biogeophys/CanopyFluxesMod.F90

Summary of testing:

  bluevista:
062 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 7
  lightning: All PASS except
019 sm551 TSM.sh _dh 10x15 48 .....................................FAIL! rc= 8
020 er551 TER.sh _dh 10x15 10+38 ..................................FAIL! rc= 5
021 br551 TBR.sh _dh 10x15 24+24 ..................................FAIL! rc= 5
  bangkok/lf95:
033 sm982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 4

===============================================================
===============================================================
Tag name:  clm3_expa_99
Originator(s):  erik (KLUZEK ERIK 1326 CGD)
Date:  Tue Apr 24 13:27:10 MDT 2007
One-line Summary: Update to mklai02_clm3_expa_98, mklai changes, dust changes, TKFRZ fix from Keith O., fix CASA

Purpose of changes: Answer changing code changes moved onto the clm trunk: 
    mklai changes for mksurfdata -- reviewed by Sam L., and Nan R. extensively
    changes for DUST mode from Natalie M. and Francis V.
    TKFRZ fix from Keith O.
    Fix CASA' from problem Sam L. found with a suggested fix by Inez Fung

Bugs fixed (include bugzilla ID): 389 (partial), 442, 443, 445, 450

Describe any changes made to build system: Fix build for jaguar and phoenix

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: nanr, slevis, dlawren, oleson, and bonan reviewed the mklai changes

List any svn externals directories updated (csm_share, mct, etc.): None

List all subroutines eliminated: None

List all subroutines added and what they do: Documentation files

A  +   doc/README.DGVM
A  +   doc/KnownBugs

List all existing files that have been modified, and describe the changes:

---------------------> Improve testing
M      test/system/nl_files/t31_cnall
M      test/system/nl_files/singlept_dgvm_long
M      test/system/nl_files/1.9x2.5
M      test/system/nl_files/t31_dgvm
M      test/system/nl_files/singlept
M      test/system/nl_files/10x15_cnall
M      test/system/nl_files/10x15_dgvm
M      test/system/nl_files/t31_casa
M      test/system/nl_files/regional
M      test/system/nl_files/10x15_pftdyn
M      test/system/nl_files/t31_dgvm_long
M      test/system/nl_files/t42half
M      test/system/nl_files/t31
M      test/system/nl_files/10x15
M      test/system/tests_posttag_robin
M      test/system/input_tests_master
M      test/system/tests_pretag_jaguar
M      test/system/tests_posttag_phoenix
M      test/system/test_driver.sh
M      test/system/TSCscam.sh

---------------------> Change calculation of LAI,SAI,Canopy-top/bottom so weighted by %-PFT
M      tools/mksurfdata/mkfmax.F90
M      tools/mksurfdata/mklaiMod.F90
M      tools/mksurfdata/mkglacier.F90
M      tools/mksurfdata/mkurban.F90
M      tools/mksurfdata/mksoitex.F90
M      tools/mksurfdata/areaMod.F90
M      tools/mksurfdata/mksrfdat.F90
M      tools/mksurfdata/Srcfiles
M      tools/mksurfdata/mksoicol.F90
M      tools/mksurfdata/mkpftMod.F90

---------------------> Use new default files at T42, add and correct documentation
M      bld/run-pc.csh
M      bld/run-lightning.csh
M      bld/Makefile.in
M      bld/run-ibm.csh
M      bld/config_clm_defaults.xml
M      bld/system_defaults.xml
M      bld/run-frost.csh

---------------------> Remove uneeded shr_sys_flush, put #ifndef UNICOSMP around shr_sys_flush(6), correct MCT vector calls
                       needed for phoenix/robin build.

M      src/biogeochem/CNCStateUpdate2Mod.F90
M      src/biogeochem/CNGapMortalityMod.F90
M      src/biogeochem/CNC13StateUpdate2Mod.F90
M      src/biogeochem/CNFireMod.F90
M      src/biogeochem/CASAMod.F90 -------------------> Fix CASA by uncommenting lines according to Inez Fung
M      src/biogeochem/CNPrecisionControlMod.F90
M      src/biogeochem/DUSTMod.F90 -------------------> Changes from Natalie M. and Francis Vitt for CAM/CLM3.5 Aerosols
M      src/biogeochem/CNPhenologyMod.F90
M      src/biogeochem/CNCStateUpdate1Mod.F90
M      src/biogeochem/CNDecompMod.F90
M      src/biogeochem/CNCStateUpdate3Mod.F90
M      src/biogeochem/CNC13StateUpdate1Mod.F90
M      src/biogeochem/CNC13StateUpdate3Mod.F90
M      src/biogeochem/CNAllocationMod.F90
M      src/biogeochem/CNC13FluxMod.F90
M      src/biogeochem/CNEcosystemDynMod.F90
M      src/biogeochem/CNVegStructUpdateMod.F90
M      src/main/inicFileMod.F90
M      src/main/abortutils.F90
M      src/main/driver.F90
M      src/main/ncdio.F90
M      src/main/atmdrvMod.F90 -----------------------> Changes from Keith O. to fix TKFRZ change
M      src/main/initializeMod.F90
M      src/main/clmtypeInitMod.F90
M      src/main/histFileMod.F90
M      src/main/clm_csmMod.F90
M      src/main/controlMod.F90 ----------------------> Fix #ifdef's so extra namelist items only on for COUP_CSM or OFFLINE
M      src/main/initSurfAlbMod.F90
M      src/main/clm_time_manager.F90
M      src/main/initGridCellsMod.F90
M      src/main/program_off.F90
M      src/main/surfrdMod.F90
M      src/main/decompMod.F90
M      src/main/areaMod.F90
M      src/main/clm_mct_mod.F90
M      src/riverroute/RtmMod.F90
M      src/biogeophys/SurfaceRadiationMod.F90
M      src/biogeophys/SurfaceAlbedoMod.F90
M      src/biogeophys/Hydrology2Mod.F90
M      src/biogeophys/CanopyFluxesMod.F90

Summary of testing:

  bluevista: All PASS except
004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................FAIL! rc=
009 bl127 TBL.sh 17p_vodsr_dh t31 48 ..............................FAIL! rc=
014 bl131 TBL.sh 4p_vodsr_dh t42half 48 ...........................FAIL! rc=
019 bl141 TBL.sh 17p__dh 10x15_pftdyn 48 ..........................FAIL! rc=
024 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................FAIL! rc=
028 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................FAIL! rc=
032 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................FAIL! rc=
037 bl471 TBL.sh 10p_dgvm_s singlept_dgvm_long -730 ...............FAIL! rc=
041 bl563 TBL.sh _h 1.9x2.5 -10 ...................................FAIL! rc=
045 bl552 TBL.sh _ds 10x15 24 .....................................FAIL! rc=
049 bl573 TBL.sh _s singlept -10 ..................................FAIL! rc=
053 bl583 TBL.sh _dh regional -10 .................................FAIL! rc=
057 bl711 TBLtools.sh mksurfdata namelist .........................FAIL! rc=
059 bl771 TBLtools.sh mksurfdata singlept .........................FAIL! rc=
062 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 7
  lightning: All PASS except
004 bl112 TBL.sh 4p_vodsr_dm t31 48 ...............................FAIL! rc=
009 bl142 TBL.sh 17p__dm 10x15_pftdyn 48 ..........................FAIL! rc=
014 bl252 TBL.sh 17p_cnn_dm 10x15_cnall 48 ........................FAIL! rc=
018 bl451 TBL.sh 10p_dgvm_dm 10x15_dgvm 48 ........................FAIL! rc=
019 sm551 TSM.sh _dh 10x15 48 .....................................FAIL! rc= 8
020 er551 TER.sh _dh 10x15 10+38 ..................................FAIL! rc= 5
021 br551 TBR.sh _dh 10x15 24+24 ..................................FAIL! rc= 5
022 bl551 TBL.sh _dh 10x15 48 .....................................FAIL! rc=
026 bl573 TBL.sh _s singlept -10 ..................................FAIL! rc=
029 bl771 TBLtools.sh mksurfdata singlept .........................FAIL! rc=
  bangkok/lf95:
004 bl112 TBL.sh 4p_vodsr_dm t31 48 ...............................FAIL! rc=
009 bl142 TBL.sh 17p__dm 10x15_pftdyn 48 ..........................FAIL! rc=
014 bl252 TBL.sh 17p_cnn_dm 10x15_cnall 48 ........................FAIL! rc=
018 bl312 TBL.sh 4p_casa_dm t31_casa 48 ...........................FAIL! rc=
022 bl451 TBL.sh 10p_dgvm_dm 10x15_dgvm 48 ........................FAIL! rc=
026 bl551 TBL.sh _dh 10x15 48 .....................................FAIL! rc=
030 bl573 TBL.sh _s singlept -10 ..................................FAIL! rc=
033 sm982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 4
  robin: All compile tests pass

CLM tag used for the baseline comparison tests if applicable: clm3_expa_98

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers:
    - what code configurations: All
    - what platforms/compilers: All
    - nature of change: new LAI, TKFRZ change is roundoff different, Dust and CASA changes are significant

===============================================================
===============================================================
Tag name:  clm3_expa_98
Originator(s):  erik (KLUZEK ERIK 1326 CGD)
Date:  Wed Apr 18 09:51:53 MDT 2007
One-line Summary: Move externals to top, make SOM4 the default, rename setidx file, use new datafiles, 
    remove NUMLONS read, tweak testing, remove shell_cmd, remove read of old surfdata file

Purpose of changes: Some simple cleanup preparing for CLM3.5 release

Bugs fixed (include bugzilla ID): 440, 441

Describe any changes made to build system: None

Describe any changes made to the namelist: Use new datasets

List any changes to the defaults for the boundary datasets: Use new NCEP forcing datasets,
  and new Nitrogen deposition datasets

Describe any substantial timing or memory changes: None

Code reviewed by: self

List any svn externals directories updated (csm_share, mct, etc.):

	Directories are the same -- but SVN externals themselves moved to top level

List all subroutines eliminated:

D      test/system/tests_pretag_blueice > Rename to posttag filename
D      bld/empty -----------------------> Rename to usr.src
D      src/main/setlatlonidx.F90 -------> Rename to scam_setlatlonidx.F90 filename
D      src/main/system_cmd.c
D      src/main/cfort.h
D      src/SVN_EXTERNAL_DIRECTORIES ----> Move to top layer

List all subroutines added and what they do:

  -------------------> Files renamed from above
A  +   test/system/tests_posttag_blueice
A  +   bld/usr.src
A  +   SVN_EXTERNAL_DIRECTORIES
A  +   src/main/scam_setlatlonidx.F90

  -------------------> New files
A      test/system/config_files/10p_dgvm_s -------> New DGVM test
A  +   test/system/tests_posttag_blueice ---------> Rename
A      test/system/tests_posttag_robin -----------> Add tests for robin/phoenix
A      test/system/tests_posttag_phoenix
A      test/system/nl_files/singlept_dgvm_long ---> Add new singlept DGVM test
  -------------------> Add new documentation README files
A      tools/README
A      bld/README
A      Copyright ----> CCSM Copyright file
A      README

List all existing files that have been modified, and describe the changes:

  -------------------> Tweak testing -- use new datasets, increase diversity of testing
M      test/system/tests_pretag_bluevista
M      test/system/nl_files/t31_cnall
M      test/system/nl_files/1.9x2.5
M      test/system/nl_files/t31_dgvm
M      test/system/nl_files/singlept
M      test/system/nl_files/10x15_cnall
M      test/system/nl_files/10x15_dgvm
M      test/system/nl_files/t31_casa
M      test/system/nl_files/regional
M      test/system/nl_files/10x15_pftdyn
M      test/system/nl_files/t31_dgvm_long
M      test/system/nl_files/t42half
M      test/system/nl_files/t31
M      test/system/nl_files/10x15
M      test/system/input_tests_master
M      test/system/test_driver.sh
   ---------------------> Remove system_cmd.c from list of source files needed to compile
M      tools/mksurfdata/Srcfiles
M      tools/interpinic/interpinic.F90 <--- fix interpinic compile on bluevista
M      tools/mkgriddata/Srcfiles
   ---------------------> Use new datasets, make sure works
M      bld/run-pc.csh
M      bld/configure ---- Remove SOM4 CPP declaration
M      bld/run-lightning.csh
M      bld/run-ibm.csh
M      bld/run-frost.csh
   ---------------------> Make SOM4 the default remove other option, remove read of NUMLON
   ---------------------> Remove read of old surfdata sets, remove shell_cmd
M      src/biogeochem/CNDecompMod.F90
M      src/biogeochem/STATICEcosysDynMod.F90
M      src/main/ncdio.F90
M      src/main/fileutils.F90 -----> Remove shell_cmd as unused now.
M      src/main/iniTimeConst.F90
M      src/main/clm_varsur.F90
M      src/main/surfrdMod.F90

Summary of testing:

  bluevista:    All PASS, except
062 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 7
  bangkok/lf95: All PASS
  tempest:      All PASS, except
033 sm982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 4

CLM tag used for the baseline comparison tests if applicable: clm3_expa_97

===============================================================
===============================================================
Tag name:  clm3_expa_97
Originator(s):  erik (KLUZEK ERIK 1326 CGD)
Date:  Wed Apr 11 12:18:32 MDT 2007
One-line Summary: Remove SPMD, update to clm proc tag, update timing, improve testing

Purpose of changes:
     Remove SPMD #ifdefs -- use mpi-serial code
     Remove COUP_CAM #ifdefs for SEQ_MCT || SEQ_ESMF
     Remove LOCAL_DEBUG CPP #ifdefs
     Update to prof05_clm3_expa_92 tag (timing changes, SCAM fixes)
     Update timing library to latest
     Fix bugs
     Improve test suite
     Change scripts so will rebuild each time (only configure first time if config file DNE)
     Change tool Makefile to be consistent and have USER_ overload options.
     Add script to update ChangeLog

Bugs fixed (include bugzilla ID):  337, 361, 389(partial), 407, 408, 417, 428
     337 -- SPMD
     361 -- IRIX
     389 -- Testing
     407 -- Single gridcell
     408 -- mksurfdata,mkgriddata compiling
     417 -- write last file to mss correctly
     428 -- pdt-dyn mode now restarts correctly

Describe any changes made to build system: Remove HIDE_MPI, remove 
     stuff left over from CAM Makefile, put FORTRAN name definition in configure
     remove LOCAL_DEBUG CPP #ifdefs

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: mvertens, oleson, thornton (all just briefly)

List any svn externals directories updated (csm_share, mct, etc.):
        Update csm_share to share3_070321
        Update timing    to timing_070328

List all subroutines eliminated:

D      bld/run-sgi.csh --------------------> Remove SGI run script
D      test/system/tests_pretag_bluesky ---> Remove since bluesky is gone
D      tools/mksurfdata/mksrfdat.namelist -> Change name to mksurfdata.namelist

   -------> Rename interpinic files to *.F90

D      tools/interpinic/fmain.f90
D      tools/interpinic/wrap_nf.f90
D      tools/interpinic/shr_kind_mod.f90
D      tools/interpinic/interpinic.f90
D      tools/interpinic/addglobal.f90

   --------> Remove file no longer needed by SCAM or for SPMD mode
D      src/main/getnetcdfdata.F90
D      src/main/mpiinc.F90


List all subroutines added and what they do:

------- Add concurrent and sequential CCSM tests, add more resolutions, improve tools tests
A      test/system/TSMconccsm.sh   ----------- Concurrent CCSM test
--------------------> New configurations to test
A      test/system/config_files/scam_ds
A      test/system/config_files/_h
A      test/system/config_files/_dh
A      test/system/config_files/_m
A      test/system/config_files/_o
A      test/system/config_files/_dm
A      test/system/config_files/_do
A      test/system/config_files/_s
A      test/system/config_files/_ds
A      test/system/config_files/seqccsm_4x5_dh
A      test/system/config_files/seqccsm_64x128_s
A      test/system/config_files/seqccsm_10x15_dm
A      test/system/config_files/17p__m
A      test/system/config_files/17p__o
A      test/system/config_files/17p__dh
A      test/system/config_files/17p__dm
A      test/system/config_files/17p__do
A      test/system/config_files/17p__h
A      test/system/TSMseqccsm.sh ------------- Sequential CCSM test
--------------------> New namelists and resolutions to test
A      test/system/nl_files/scam
A      test/system/nl_files/1.9x2.5
A      test/system/nl_files/singlept
A      test/system/nl_files/10x15_cnall
A      test/system/nl_files/10x15_dgvm
A      test/system/nl_files/seqccsm
A      test/system/nl_files/regional
A      test/system/nl_files/scam_prep
A      test/system/nl_files/10x15
A      test/system/README
A      test/system/TCBseqccsm.sh --------> Sequential CCSM configure/build
A      test/system/TSCscam.sh -----------> Sequential CCSM SCAM mode configure/build
A      test/system/TCTconccsm.sh --------> CCSM create-test
A      test/system/TBLtools.sh ----------> Compare tools to baseline version

----------- add singlept and regional tests
A      tools/mksurfdata/mksurfdata.singlept
A      tools/mksurfdata/mksurfdata.regional
A  +   tools/mksurfdata/mksurfdata.namelist

----------- Get improved code from Sam Levis (change names to *.F90)

A      tools/interpinic/interpinic.runoptions
A  +   tools/interpinic/fmain.F90
A      tools/interpinic/clmi_1999-01-02_10x15_c070330.nc <---- Test file
A  +   tools/interpinic/wrap_nf.F90
A      tools/interpinic/Filepath
A  +   tools/interpinic/interpinic.F90
A  +   tools/interpinic/addglobal.F90
A      tools/interpinic/Srcfiles
----------- add singlept and regional tests
A      tools/mkgriddata/mkgriddata.singlept
A      tools/mkgriddata/mkgriddata.regional

----------- Help to update ChangeLog
A      doc/UpDateChangeLog.pl

----------- New code needed for SCAM mode
A  +   src/main/setlatlonidx.F90


List all existing files that have been modified, and describe the changes:

----------- Improve test system (tweak tests, add new tests to various machines)
M      test/system/tests_pretag_bluevista
M      test/system/nl_files/t31_cnall
M      test/system/nl_files/t31_dgvm
M      test/system/nl_files/t31_casa
M      test/system/nl_files/10x15_pftdyn
M      test/system/nl_files/t31_dgvm_long
M      test/system/nl_files/t42half
M      test/system/nl_files/t31
M      test/system/CLM_runcmnd.sh ------- Use mpirun instead of mpiexec on bangkok/calgary
M      test/system/tests_pretag_blueice
M      test/system/input_tests_master
M      test/system/tests_pretag_jaguar
M      test/system/TSMtools.sh
M      test/system/tests_pretag_bangkok
M      test/system/TCBtools.sh
M      test/system/test_driver.sh
M      test/system/tests_pretag_tempest
M      test/system/tests_posttag_lightning

----------- Get tools to build
M      tools/mksurfdata/mklaiMod.F90
M      tools/mksurfdata/mkfileMod.F90
M      tools/mksurfdata/creategridMod.F90
M      tools/mksurfdata/Srcfiles
M      tools/mksurfdata/Makefile ------ Make makefile consistent and add USER_ options
M      tools/interpinic/Makefile ------ Make makefile consistent and add USER_ options
M      tools/mkgriddata/mkgriddata.F90
M      tools/mkgriddata/creategridMod.F90
M      tools/mkgriddata/Srcfiles
M      tools/mkgriddata/Makefile ------ Make makefile consistent and add USER_ options

----------- Improvements to run scripts and build system
     Change scripts so will rebuild each time (only configure first time if config file DNE), remove left over
     features from CAM Makefile.
M      bld/run-pc.csh
M      bld/configure
M      bld/run-lightning.csh
M      bld/Makefile.in
M      bld/run-ibm.csh
M      bld/run-frost.csh

----------- Source code changes, removing SPMD #ifdef, LOCAL_DEBUG, get SCAM mode working with new CAM, change
            to work with new timing library, fix code bugs above.  Remove COUP_CAM #ifdefs for SEQ_MCT || SEQ_ESMF
M      src/biogeochem/CASAMod.F90
M      src/biogeochem/CNPhenologyMod.F90
M      src/biogeochem/STATICEcosysDynMod.F90
M      src/biogeochem/DGVMMod.F90
M      src/biogeochem/CNAllocationMod.F90
M      src/biogeochem/CNVegStructUpdateMod.F90
M      src/main/spmdGathScatMod.F90
M      src/main/abortutils.F90
M      src/main/clm_comp.F90
M      src/main/driver.F90
M      src/main/ncdio.F90
M      src/main/atmdrvMod.F90
M      src/main/fileutils.F90
M      src/main/pftdynMod.F90
M      src/main/iniTimeConst.F90
M      src/main/histFileMod.F90
M      src/main/program_csm.F90
M      src/main/restFileMod.F90
M      src/main/clm_csmMod.F90
M      src/main/controlMod.F90
M      src/main/ndepFileMod.F90
M      src/main/initGridCellsMod.F90
M      src/main/lnd_comp_mct.F90
M      src/main/program_off.F90
M      src/main/pftvarcon.F90
M      src/main/spmdMod.F90
M      src/main/surfrdMod.F90
M      src/main/decompMod.F90
M      src/main/areaMod.F90
M      src/main/iobinary.F90
M      src/main/do_close_dispose.F90
M      src/riverroute/RtmMod.F90
M      src/biogeophys/Hydrology2Mod.F90
M      src/biogeophys/BiogeophysRestMod.F90

Summary of testing:

  tempest: ALL PASS
  bluevista:
019 bl141 TBL.sh 17p_vodsr_dh 10x15_pftdyn 48 .....................FAIL! rc= 7
022 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................FAIL! rc= 6
059 sm061 TSMconccsm.sh ERS f19_g13 ...............................FAIL! rc= 5
  bangkok/lf95:
033 sm982 TSCscam.sh seqccsm_64x128_s scam_prep scam_ds scam 7 ....FAIL! rc= 4

TBL test fails because of restart trouble with pftdyn.
Concurrent CCSM test fails because of a problem with ccsm3_5_beta01 for datm7.
bangkok scam test fails as is says that scm_crm_mode is not initialized in
CAM code.

CLM tag used for the baseline comparison tests if applicable: clm3_expa_96
 (had to add in new tests, and set SOM4)

Changes Answers: No

===============================================================

===============================================================
Tag name: clm3_expa_96
Originator(s): tcraig
Date: Mon Mar 12 16:41:58 MDT 2007
One-line Summary: fixed finemesh, pftdyn modes, add new tests

Purpose of changes: restore finemesh and pftdyn modes, improve
	test coverage

Bugs fixed (include bugzilla ID): 389 (partial)

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: reduced memory use in pftdyn

Code reviewed by:

List any svn externals directories updated (csm_share, mct, etc.): none

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

        M      test/system/tests_pretag_bluevista
	A  +   test/system/nl_files/10x15_pftdyn
	A  +   test/system/nl_files/t31_dgvm_long
	A  +   test/system/nl_files/t42half
	M      test/system/input_tests_master
	M      test/system/tests_pretag_blueice
	M      test/system/tests_pretag_jaguar
	M      test/system/tests_pretag_bangkok
	M      test/system/test_driver.sh
	M      test/system/tests_posttag_lightning
	M      src/main/subgridMod.F90
	M      src/main/initializeMod.F90
	M      src/main/pftdynMod.F90
	M      src/main/clm_varsur.F90
	M      src/main/ndepFileMod.F90
	M      src/main/subgridAveMod.F90
	M      src/main/initGridCellsMod.F90
	M      src/main/lnd_comp_mct.F90
	M      src/main/program_off.F90
	M      src/main/surfrdMod.F90
	M      src/main/domainMod.F90
	M      src/main/decompMod.F90
	M      src/main/areaMod.F90

- rename lvegxy,lwtxy to vegxy, wtxy
- implement general setgatm, get finemesh working again
- refactor pftdynMod for low memory implementation, validate pfydyn mode
- modify ndep and pftdyn from x = x1*wt1 + x2*wt2 to x = x2 + wt1*(x1-x2)
  as suggested by k.lindsay, improves roundoff performance
- clean up some old code
- add new tests configurations (10x15_pftdyn, t31_dgvm_long, t42half), 
- update pretag lists, add new tests
		
Summary of testing: 

  bluevista:
	     all clm tests pass except bl for new cases including new tests 
	     all cam tests pass except bl (due to clm changes in expa_94/95)
	     ccsm passes ERS.f45_g35.B.bluevista16 (answers change due to expa_94/95)
  bangkok/lf95: 
	     all clm tests pass including new tests in list
	     all cam tests pass except bl (due to clm changes in expa_94/95)
  tempest:
	     all cam tests pass except bl (due to clm changes in expa_94/95)
  lightning: 
	     ccsm passes ERS.f45_g35.B2.lightning (answers change due to expa_94/95)

CLM tag used for the baseline comparison tests if applicable:
	clm3_expa_95, cam3_4_03, ccsm3_1_beta45

IF tag changes answers relative to baseline comparison the
following should be filled in:
	answers are bfb with clm3_expa_95 in clm.  cam and ccsm could not
	be tested for bfb due to lagging clm version in latest cam and ccsm tags

  Summarize any changes to answers, i.e.,
    - what code configurations: 
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
Tag name: clm3_expa_95
Originator(s): nanr, Keith Oleson, Peter Thornton
Date: Thu Mar  8 17:06:06 MST 2007
One-line Summary: Adding N limitation for CLM standalone w/o CN.

Purpose of changes: Improve estimation of photosynthesis in CLM when it
is run without CN active.  These changes impose a N limitation as a fcn of
PFT [0-1].

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: testing suites: fpftcon = pft-physiology.c070207

List any changes to the defaults for the boundary datasets: 
	fptfcon = pft-physiology.c070207
		  pft-physiology.c070207.readme

Describe any substantial timing or memory changes: none expected

Code reviewed by: Keith Oleson, Peter Thornton, Dave Lawrence

List any svn externals directories updated (csm_share, mct, etc.):  none
  
List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

bv1103en.ucar.edu-/fis/cgd/tss/nanr/clm/clm3_trunk % !svn
svn status | grep 'M '
M      test/system/nl_files/t31_cnall	! change pft-physiology.c070207
M      test/system/nl_files/t31_dgvm	! change pft-physiology.c070207
M      test/system/nl_files/t31		! change pft-physiology.c070207
M      test/system/nl_files/t31_casa	! change pft-physiology.c070207
M      bld/run-pc.csh			! change pft-physiology.c070207
M      bld/run-sgi.csh			! change pft-physiology.c070207
M      bld/run-lightning.csh		! change pft-physiology.c070207
M      bld/run-ibm.csh			! change pft-physiology.c070207
M      bld/run-frost.csh		! change pft-physiology.c070207
M      src/main/clmtypeInitMod.F90		! initialize new N limitation factor (fnitr)
M      src/main/iniTimeConst.F90		! initialize new N limitation factor (fnitr)
M      src/main/pftvarcon.F90			! read in new var (fnitr)
M      src/main/clmtype.F90			! initialize new N limitation factor (fnitr)
M      src/biogeophys/CanopyFluxesMod.F90	! apply new N limitation factor (fnitr)

Summary of testing:  

  bluevista:
	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................PASS
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................PASS
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................PASS
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................PASS
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................PASS
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable:

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:	  CN inactive
    - what platforms/compilers:	  all
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	new climate

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

  MSS location of control simulations used to validate new climate:

	/OLESON/csm/hydp2_off_communn_hk39
   
   URL for LMWG diagnostics output used to validate new climate:

http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk39aa-hydp2_off_communn_hk38aa/setsIndex.html


	
===============================================================
===============================================================
Tag name: clm3_expa_94
Originator(s): nanr, Keith Oleson, Peter Thornton
Date: 	Thu Mar  8 14:22:36 MST 2007
One-line Summary:  BTRAN modification

Purpose of changes:  Change BTRAN calculation to improve prognostic
	LAI estimation in high latitudes.

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: Keith Oleson, Peter Thornton, Dave Lawrence

List any svn externals directories updated (csm_share, mct, etc.): nanr

List all subroutines eliminated: nanr

List all subroutines added and what they do: nanr

List all existing files that have been modified, and describe the changes:
M      src/biogeophys/CanopyFluxesMod.F90

Changing calculation of rootr to allow non-zero rootr (and btran) in partially frozen layers.

Summary of testing:

  bluevista:

	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................PASS
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................PASS
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................PASS
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................PASS
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................PASS
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable: none

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: all
    - what platforms/compilers: all
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

	-larger than roundoff.  Climate changes unknown.
	-Improves prognostic LAI estimation in high latitudes.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository): clm3_expa_89
   - platform/compilers:  bluevista
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
	/OLESON/csm/hydp2_off_communn_hk38
   
   URL for LMWG diagnostics output used to validate new climate:

http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk38aa-hydp2_off_communn_expa89aa/setsIndex.html

	
===============================================================

===============================================================
Tag name: clm3_expa_93		! NOTE: Tag incremented to correct mistaken tag number in documentation. (nanr)
Originator(s): tcraig
Date: Tue Feb 27 16:53:41 MST 2007	
One-line Summary: merge fmf branch to trunk (low memory mods)

Purpose of changes: reduce memory and improve memory scaling

Bugs fixed (include bugzilla ID):

Describe any changes made to build system: began adding support
  for frost in Makefile and added a run-frost.csh (not yet
  fully validated)

Describe any changes made to the namelist: added new optional namelist
  input, nsegspc (number of segments per clump for new decomp.  default
  is 20, 1 will produce poor loadbalance, infinity yields too many
  segments per pe but good load balance.  performance asymptotes for
  several configurations at about 5-10 segments/pe, use 20 as default.)

List any changes to the defaults for the boundary datasets: NONE

Describe any substantial timing or memory changes: significant reduction
  in memory use and improved memory scaling.

Code reviewed by:

List any svn externals directories updated (csm_share, mct, etc.): update
  to mct external, MCT2_3_0_070206

List all subroutines eliminated:

List all subroutines added and what they do:

List all existing files that have been modified, and describe the changes:

- implement new 1d decomp based on ngsegspc rather than balancing pfts,
  ngsegspc is the number of segments per clump.  the 1d gridcells will
  be divided into clumps and segments per clump so there will be
  a total number of segments, clumps*nsegspc, each of about equal number
  of gridcells, that will be distributed round-robin to pes.  pfts are
  derived later and will hopefully end up being nearly as well load
  balanced as the previous method without having to precompute pfts
  and requiring much less memory.  see above for more info on the namelist 
  input and default.
- reorganize initialization, split decomp_init into three phases,
  atm (coarse), lnd (finemesh), and glcp (subgrid).
- add new datatype, latlon to hold some global grid info
- now all domain info is local (although initialization still needs
  to be modified)
- remove some dead code
- add new timers (bug #302)
- split gatm out of domain type
- create simple setgatm_UNITY routine, finemesh capability now disabled,
  must fix setgatm in future version
- move wtxy, vegxy, and pctspec to clm_varsur, allocate as local arrays
  now (begg:endg) and modify surfrd to handle local data only both for
  I/O and initialization.
- implement gather/scatter routines in spmdGathScatMod that use gsmaps.
- update MCT and share
- port to frost
- get rid of some of the global decomps use in code, still more to do
- memory cleanup in STATICEcosysDynMod
- implement new ncdio methods for reading to local gridcell data using gsmaps
- clean up atmdrv, use newer low mem datatypes, reduce memory
- clean up rtm, use newer low mem datatypes, reduce memory
- remove history "lat/lon" fields

M      test/system/test_driver.sh
M      tools/mkgriddata/mkgriddata.F90
M      bld/configure
M      bld/Makefile.in
A  +   bld/run-frost.csh
M      src/biogeochem/CASAMod.F90
M      src/biogeochem/STATICEcosysDynMod.F90
M      src/biogeochem/DGVMMod.F90
M      src/main/spmdGathScatMod.F90
M      src/main/abortutils.F90
M      src/main/clm_comp.F90
M      src/main/driver.F90
M      src/main/ncdio.F90
M      src/main/atmdrvMod.F90
M      src/main/subgridMod.F90
M      src/main/initializeMod.F90
M      src/main/pftdynMod.F90
M      src/main/iniTimeConst.F90
M      src/main/histFileMod.F90
M      src/main/program_csm.F90
M      src/main/clm_atmlnd.F90
M      src/main/clm_varsur.F90
M      src/main/clm_csmMod.F90
M      src/main/restFileMod.F90
M      src/main/controlMod.F90
M      src/main/clm_varctl.F90
M      src/main/ndepFileMod.F90
M      src/main/initGridCellsMod.F90
M      src/main/lnd_comp_mct.F90
M      src/main/program_off.F90
M      src/main/surfrdMod.F90
M      src/main/domainMod.F90
M      src/main/decompMod.F90
M      src/main/areaMod.F90
M      src/main/clm_mct_mod.F90
M      src/SVN_EXTERNAL_DIRECTORIES
M      src/riverroute/RtmMod.F90
	
Summary of testing:

  bluevista: all pass except
    004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................FAIL! rc= 7
    009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................FAIL! rc= 7
  bangkok/lf95: all pass except
    004 bl112 TBL.sh 4p_vodsr_dm t31 48 ...............................FAIL! rc= 7
    009 bl122 TBL.sh 17p_vodsr_dm t31 48 ..............................FAIL! rc= 7
  Due to roundoff change in rtm, only rtm fields affected, otherwise bfb

  Also tested version in CCSM vs ccsm3_1_beta45
    ERS.f45_g35.B.bluevista16
    ERS.f45_g35.B2.lightning
    Both PASS and bfb versus beta45 except for rtm roundoff difference and
      associated error growth through ocean coupling

  Also tested mods merged to clm3_expa_91 with cam3_4_00, all
    CAM tests pass on bangkok, bluevista, and tempest including scam.
  Tested on bangkok with cam3_4_01 and updated to clm3_expa_92, all
    CAM tests pass on bangkok.  bluevista and tempest not tested
    due to time constraints and earlier adequate testing with 
    clm3_expa_91 and cam3_4_00.
	
CLM tag used for the baseline comparison tests if applicable: clm3_expa_89

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: anything with RTM on
    - what platforms/compilers: all 
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
        roundoff change in RTM due to roundoff change in cell area calculation

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?  tested in multiple systems, review growth of diffs in 
     stand-alone clm, only rtm fields affected, diffs remain roundoff for
     48 timesteps, no coupling to other fields or error growth in system.

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================


===============================================================
Tag name: clm3_expa_92
Originator(s): erik,mvertens,mvr
Date: Mon Feb 26 15:59:16 MST 2007
One-line Summary: When running with Sequential CCSM -- use date for albedo calculation

Purpose of changes: To work with cam3_4_01

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: erik,mvr,mvertens

List any svn externals directories updated (csm_share, mct, etc.): none

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M      src/main/clm_comp.F90
M      src/main/lnd_comp_mct.F90

Have sequential CCSM give CLM the date of the next radiation calculation so that
it can calculate albedo's for that specific time-step. This is needed to work with
cam3_4_01.

Summary of testing:

  bluevista: Pass
  bangkok/lf95: Pass

CLM tag used for the baseline comparison tests if applicable: clm3_expa_91

===============================================================
===============================================================
Tag name: clm3_expa_91
Originator(s): erik
Date: Wed Feb 21 13:19:51 MST 2007
One-line Summary: Fix SCAM mode, add more machines for test_driver, have tools use csm_share, 
	make clmtype private (except for data exporting), fix several bugs

Purpose of changes: Fix SCAM mode so can make a new CAM tag.

Bugs fixed (include bugzilla ID): 252, 310, 370, 377, 385 (partial -- 302, 357, 389)

Describe any changes made to build system: Remove -DNO_R16 from Makefile

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: MSS writes are now synchronous instead of
	asynchronous

Code reviewed by: slevis

List any externals updated: Update to csm_share3_070220

List all subroutines eliminated:

Remove makdep -- as MkDepends replaces it
Remove cprlndnc -- as newcprnc replaces it

D      tools/makdep
D      tools/makdep/main.c
D      tools/makdep/Makefile
D      tools/makdep/README
D      tools/cprlndnc
D      tools/cprlndnc/cprtps.F
D      tools/cprlndnc/lenchr.F
D      tools/cprlndnc/precision.F
D      tools/cprlndnc/printstats.F
D      tools/cprlndnc/wrap_nf.F
D      tools/cprlndnc/stats.F
D      tools/cprlndnc/ismax.F
D      tools/cprlndnc/initstats.F
D      tools/cprlndnc/nldat.F
D      tools/cprlndnc/cpr.F
D      tools/cprlndnc/prhddiff.F
D      tools/cprlndnc/header.F
D      tools/cprlndnc/Makefile
D      doc/BranchLog
D      doc/ChangeSum

Delete files that tools use that are copied from main src directories (so we don't have
to maintain separate copies of code)

D      Deleting       tools/mkgriddata/fileutils.F90
D      Deleting       tools/mkgriddata/nanMod.F90
D      Deleting       tools/mkgriddata/shr_const_mod.F90
D      Deleting       tools/mkgriddata/shr_kind_mod.F90
D      Deleting       tools/mkgriddata/shr_sys_mod.F90
D      Deleting       tools/mksurfdata/fileutils.F90
D      Deleting       tools/mksurfdata/nanMod.F90
D      Deleting       tools/mksurfdata/shr_const_mod.F90
D      Deleting       tools/mksurfdata/shr_kind_mod.F90
D      Deleting       tools/mksurfdata/shr_sys_mod.F90
D      Deleting       tools/mksurfdata/shr_timer_mod.F90

List all subroutines added and what they do:

A      test/system/TSMtools.sh -- for testing of the tools (not tested yet)
A      test/system/TCBtools.sh -- for build testing of the tools (not tested yet)
A      test/system/tests_pretag_blueice -- for running on blueice (does work)
A      test/system/tests_pretag_jaguar -- for running on jaguar (doesn't work yet)
A      test/system/tests_posttag_lightning -- for running on lightning (doesn't work yet)

Files added so that tools build uses copies of files in main directories rather than separate copies

A      tools/mkgriddata/Filepath
A      tools/mkgriddata/Srcfiles
A      tools/mkgriddata/misc.h
A      tools/mkgriddata/preproc.h
A      tools/mksurfdata/Filepath
A      tools/mksurfdata/Srcfiles
A      tools/mksurfdata/misc.h
A      tools/mksurfdata/preproc.h

List all existing files that have been modified, and describe the changes:

Add check for soil energy balance:

M      src/biogeophys/BalanceCheckMod.F90

Bigint bug fix (don't copy over static fields with bigint values when copying a domain)

M      src/main/domainMod.F90

SCAM fixes (read datasets differently for SCAM)

M      src/main/surfrdMod.F90
M      src/main/ndepFileMod.F90
M      src/main/iniTimeConst.F90

Change so that tools use main copies of code rather than own particular copy:

M      tools/mkgriddata/Makefile
M      tools/mkgriddata/mkgriddata.namelist
M      tools/mksurfdata/Makefile
M      tools/mksurfdata/domainMod.F90

Make MSS write's synchronous instead of asynchronous: Required for LSF queing systems

M      src/main/fileutils.F90

Landmask bug fix: (landmask now output globally with no missing or fill values)

M      src/main/histFileMod.F90
M      src/main/initializeMod.F90
M      src/main/ncdio.F90

Timers

M      src/main/program_csm.F90
M      src/main/driver.F90

Make clmtype private -- so only exports it's data not data it uses.

M      src/biogeochem/CNGapMortalityMod.F90
M      src/biogeochem/VOCEmissionMod.F90
M      src/biogeochem/CNrestMod.F90
M      src/biogeochem/CNC13FluxMod.F90
M      src/biogeochem/CNSetValueMod.F90
M      src/main/atmdrvMod.F90
M      src/main/clmtypeInitMod.F90
M      src/main/pftdynMod.F90
M      src/main/restFileMod.F90
M      src/main/clmtype.F90
M      src/biogeophys/SnowHydrologyMod.F90
M      src/biogeophys/SurfaceAlbedoMod.F90
M      src/biogeophys/BiogeophysRestMod.F90
M      src/biogeophys/DriverInitMod.F90

Miscellaneous:

M      bld/Makefile.in  --- Remove NO_R16 CPP token, some changes to start work on jaguar
M      test/system/test_driver.sh -- add more machines
M      test/system/CLM_runcmnd.sh -- add more machines

Summary of testing:

  bluevista: 	All PASS -- except TBL tests because of csm_share shr_const_mod TKFRZ change
  bangkok/lf95: All PASS -- except TBL tests because of csm_share shr_const_mod TKFRZ change
  blueice: 	All PASS -- except TBL tests because of csm_share shr_const_mod TKFRZ change

CLM tag used for the baseline comparison tests if applicable: clm3_expa_90

  Summarize any changes to answers: larger than roundoff (all config/all machines)

  (No simulations were performed as CCSM scientists deemed the change to be
   insignificant)

===============================================================
===============================================================
Tag name:  clm3_expa_90
Originator(s):  nanr
Date:  Tue Feb  6 13:17:55 MST 2007
One-line Summary:  Changed creategridMod.F90 to read variables from 10min USGS file.

Purpose of changes:  
Added htopo and landfract to retrieve landfrac and topography for processing USGS-gtopo30_10min_c050419.nc

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by:  nanr

List all subroutines eliminated:  none

List all subroutines added and what they do:  none

List all existing files that have been modified, and describe the changes:

M      creategridMod.F90

   Added lines to creategridMod.F90 to read variables from USGS-gtopo30-10min_c050419.nc 

    ier = nf_inq_varid (ncid, 'landfract', varid)
    if (ier == NF_NOERR) then
       if (landfracset) write(6,*) trim(subname),' WARNING, overwriting frac'
       landfracset = .true.
       write(6,*) trim(subname),' read landfract'
       call check_ret(nf_inq_varid (ncid, 'landfract', varid), subname)
       call check_ret(nf_get_var_double (ncid, varid, domain%frac), subname)
    endif

    ier = nf_inq_varid (ncid, 'htopo', varid)
    if (ier == NF_NOERR) then
       if (toposet) write(6,*) trim(subname),' WARNING, overwriting topo'
       toposet = .true.
       write(6,*) trim(subname),' read htopo'
       call check_ret(nf_inq_varid (ncid, 'htopo', varid), subname)
       call check_ret(nf_get_var_double (ncid, varid, domain%topo), subname)
    endif


Summary of testing:  none. Affects tools/mkgriddata only.

  bluesky:
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable:

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate: 
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
===============================================================
Tag name: clm3_expa_89
Originator(s): erik,oleson
Date: Feb/02/2007
One-line Summary: 

Purpose of changes: Use new water table rise calculation in SoilHydrology

Bugs fixed (include bugzilla ID): 345, 353

Describe any changes made to build system: None (although added Darwin to mksrfdat build Makefile)

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: Keith Oleson

List all subroutines eliminated: None

Remove bld/offline directory tree

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

M      bld/Makefile.in ---- Add -DFORTRANUNDERSCORE so can compile mpi-serial on IRIX

Change run scripts so that spmd and smp settings work for both on AND off

M      bld/run-pc.csh ----------------------- Also add LD_LIBRARY_PATH setting
M      bld/run-sgi.csh
M      bld/run-lightning.csh

M      src/main/spmdMod.F90 ------------------ Remove #ifdef around #include <mpif.h> so will
	run serial (this is a partial fix to bug 337. The longer term fix is to remove all
	#ifdef SPMD as we can use the mpi-serial code to make the serial and SPMD code the same.

M      src/biogeophys/SoilHydrologyMod.F90 --- New drainage formulation from Keith Oleson

Summary of testing:

  bluesky: -- All but comparision to previous version
  tempest: -- All but comparison to previous version and the following restart tests
	(These tests fail on previous versions as well -- documented as bug 361)
002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................FAIL! rc= 11
003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
005 sm116 TSM.sh 4p_vodsr_o t31 48 ................................FAIL! rc= 4
007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................FAIL! rc= 11
008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................FAIL! rc= 11
013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................FAIL! rc= 11
017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................FAIL! rc= 11
021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	(We are going to remove tempest as a standard test for CLM)

  bangkok/lf95: -- All but comparision to previous version

CLM tag used for the baseline comparison tests if applicable: none

  Summarize any changes to answers, i.e.,
    - what code configurations: All
    - what platforms/compilers: All
    - nature of change (similar climate)

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers: Cray-XT3/jaguar
   - configuration (CPP ifdefs): default
   - build-namelist command (or complete namelist):
   - MSS location of output: /CCSM/csm/b31.020ws/lnd/hist

   URL for LMWG diagnostics output used to validate new climate: Not yet prepared
	
===============================================================
===============================================================
Tag name: clm3_expa_88
Originator(s): nanr
Date: Thu Jan 11 12:31:51 MST 2007
One-line Summary:  Minor formatting change in tools.
		   Correctons to ChangLog
		

Purpose of changes: 
1.	Update formatted write in tools/ mkgriddata.F90 and tools/mksrfdat.F90 
	to accomodate 4 digit lat/lons.
2.	Add note to ChangeLog to explain commit by nanr (10/27) that was not tagged.
3.	correct Changelog for tag clm3_expa_80.  The changes listed below never happened.
	surfFileMod.F90 was actually removed from the trunk in a previous tag (clm3_expa_66)
	and renamed surfrdMod.F90.  So this modification probably reflects the status of the branch 
	Keith Oleson was working on.
		M      src/main/surfFileMod.F90

		Removed statements contained within CN ifdef (OK'd by P. Thornton) that:

		! the following test prevents the assignment of temperate deciduous
                  		! vegetation types in the tropics
                  		! 1. broadleaf deciduous temperate tree -> broadleaf deciduous tropical tree
                  		! 2. broadleaf deciduous temperate shrub -> broadleaf deciduous tropical tree
                  		! this reassignment from shrub to tree is necessary because there is currently no
                  		! tropical deciduous broadleaf shrub type defined.


Bugs fixed (include bugzilla ID):  none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: nanr

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M      tools/mksurfdata/mksrfdat.F90
M      tools/mkgriddata/mkgriddata.F90
	
   Changed formatting strings to accomodate 4 char lat/lons.
	OLD:  write (resol,'(i3.3,"x",i3.3)') lsmlat,lsmlon
	NEW:  write (resol,'(i4.4,"x",i4.4)') lsmlat,lsmlon

Summary of testing:  none.  Changes only to tools and ChangeLog

  bluesky:
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable: none

IF tag changes answers relative to baseline comparison the
following should be filled in: none

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate: NA
   
   URL for LMWG diagnostics output used to validate new climate: NA
	
===============================================================
===============================================================
Tag name: clm3_expa_87
Originator(s): tcraig, jet
Date: Wed Dec 27 05:03:01 GMT 2006
One-line Summary: merge fme branch, merge refactor_scam branch

Purpose of changes: bug fixes, reduce memory usage, improve memory scaling,
	add mct package, update scam

Bugs fixed (include bugzilla ID): 
	#133 adomain,ldomain compare
	#290 time bounds problem in history file
	#291 fix rtm history bug on bangkok
	#301 modify decomp info in i/o
	#321 merge refactor_scam branch

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: memory reduce, amount TBD

Code reviewed by: tcraig

List all subroutines eliminated: many routines in areaMod removed
	rename seq_mct_mod.F90 to clm_mct_mod.F90
	add getnetcdfdata.F90

List all subroutines added and what they do: added MCT package and interpolation
	routines that use MCT mapping datatypes

List all existing files that have been modified, and describe the changes:

         test/system/TBL.sh
	 test/system/TBR.sh
	 test/system/test_driver.sh
	 test/system/TER.sh
	 bld/offline/mkSrcfiles
	 bld/offline/tests/CLM_namelist.pm
	 bld/offline/tests/compare.csh
	 bld/offline/tests/config_machine_specs.csh
	 bld/offline/tests/CLM_lab.pm
	 bld/offline/tests/CLM_test.pm
	 bld/offline/tests/CLM.pm
	 bld/offline/tests/test-model.pl
	 bld/offline/tests/model_specs.csh
	 bld/offline/tests/CLM_run.pm
	 bld/offline/tests/test_batch.csh
	 bld/offline/tests/Makefile
	 bld/offline/tests/configure.csh
         bld/offline/tests/lab_default.pm
	 bld/offline/mkDepends
	 bld/offline/jobscript.csh
	 bld/offline/Makefile
         src/biogeochem/STATICEcosysDynMod.F90
         src/SVN_EXTERNAL_DIRECTORIES
	 src/main/inicFileMod.F90
	 src/main/driver.F90
	 src/main/ncdio.F90
	 src/main/atmdrvMod.F90
	 src/main/initializeMod.F90
	 src/main/iniTimeConst.F90
	 src/main/histFileMod.F90
	 src/main/clm_atmlnd.F90
	 src/main/clm_csmMod.F90
	 src/main/restFileMod.F90
	 src/main/controlMod.F90
	 src/main/clm_varctl.F90
	 src/main/getnetcdfdata.F90
	 src/main/lnd_comp_mct.F90
	 src/main/program_off.F90
	 src/main/spmdMod.F90
	 src/main/surfrdMod.F90
	 src/main/domainMod.F90
	 src/main/decompMod.F90
	 src/main/areaMod.F90
	 src/main/iobinary.F90
	 src/main/clmtype.F90
	 src/main/clm_mct_mod.F90
	 src/riverroute/RtmMod.F90
	 src/riverroute/RunoffMod.F90

  fix minor bug in TBL, TBR, TER reporting non bfb errors
  include mods from john truesdale for refactor_scam branch
  add MCT package to utils and SVN_EXTERNALS
  add mpicom to smpdMod.F90 default for mct
  add map_setmapAR to areaMod.F90
  refactor clm mapping datatypes and subroutines in general
  remove 9 of 15 global arrays from decomp type
  add MCT datatypes and mapping to atmdrv and rtm
	
Summary of testing:
  fme05_clm3_expa_78 vs clm3_expa_78, cam3_3_40, ccsm3_1_beta40
  (mods on top of clm3_expa_78)
    bluesky:   all clm pass except BL fail due to changes in atmdrv mapping
	       all cam pass
    tempest:   all cam pass
    bangkok:   all clm pass except BL fail due to changes in atmdrv mapping
    lightning: ccsm ERS.f45_g35.B2 bfb with ccsm3_1_beta40
    bluevista: ccsm ERS.f45_g35.B2 bfb with ccsm3_1_beta40
	       cam finemesh test is bfb

  fme06_clm3_expa_79 vs clm3_expa_79, cam3_3_44, ccsm3_1_beta40
  (merge in scam_refactor02_clm3_expa_79)
    bluesky:   all clm pass except BL fail due to changes in atmdrv mapping
	       clm *211 test fail (due to failures in clm3_expa_79)
	       all cam pass
    tempest:   all cam pass
    bangkok:   all cam pass
    lightning: ccsm ERS.f45_g35.B2 bfb with ccsm3_1_beta40
    bluevista: ccsm ERS.f45_g35.B2 bfb with ccsm3_1_beta40
	       cam finemesh test is bfb

  clm3_expa_87 == fme07_clm3_expa_86 vs clm3_expa_86, ccsm3_1_hydro01
  (merge in clm3_expa_86, cam testing not possible)
    bluesky:   all clm pass except BL fail due to changes in atmdrv mapping
    bangkok:   all clm pass except BL fail due to changes in atmdrv mapping
    bluevista: ccsm ERS.f19_g14.B2 bfb with ccsm3_1_beta40

CLM tag used for the baseline comparison tests if applicable: clm3_expa_86

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: all
    - what platforms/compilers: all
    - nature of change (roundoff; larger than roundoff/same climate; new climate): roundoff

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?
	roundoff differences introduced in rtm and atmdrv due to change in
	  interpolation order of operations.  verified this carefully during
	  development with print statements.
	also, with BL tests, history fields are typically different in only the 15th digit 
	  after several timesteps
	verified bfb in ccsm vs ccsm3_1_hydro01 tag (includes clm3_expa_86)
	all cam tests pass with fme mods bfb including BL

===============================================================
===============================================================
Tag name: clm3_expa_86
Originator(s): nanr
Date: Thu Dec  7 10:22:11 MST 2006
One-line Summary:  Correct FMAX calculation.

Purpose of changes:  Correction for iniTimeConst.F90, which incorrectly divides fmax by 100.
	fmax is already stored as unitless [0-1].

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by:  myself, Keith Oleson

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M      iniTimeConst.F9
   OLD:  wtfact(c) = gti(i,j)/100.
   NEW:  wtfact(c) = gti(i,j)

Summary of testing:

  bluesky:
	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

   Note, the branch tests failed only in the differences to the time_bounds variable
   upon branching - all other variables stayed the same. This has been reported as
   bug #290.

  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable:

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:	All
    - what platforms/compilers:	All
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	small changes in climate which are now more realistic.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:  
   
   URL for LMWG diagnostics output used to validate new climate:  
	
===============================================================
===============================================================
Tag name:  clm3_expa_85
Originator(s): nanr
Date: Fri Dec  1 11:46:26 MST 2006
One-line Summary: change in topsoil evaporation.

Purpose of changes:  Change in topsoil evaporation sums the contributions of qflx_evap_soi over
all pft, regardless of sign of the pft

Bugs fixed (include bugzilla ID): 264

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: Peter Thornton

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

        M      src/biogeophys/Biogeophysics2Mod.F90

1. (around line 297) Changed calculation of topsoil_evap_tot(c) to sum the contributions of qflx_evap_soi(p) over all PFTs, regardle
ss of the sign of the PFT-level flux term.  Previously, this summation was only done over the positive PFT-level evaporation fluxes
(excluded condensation terms).

2. Change (1) eliminates the need for rescaling the topsoil_evap_tot(c) using sumwt(c), so this code was removed (around line 308).
 Calculation of egirat(c) looks the same, but is now based on the modified topsoil_evap_tot(c), which includes both evaporation and
condensation terms.

3. Removed control on positive qflx_evap_soi(p) in block where PFT-level fluxes are being modified to avoid evaporation in excess of
 top-layer water.  Now both evaporation and condensation terms are scaled by egirat(c).

4. Removed calculation of evaprat(p)(around line 323).  Changed calculation of split between soil evaporation and ice sublimation to
 eliminate use of evaprat(p), instead using the ratio of liquid/(liquid+ice) in top layer to partition total evaporation loss into w
ater evaporation and ice sublimation (around line 354).

Summary of testing:

  bluesky:
	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable:  None

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:	All
    - what platforms/compilers:	All
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	new physics.  Same climate; larger than roundoff differences.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
===============================================================
Tag name: clm3_expa_84
Originator(s):  nanr
Date: Fri Dec  1 10:32:28 MST 2006
One-line Summary: Modify stomatal open/close values for ENF/DNF/EBF

Purpose of changes: Make stomatal open/close values consistent with White et al. (2000)
	update run script namelists to point to new physiology files.

Bugs fixed (include bugzilla ID): 
	Bug #265
	mksurfdata was missing the mkfmax.F90 file from clm3_expa_76, so I added mkfmax.F90
	Bug #300 - Uncorporated most of Keith Oleson's recommended changes to the run scripts

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: 

	A new pft physiology file is required: pft-physiology.c061129

Describe any substantial timing or memory changes: None

Code reviewed by: Keith Oleson

List all subroutines eliminated: None

List all subroutines added and what they do: 
	tools/mksurfdata/mkfmax.F90 	(documented in clm3_expa_76 but not added)
	/bld/empty			empty directory was added as template for run scripts (Bug 300)

List all existing files that have been modified, and describe the changes: None

M      test/system/nl_files/t31_cnall		! namelist change for new pft file
M      test/system/nl_files/t31_dgvm		! namelist change for new pft file
M      test/system/nl_files/t31			! namelist change for new pft file
M      test/system/nl_files/t31_casa		! namelist change for new pft file
A      tools/mksurfdata/mkfmax.F90		! adding fmax tool
M      bld/run-pc.csh				! namelist change for new pft file
M      bld/run-sgi.csh				! namelist change for new pft file
M      bld/run-lightning.csh			! namelist change for new pft file
M      bld/run-ibm.csh				! namelist change for new pft file
A      bld/empty				! empty directory for run script 

Summary of testing:  bluesky

	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

   Note, the branch tests failed only in the differences to the time_bounds variable
   upon branching - all other variables stayed the same. This has been reported as
   bug #290.

CLM tag used for the baseline comparison tests if applicable: None

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: all
    - what platforms/compilers: all
    - nature of change (roundoff; larger than roundoff/same climate; new climate): small changes in climate 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository): clm3_expa_60 was the baseline tag, 
      the testing source was:
      /home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk30
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/main
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeophys
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeochem
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/riverroute
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/csm_share/shr
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/timing
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/esmf_wrf_timemgr
   - platform/compilers: bluesky
   - configuration (CPP ifdefs): 
      #define SPMD
      #define OFFLINE
      #define LSMLON       128
      #define LSMLAT       64
      #define MAXPATCH_PFT 4
      #define RTM
      #undef  DUST
      #undef  VOC
      #undef  DGVM
      #undef  CN
      #undef  SUPLN
   - build-namelist command (or complete namelist):

 &clmexp
 caseid         = 'hydp2_off_communn_hk30'
 ctitle         = 'offline run with clm3_expa_60, same as hydp2_off_communn_hk26 but with new smpso and smpsc values for DNF,ENF,EBF'
 finidat        = ' '
 fsurdat        = '/fis/cgd/tss/oleson/plawren_datasets3/surfdata_064x128_hydro_060426.nc'
 fatmlndfrc     = '$CSMDATA/griddata/fracdata_64x128_gx1v3_060401.nc'
 fpftcon        = '/home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk30/pft-physiology.c061129'
 frivinp_rtm    = '$CSMDATA/rtmdata/rdirc.05'
 offline_atmdir = '/cgd/tss/oleson/ncepdata.tqian'
 nsrest         =  0
 nelapse        =  -6570
 dtime          =  1200
 start_ymd      =  19480101
 start_tod      =  0
 irad           = -1
 wrtdia         = .true.
 mss_irt        =  1095
 hist_dov2xy    = .true.
 hist_nhtfrq    =  0
 hist_mfilt     =  1
 hist_crtinic   = 'YEARLY'
 /

   - MSS location of output:
        mss:/OLESON/csm/hydp2_off_communn_hk30

   URL for LMWG diagnostics output used to validate new climate:

	http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk30aa-hydp2_off_communn_hk26aa/setsIndex.html

===============================================================
Tag name: clm3_expa_83
Originator(s): nanr
Date:  Tue Nov 28 13:45:11 MST 2006
One-line Summary:  Fix snow age bug.

Purpose of changes: Snow age (which affects snow albedo) is currently reset to zero 
at each time step if there are less than five snow layers.  Snow age should only be 
reset to zero if there are no snow layers.  This fix lowers surface albedo, 
resulting in faster snow ablation in some regions.  

Bugs fixed (include bugzilla ID):  281

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by:  Keith Oleson

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

  M Hydrology2Mod.F90

  Set snowage to zero only if there are no snow layers.

Summary of testing:

  bluesky:
	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

  NOTE:  the branch tests failed only in the differences to the time_bounds variable
         upon branching - all other variables stayed the same. This has been reported as
         bug #290.

  tempest:  Needs to be tested.
  bangkok/lf95:  Needs to be tested.

CLM tag used for the baseline comparison tests if applicable: None

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:  All
    - what platforms/compilers:  All
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	small change in climate in regions with snow.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
      the testing source was:
      /home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk19
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/main
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeophys
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeochem
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/riverroute
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/csm_share/shr
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/timing
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/esmf_wrf_timemgr
   - platform/compilers: bluesky
   - configuration (CPP ifdefs):
      #define SPMD
      #define OFFLINE
      #define LSMLON       128
      #define LSMLAT       64
      #define MAXPATCH_PFT 4
      #define RTM
      #undef  DUST
      #undef  VOC
      #undef  DGVM
      #undef  CN
      #undef  SUPLN
   - build-namelist command (or complete namelist):
 	&clmexp
 	caseid         = 'hydp2_off_communn_hk19'
 	ctitle         = 'offline run with clm3_expa_60, same as hydp2_off_con but with version 3 of P. Lawrence sfc dataset and new community hydrology with soil ice and recharge fix,hkdepth=2.5,gridcell fmax,WT fix,ws fix,Sellers rsoil,rsoil dew fix,snowage fix'
 	finidat        = ' '
 	fsurdat        = '/fis/cgd/tss/oleson/plawren_datasets3/surfdata_064x128_hydro_060426.nc'
 	fatmlndfrc     = '$CSMDATA/griddata/fracdata_64x128_gx1v3_060401.nc'
 	fpftcon        = '/home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_commun/pft-physiology.c060426'
 	frivinp_rtm    = '$CSMDATA/rtmdata/rdirc.05'
 	offline_atmdir = '/ptmp/oleson/qian_atm2'
 	nsrest         =  1
 	nelapse        =  -7300
 	dtime          =  1200
 	start_ymd      =  19790101
 	start_tod      =  0
 	irad           = -1
 	wrtdia         = .true.
 	mss_irt        =  1095
 	hist_dov2xy    = .true.
 	hist_nhtfrq    =  0
 	hist_mfilt     =  1
 	hist_crtinic   = 'YEARLY'

    MSS location of control simulations used to validate new climate:

       mss:/OLESON/csm/hydp2_off_communn_hk19

    URL for LMWG diagnostics output used to validate new climate:

 	http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk19a-hydp2_off_communn_hk15a/setsIndex.html
===============================================================
Tag name: clm3_expa_82
Originator(s): nanr	
Date: Mon Nov 27 21:51:23 MST 2006
One-line Summary:  Fix water balance error

Purpose of changes: Fix water balance error in calculation of btran.  In certain situations not enough
water was being drawn out of the soil according to the calculated transpiration.  

Bugs fixed (include bugzilla ID): 263

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none.

Code reviewed by: Keith Oleson, Dave Lawrence

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M	CanopyFluxesMod.F90 

   OLD: real(r8), parameter :: btran0 = 1.0e-10_r8  ! initial value
   NEW: real(r8), parameter :: btran0 = 0.0_r8  ! initial value

   do j = 1,nlevsoi
      do f = 1, fn
         p = filterp(f)
         if (btran(p) .gt. btran0) then
           rootr(p,j) = rootr(p,j)/btran(p)
         else				! NEW
           rootr(p,j) = 0._r8		! NEW
         end if				
      end do
   end do

Summary of testing: test_driver.sh

  bluesky:
	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

  NOTE:  the branch tests failed only in the differences to the time_bounds variable
         upon branching - all other variables stayed the same. This has been reported as
         bug #290.

  tempest:  Needs to be tested.
  bangkok/lf95:  Needs to be tested.

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:	All
    - what platforms/compilers: All
    - nature of change (roundoff; larger than roundoff/same climate; new climate): roundoff

	Keith Oleson ran a 20-year global offline simulation and didn't get a single water balance error warning. 
	The annual mean min and max ERRH2O for the new simulation is -3.75e-13 and
	6.7e-14.  Previously it was -4.15e-15 and 1.28e-7.

   MSS location of control simulations used to validate new climate:

	/OLESON/csm/hydp2_off_communn_hk20

   URL for LMWG diagnostics output used to validate new climate:

	http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk20a-hydp2_off_communn_hk16d/setsIndex.html
	The hk20 simulation is the one with the fix.

	
===============================================================
===============================================================
Tag name: clm3_expa_81
Originator(s): nanr	
Date: Mon Nov 27 19:56:25 MST 2006
One-line Summary:  Changes to water table calculations for frozen soil 

Purpose of changes: Improve water table calculations for frozen soil.  
Correct typo in Pat Worley's timing code.  Correct run-ibm.csh script.

Bugs fixed (include bugzilla ID): 304, 303 

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by:  Keith Oleson, David Lawrence

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

M      bld/run-ibm.csh

	OLD:  set clmroot   = /fis/cgd/tss/nanr/clm/hydro/clm_trunk.061107
	NEW:  set clmroot   = /fis/cgd/.......

	OLD:  fpftcon        = '$CSMDATA/pftdata/pft-physiology-cn16.c040719'
	NEW:  fpftcon        = '$CSMDATA/pftdata/pft-physiology.c060426'

M      src/main/lnd_comp_mct.F90

	OLD:  call t_stopf ('sync_clm_run11') 
	NEW:  call t_stopf ('sync_clm_run1')

M      src/biogeophys/Hydrology2Mod.F90

Modify subroutine calls to SurfaceRunoff and Drainage to pass icefrac in/out

M      src/biogeophys/SoilHydrologyMod.F90

Modify subroutine arguments for SurfaceRunoff and Drainage to pass icefrac in/out.
Make surface runoff a function of ice content in soil layers. 
Make soil matric potential a function of liquid water content and effective porosity only.
Remove qcharge limit in "permafrost areas".

Summary of testing:

  bluesky: test_driver.sh

	tests of CCSM will use source code from:
	/fs/cgd/csm/collections/ccsm3_1_beta40
	see /fis/cgd/tss/nanr/clm/hydro/clm3_expa_80_nr/test/system/td.187162.log for more detailed output

	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

  NOTE:  the branch tests failed only in the differences to the time_bounds variable
         upon branching - all other variables stayed the same. This has been reported as
         bug #290.

  tempest: Needs to be tested
  bangkok/lf95:  Needs to be tested

  Summarize any changes to answers, i.e.,
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

	small changes in climate in some frozen soil regions, but mainly affects runoff.

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):  clm3_expa_60 was the baseline tag
   - testing source:
      /home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk26
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/main
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeophys
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeochem
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/riverroute
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/csm_share/shr
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/timing
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/esmf_wrf_timemgr
   - platform/compilers: bluesky
   - configuration (CPP ifdefs): 
      #define SPMD
      #define OFFLINE
      #define LSMLON       128
      #define LSMLAT       64
      #define MAXPATCH_PFT 4
      #define RTM
      #undef  DUST
      #undef  VOC
      #undef  DGVM
      #undef  CN
      #undef  SUPLN
   - build-namelist command (or complete namelist):

 &clmexp
 caseid         = 'hydp2_off_communn_hk26'
 ctitle         = 'offline run with clm3_expa_60, same as hydp2_off_con but with version 3 of P. Lawrence sfc dataset,new comm
unity hydrology,soil ice and recharge fix,hkdepth=2.5,gridcell fmax,WT fix,ws fix,Sellers rsoil,rsoil dew fix,s_node fix,my fr
ozen soil fixes,starts 1948'
 finidat        = ' '
 fsurdat        = '/fis/cgd/tss/oleson/plawren_datasets3/surfdata_064x128_hydro_060426.nc'
 fatmlndfrc     = '/fs/cgd/csm/inputdata/lnd/clm2/griddata/fracdata_64x128_gx1v3_060401.nc'
 fpftcon        = '/home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk23/pft-physiology.c060426'
 frivinp_rtm    = '/fs/cgd/csm/inputdata/lnd/clm2/rtmdata/rdirc.05'
 offline_atmdir = '/cgd/tss/oleson/ncepdata.tqian'
 nsrest         =  1
 nelapse        =  -6570
 dtime          =  1200
 start_ymd      =  19480101
 start_tod      =  0
 irad           = -1
 wrtdia         = .true.
 mss_irt        =  1095
 hist_dov2xy    = .true.
 hist_nhtfrq    =  0
 hist_mfilt     =  1
 hist_crtinic   = 'YEARLY'
 /

   MSS location of control simulations used to validate new climate:

   	mss:/OLESON/csm/hydp2_off_communn_hk26
  
   URL for LMWG diagnostics output used to validate new climate:

	http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk26d-obs/setsIndex.html
	
===============================================================
===============================================================
Tag name: clm3_expa_80
Originator(s): nanr
Date:  Thu Nov 16 13:38:09 MST 2006
One-line Summary:  Merge Keith Oleson's Hydrology changes to the clm trunk.

Purpose of changes:  New hydrology for CLM

Bugs fixed (include bugzilla ID): Bug #249

Describe any changes made to build system:  None

Describe any changes made to the namelist:

  This tag requires a new variable 'fmax' found in new surface datasets.  
  Code is not backward compatible.

  fsurdat, fatmgrid, and fatmlndfrc are t31 only.  We need to produce
  new datasets at other resolutions.

  OLD Namelist:
   fsurdat        = '$CSMDATA/surfdata/surfdata_48x96_060404.nc'
   fatmgrid       = '$CSMDATA/griddata/griddata_48x96_060404.nc'
   fatmlndfrc     = '$CSMDATA/griddata/fracdata_48x96_gx1v3_060404.nc'
   fpftcon        = '$CSMDATA/pftdata/pft-physiology-cn16.c040719'
   frivinp_rtm    = '$CSMDATA/rtmdata/rdirc.05'

  NEW Namelist:
   fsurdat        = "$CSMDATA/surfdata/surfdata_048x096_061108.nc"
   fatmgrid       = "$CSMDATA/griddata/griddata_48x96_060829.nc"
   fatmlndfrc     = "$CSMDATA/griddata/fracdata_48x96_gx3v5_060829.nc"
   fpftcon        = "$CSMDATA/pftdata/pft-physiology.c060426"
   frivinp_rtm    = "$CSMDATA/rtmdata/rdirc.05.061026"

List any changes to the defaults for the boundary datasets:

  This tag requires a new variable 'fmax' found in new surface datasets.  
  Code is not backward compatible.

  OLD:
     Vegetation_type_raw_data_filename = "mksrf_pft.050425.nc" ;
     Soil_color_raw_data_file_name = "mksrf_soilcol.050425.nc" ;
     Inland_water_raw_data_file_name = "mksrf_lanwat.050425.nc" ;
     Glacier_raw_data_file_name = "mksrf_glacier.050425.nc" ;
     Urban_raw_data_file_name = "mksrf_urban.050425.nc" ;
     Lai_raw_data_file_name = "mksrf_lai.050425.nc" ;
  NEW:
     Vegetation_type_raw_data_filename = "mksrf_pft.060929.nc" ;
     Soil_color_raw_data_file_name = "mksrf_soilcol.060929.nc" ;
     Inland_water_raw_data_file_name = "mksrf_lanwat.060929.nc" ;
     Glacier_raw_data_file_name = "mksrf_glacier.060929.nc" ;
     Fmax_raw_data_file_name = "mksrf_fmax.061020.nc" ;
     Urban_raw_data_file_name = "mksrf_urban.060929.nc" ;
     Lai_raw_data_file_name = "mksrf_lai.060929.nc" ;

Describe any substantial timing or memory changes: Unknown; Needs to be tested.

Code reviewed by: myself (testing suite), David Lawrence, Keith Oleson

List all subroutines eliminated: None

List all subroutines added and what they do:

A      test/system/nl_files/t31_casa	! Addition to testing suite

List all existing files that have been modified, and describe the changes:

test suite mods:
M      test/system/input_tests_master
M      test/system/test_driver.sh
M      bld/run-ibm.csh
M      test/system/nl_files/t31_cnall
        1. pointing to new pft file, 
	2. starting at first day of the year.
Inputdataset Changes:
M      tools/mksurfdata/mksrfdat.namelist
	test suite mods
Hydrology mods: 

M      src/main/clm_varcon.F90

Removed CN ifdef for csoilc.

M      src/main/clmtypeInitMod.F90

Added allocation and initialization for two new pft-physiology variables and
several hydrology variables.
Removed smpmax.

M      src/main/iniTimeConst.F90

Read in new fmax surface dataset.
Initialize hkdepth (decay factor).

M      src/main/histFileMod.F90

Changed string from CLM2 to CLM3.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Start Revision:  
   ChangLog modified by nanr (1/11/07):  
   surfFileMod.F90 was removed from the trunk in clm3_expa_66 and renamed surfrdMod.F90.
   Therefore, these changes did not actually happen in the code base.

	M      src/main/surfFileMod.F90

	Removed statements contained within CN ifdef (OK'd by P. Thornton) that:

	! the following test prevents the assignment of temperate deciduous
                 ! vegetation types in the tropics
                 ! 1. broadleaf deciduous temperate tree -> broadleaf deciduous tropical tree
                 ! 2. broadleaf deciduous temperate shrub -> broadleaf deciduous tropical tree
                 ! this reassignment from shrub to tree is necessary because there is currently no
                 ! tropical deciduous broadleaf shrub type defined.

End Revision:   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

M      src/main/pftvarcon.F90

Added statements to take care of two new pft-physiology variables.

M      src/main/clmtype.F90

Added pointers for new pft-physiology variables and hydrology variables.

M      src/main/histFldsMod.F90

Added the following new hydrology fields:

      call add_fld1d (fname='FCOV',  units='unitless',  &
           avgflag='A', long_name='fractional area with water table at surface', &
           ptr_col=clm3%g%l%c%cws%fcov)
      call add_fld1d (fname='ZWT',  units='m',  &
           avgflag='A', long_name='water table depth', &
           ptr_col=clm3%g%l%c%cws%zwt)
      call add_fld1d (fname='WA',  units='mm',  &
           avgflag='A', long_name='water in the unconfined aquifer', &
           ptr_col=clm3%g%l%c%cws%wa)
      call add_fld1d (fname='WT',  units='mm',  &
           avgflag='A', long_name='total water storage (unsaturated soil water + groundwater)', &
           ptr_col=clm3%g%l%c%cws%wt)
      call add_fld1d (fname='QCHARGE',  units='mm/s',  &
           avgflag='A', long_name='aquifer recharge rate', &
           ptr_col=clm3%g%l%c%cws%qcharge)

M      src/main/mkarbinitMod.F90

Added arbitrary initialization for water table variables and changed soil water 
initialization from 0.3 to 0.4

M      src/biogeophys/BalanceCheckMod.F90

Added aquifer water to water balance check

M      src/biogeophys/SoilTemperatureMod.F90

Subroutine PhaseChange was changed to accomodate the presence of supercooled liquid water
in the soil at temperatures less than freezing. Also incorporates the concepth of 
fractional permeable area (Niu and Yang, 2006, J. Hydrometeorol., 7, 937-952).

M      src/biogeophys/Biogeophysics1Mod.F90

Added statements to set soilalpha as an output variable.

M      src/biogeophys/Biogeophysics2Mod.F90

Added index for landunit.

M      src/biogeophys/Hydrology2Mod.F90

Added aquifer water to ending water balance.
Added pointers to hydrology variables.
Added arguments to subroutines SurfaceRunoff and Drainage.

M      src/biogeophys/BiogeophysRestMod.F90

Added wa, wt, zwt to restart/initial file

M      src/biogeophys/SoilHydrologyMod.F90

Changes to subroutines SurfaceRunoff, SoilWater, and Drainage.  
New parameterizations are based on 
Niu et al., 2006, J. Geophys. Res., in press (Groundwater)
Niu et al., 2005, J. Geophys. Res., 110, doi:10.1029/2005JD006111 (Runoff)
Niu and Yang, 2006, J. Hydrometeorol., 7, 937-952 (Frozen soil)

M      src/biogeophys/HydrologyLakeMod.F90

Set hydrology variables to special value for lakes.

M      src/biogeophys/BareGroundFluxesMod.F90

Added soil resistance function for soil evaporation.

M      src/biogeophys/CanopyFluxesMod.F90

New parameterization for soil moisture limitation function (P. Thornton).
Removed CN ifdef for csoilc.

Summary of testing:

  bluesky:

	001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
	002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
	003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
	004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
	005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
	006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
	007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
	008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
	009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
	010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
	011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
	012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
	013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
	014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
	015 sm311 TSM.sh 4p_casa_dh t31_casa 48 ...........................PASS
	016 er311 TER.sh 4p_casa_dh t31_casa 10+38 ........................PASS
	017 br311 TBR.sh 4p_casa_dh t31_casa 24+24 ........................FAIL! rc= 11
	018 bl311 TBL.sh 4p_casa_dh t31_casa 48 ...........................SKIPPED*
	019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
	020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
	021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
	022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*

  NOTE:  the branch tests failed only in the differences to the time_bounds variable
         upon branching - all other variables stayed the same. This has been reported as
         bug #290.
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable:  None

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:  all
    - what platforms/compilers:  all
    - nature of change (roundoff; larger than roundoff/same climate; new climate):  new climate

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
      clm3_expa_60 was the baseline tag
      the testing source was:
      /home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_communn_hk15
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/main
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeophys
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/biogeochem
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/riverroute
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/csm_share/shr
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/timing
      /home/bluesky/oleson/hydro01_clm3_expa_60/src/utils/esmf_wrf_timemgr
   - platform/compilers:  bluesky
   - configuration (CPP ifdefs):
      #define SPMD
      #define OFFLINE
      #define LSMLON       128
      #define LSMLAT       64
      #define MAXPATCH_PFT 4
      #define RTM
      #undef  DUST
      #undef  VOC
      #undef  DGVM
      #undef  CN
      #undef  SUPLN
   - build-namelist command (or complete namelist):
         &clmexp
         caseid         = 'hydp2_off_communn_hk16'
         ctitle         = 'offline run with clm3_expa_60, same as hydp2_off_con but with version 3 of P. Lawrence sfc dataset and new community hydrology with soil ice and recharge fix and hkdepth=2.5 and gridcell fmax and WT fix and ws fix and Sellers rsoil and r
soil dew fix and starts 1948'
         finidat        = ' '
         fsurdat        = '/fis/cgd/tss/oleson/plawren_datasets3/surfdata_064x128_hydro_060426.nc'
         fatmlndfrc     = '/fs/cgd/csm/inputdata/lnd/clm2/griddata/fracdata_64x128_gx1v3_060401.nc'
         fpftcon        = '/home/bluesky/oleson/hydro01_clm3_expa_60/bld/offline/mods_hydp2_off_commun/pft-physiology.c060426'
         frivinp_rtm    = '/fs/cgd/csm/inputdata/lnd/clm2/rtmdata/rdirc.05'
         offline_atmdir = '/cgd/tss/oleson/ncepdata.tqian'
         nsrest         =  0
         nelapse        =  -6570
         dtime          =  1200
         start_ymd      =  19480101
         start_tod      =  0
         irad           = -1
         wrtdia         = .true.
         mss_irt        =  1095
         hist_dov2xy    = .true.
         hist_nhtfrq    =  0
         hist_mfilt     =  1
         hist_crtinic   = 'YEARLY'
         /

   - MSS location of output:
        mss:/OLESON/csm/hydp2_off_communn_hk16

   URL for LMWG diagnostics output used to validate new climate:

http://www.cgd.ucar.edu/tss/clm/diagnostics/lmwg_hydro/hydp2_off_communn_hk16c-obs/setsIndex.html
	
===============================================================
===============================================================
Tag name: clm3_expa_79
Originator(s): nanr
Date: Wed Nov 15 14:29:37 MST 2006
One-line Summary: Add Pat Whorley's timing changes.

Purpose of changes: 
Pat Whorley's improvements to the timing calls to give a better picture of 
CLM timing.  Pat added comments and a few modifications to the t_startf/t_stopf calls.  

Bugs fixed (include bugzilla ID):  None

Describe any changes made to build system:  None

Describe any changes made to the namelist:  updated pft namelist to point to new pft-physiology file:
$CSMDATA/pftdata/pft-physiology.c060426.   


List any changes to the defaults for the boundary datasets:  None

Describe any substantial timing or memory changes:  None

Code reviewed by: myself

List all subroutines eliminated:  None

List all subroutines added and what they do:  None

List all existing files that have been modified, and describe the changes:

M      test/system/nl_files/t31_cnall
M      test/system/test_driver.sh
M      src/main/clm_comp.F90
M      src/main/driver.F90
M      src/main/lnd_comp_mct.F90
M      src/main/decompMod.F90
M      src/main/areaMod.F90

Summary of testing:

  bluesky:
   001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
   002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
   003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
   004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................PASS
   005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
   006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
   007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
   008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
   009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................PASS
   010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
   011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................FAIL! rc= 11
   012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................FAIL! rc= 11
   013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
   014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................FAIL! rc= 11
   015 sm311 TSM.sh 4p_casa_dh t31_dgvm 48 ...........................PASS
   016 er311 TER.sh 4p_casa_dh t31_dgvm 10+38 ........................PASS
   017 br311 TBR.sh 4p_casa_dh t31_dgvm 24+24 ........................FAIL! rc= 11
   018 bl311 TBL.sh 4p_casa_dh t31_dgvm 48 ...........................PASS
   019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
   020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
   021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
   022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
   
   TESTING NOTE 1:  the branch tests failed only in the differences to the time_bounds variable
   		    upon branching - all other variables stayed the same. This has been reported as
   		    bug #290.
   TESTING NOTE 2:  The new pft file (added for hydro changes (clm3_expa_80) caused the t31_cnall tests to fail.

  tempest:      (tests must still be done)
  bangkok/lf95: (tests must still be done)

CLM tag used for the baseline comparison tests if applicable: clm3_expa_78

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers:  NONE
	
===============================================================
===============================================================
Tag name: clm3_expa_78
Originator(s): mvertens
Date: Mon Nov 13 20:22:05 MST 2006
One-line Summary: introduced new offline build/run scripts and testing suite

Purpose of changes: New build/run scripts were introduced in order to make it easier 
to run the offline clm on platforms other than the NCAR IBMs. In addition a new testing
suite was introduced that will make it much easier to add new tests and trace the status
of current tests. The new test suite can also be run on a much wider set of platforms
than the NCAR IBMs. Both the new build/run scripts and the new offline test suite were
based on the current CAM build/run scripts and CAM test suite.

Bugs fixed (include bugzilla ID): None

Describe any changes made to build system: New build system based on a new "configure" utility

Describe any changes made to the namelist: The namelist generation is the same. For the
the new build/run scripts, sample namelists can be found in the scripts bld/run-*.csh.

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: myself

List all subroutines eliminated:
   D   bld/offline
   D   bld/offline/tests
   D   bld/offline/tests/CLM_namelist.pm
   D   bld/offline/tests/compare.csh
   D   bld/offline/tests/config_machine_specs.csh
   D   bld/offline/tests/CLM_lab.pm
   D   bld/offline/tests/CLM_test.pm
   D   bld/offline/tests/CLM.pm
   D   bld/offline/tests/test-model.pl
   D   bld/offline/tests/model_specs.csh
   D   bld/offline/tests/CLM_run.pm
   D   bld/offline/tests/test_batch.csh
   D   bld/offline/tests/Makefile
   D   bld/offline/tests/configure.csh
   D   bld/offline/tests/lab_default.pm
   D   bld/offline/mkSrcfiles
   D   bld/offline/mkDepends
   D   bld/offline/jobscript.csh
   D   bld/offline/Makefile

List all subroutines added and what they do:
   A   test/system
   A   test/system/TCB.sh
   A   test/system/tests_pretag_bluevista
   A   test/system/config_files
   A   test/system/config_files/4p_casa_h
   A   test/system/config_files/4p_casa_m
   A   test/system/config_files/4p_casa_o
   A   test/system/config_files/17p_vodsr_h
   A   test/system/config_files/17p_vodsr_m
   A   test/system/config_files/17p_vodsr_o
   A   test/system/config_files/4p_vodsr_dh
   A   test/system/config_files/17p_cnn_h
   A   test/system/config_files/4p_vodsr_dm
   A   test/system/config_files/17p_cnn_dh
   A   test/system/config_files/17p_cnn_m
   A   test/system/config_files/4p_vodsr_do
   A   test/system/config_files/17p_cnn_o
   A   test/system/config_files/10p_dgvm_h
   A   test/system/config_files/4p_casa_dh
   A   test/system/config_files/17p_cnn_dm
   A   test/system/config_files/17p_cnn_do
   A   test/system/config_files/10p_dgvm_dh
   A   test/system/config_files/10p_dgvm_m
   A   test/system/config_files/4p_casa_dm
   A   test/system/config_files/10p_dgvm_o
   A   test/system/config_files/4p_casa_do
   A   test/system/config_files/README
   A   test/system/config_files/10p_dgvm_dm
   A   test/system/config_files/10p_dgvm_do
   A   test/system/config_files/17p_vodsr_dh
   A   test/system/config_files/17p_vodsr_dm
   A   test/system/config_files/17p_vodsr_do
   A   test/system/config_files/4p_vodsr_h
   A   test/system/config_files/4p_vodsr_m
   A   test/system/config_files/4p_vodsr_o
   A   test/system/gen_test_table.sh
   A   test/system/TBL.sh
   A   test/system/CLM_compare.sh
   A   test/system/nl_files
   A   test/system/nl_files/t31_cnall
   A   test/system/nl_files/t31_dgvm
   A   test/system/nl_files/t31
   A   test/system/input_tests_master
   A   test/system/TBR.sh
   A   test/system/tests_pretag_bangkok
   A   test/system/tests_pretag_bluesky
   A   test/system/TER.sh
   A   test/system/test_driver.sh
   A   test/system/tests_pretag_tempest
   A   test/system/CLM_runcmnd.sh
   A   test/system/TSM.sh

List all existing files that have been modified, and describe the changes:

Summary of testing:

  bluesky:
   001 sm111 TSM.sh 4p_vodsr_dh t31 48 ...............................PASS
   002 er111 TER.sh 4p_vodsr_dh t31 10+38 ............................PASS
   003 br111 TBR.sh 4p_vodsr_dh t31 24+24 ............................FAIL! rc= 11
   004 bl111 TBL.sh 4p_vodsr_dh t31 48 ...............................SKIPPED*
   005 sm114 TSM.sh 4p_vodsr_h t31 48 ................................PASS
   006 sm121 TSM.sh 17p_vodsr_dh t31 48 ..............................PASS
   007 er121 TER.sh 17p_vodsr_dh t31 10+38 ...........................PASS
   008 br121 TBR.sh 17p_vodsr_dh t31 24+24 ...........................FAIL! rc= 11
   009 bl121 TBL.sh 17p_vodsr_dh t31 48 ..............................SKIPPED*
   010 sm124 TSM.sh 17p_vodsr_h t31 48 ...............................PASS
   011 sm211 TSM.sh 17p_cnn_dh t31_cnall 48 ..........................PASS
   012 er211 TER.sh 17p_cnn_dh t31_cnall 10+38 .......................PASS
   013 br211 TBR.sh 17p_cnn_dh t31_cnall 24+24 .......................FAIL! rc= 11
   014 bl211 TBL.sh 17p_cnn_dh t31_cnall 48 ..........................SKIPPED*
   015 sm311 TSM.sh 4p_casa_dh t31_dgvm 48 ...........................PASS
   016 er311 TER.sh 4p_casa_dh t31_dgvm 10+38 ........................PASS
   017 br311 TBR.sh 4p_casa_dh t31_dgvm 24+24 ........................FAIL! rc= 11
   018 bl311 TBL.sh 4p_casa_dh t31_dgvm 48 ...........................SKIPPED*
   019 sm411 TSM.sh 10p_dgvm_dh t31_dgvm 48 ..........................PASS
   020 er411 TER.sh 10p_dgvm_dh t31_dgvm 10+38 .......................PASS
   021 br411 TBR.sh 10p_dgvm_dh t31_dgvm 24+24 .......................FAIL! rc= 11
   022 bl411 TBL.sh 10p_dgvm_dh t31_dgvm 48 ..........................SKIPPED*
   
   Note, the branch tests failed only in the differences to the time_bounds variable
   upon branching - all other variables stayed the same. This has been reported as
   bug #290.

  bangkok/lf95: (new tests will be added in later tags)
   001 sm112 TSM.sh 4p_vodsr_dm t31 48 ...............................PASS
   002 er112 TER.sh 4p_vodsr_dm t31 10+38 ............................FAIL! rc= 11
   003 br112 TBR.sh 4p_vodsr_dm t31 24+24 ............................FAIL! rc= 11
   004 bl112 TBL.sh 4p_vodsr_dm t31 48 ...............................SKIPPED*
   005 sm115 TSM.sh 4p_vodsr_m t31 48 ................................PASS

   Note, the branch tests failed only in the differences to the time_bounds variable
   upon branching - all other variables stayed the same. This has been reported as
   bug #290.

   Note, the restart test fails in rtm (the exact same restart test passes on bluesky).
   This has been reported as bug #291. 

  tempest: (tests must still be done)

CLM tag used for the baseline comparison tests if applicable:

Summarize any changes to answers: NONE
	
===============================================================

===============================================================
Tag name: clm3_expa_77
Originator(s): tcraig
Date: Thu Nov  9 23:08:50 MST 2006
One-line Summary: fix retain branch casename bug in restFileMod

Purpose of changes: correct behaviour of retain branch casename.  
  Was mostly working ok except for a few cases where the test
  of the old and new casename would produce the incorrect result.

Bugs fixed (include bugzilla ID): #269

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: none

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
M      src/main/restFileMod.F90
       - recode verify call to a more robust index call and associated mods

Summary of testing:

  bluesky: none
  tempest: none
  bangkok/lf95: all CAM tests passed with cam3_3_40 vs cam3_3_37
  bluevista: tested in CCSM with ERB test
  lightning: tested in CCSM with ERB test

Summarize any changes to answers: NONE
	
===============================================================
===============================================================
Tag name: clm3_expa_76
Originator(s): tcraig,nanr,pworley
Date: Sun Oct 29 16:03:38 MST 2006
One-line Summary: memory use and rtm parallelization/rewrite

Purpose of changes: Merge fmd07_clm3_expa_75 to the main trunk.
  That branch has several updates related to memory usage and
  parallelization of RTM.  In addition, rtm subcycling was
  added to address problems in cfl in rtm and a bug was fixed
  that resulted in incorrect downstream flux when volumes were
  negative.  Also, mksurfdata was updated to add fmax and
  several other minor bugs were fixed.

Bugs fixed (include bugzilla ID):
  RTM was changed from velocity limiting to subcycling to
    handle cfl issues.
  RTM bug fix in downstream flux calculation when volumes were
    negative
  Fix to history file for long_name.
  Add bounds attribute to time variable in history files (#254).

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by:

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:
	M      tools/newcprnc/cprnc.F90
	M      tools/newcprnc/nfwrappers.f90
	M      tools/mksurfdata/mksrfdat.namelist
	M      tools/mkgriddata/mkvarctl.F90
	M      tools/mkgriddata/README
	M      tools/mkgriddata/domainMod.F90
	M      tools/mkgriddata/mkgriddata.F90
	M      tools/mkgriddata/creategridMod.F90
	M      bld/offline/tests/test_batch.csh
	M      src/biogeochem/CASAMod.F90
	M      src/biogeochem/DGVMMod.F90
	M      src/main/spmdGathScatMod.F90
	M      src/main/clm_varcon.F90
	M      src/main/ncdio.F90
	M      src/main/atmdrvMod.F90
	M      src/main/initializeMod.F90
	M      src/main/pftdynMod.F90
	M      src/main/histFileMod.F90
	M      src/main/program_csm.F90
	M      src/main/clm_atmlnd.F90
	M      src/main/clm_csmMod.F90
	M      src/main/restFileMod.F90
	M      src/main/ndepFileMod.F90
	M      src/main/initGridCellsMod.F90
	M      src/main/lnd_comp_mct.F90
	M      src/main/surfrdMod.F90
	M      src/main/domainMod.F90
	M      src/main/decompMod.F90
	M      src/main/areaMod.F90
	M      src/main/iobinary.F90
	M      src/main/clmtype.F90
	M      src/main/histFldsMod.F90
	M      src/SVN_EXTERNAL_DIRECTORIES
	M      src/riverroute/RtmMod.F90
	M      src/riverroute/RunoffMod.F90
	
- added Pat Worley's mods for initialization performance on phoenix.  in 
  decompMod and areaMod.
- add fmax calculation in mksurdata
- add time bounds attribute and fix long_name string in history files
- rtm refactor.  convert from 2d to 1d fields.  inline routines where
  appropriate.  introduce downstream index instead of rdirc.  
  parallelize over river basins.  update i/o for parallel rtm.
  introduce subcycling.  fix bug in downstream flux calc when
  volume is negative.  introduce max timestep calculation for cfl
  for use in subcyling.  add cfl_scale parameter to rtm to set
  relative cfl limit, set cfl_scale to 0.1.  remove rtmfluxini
  routine, set fluxout=0 at initialization.  update rtm restart
  to maximize backward compatability but allowing upgrade.
- remove global domains after use in initalization.  introduce
  local domains (locdomain) in run phase.  add decomp_domg2l meethod.
  add regional and decomped logicals to domain type.
- migrate all ioglobal calls to iolocal.
- inline interpa2si in atmdrv.
- add mct to externals set, not yet used.

Summary of testing:

  This tag is bfb except when RTM is turned on.  the bug fix
  and subcycling change answers by more than roundoff.  A validation
  was performed with RTM, see below.

  bluesky: clm stand alone tests pass except RTM fields.
  bluesky: cam pretag tests all pass
  tempest: cam pretag tests all pass
  bangkok/lf95: cam pretag tests all pass
  bluevista: ccsm test bfb except rtm fields which lead to
	     divergence in solution after 2 days.  pass ERS test.
  bluevista: finemesh tests case runs to completion.
  lightning: ccsm test bfb except rtm fields which lead to
	     divergence in solution after 2 days.  pass ERS test.

CLM tag used for the baseline comparison tests if applicable:
  clm3_expa_69, cam3_3_37, ccsm3_1_beta40

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: RTM subcyling and bug fix
    - what platforms/compilers: all
    - nature of change (roundoff; larger than roundoff/same climate; new climate): larger than roundoff, same climate

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   b31.001r1 validation run done, see /TCRAIG/csm/b31.001r1 relative
   to /CCSM/csm/b31.001.  Keith Oleson also carried out a standalone
   clm run and found bfb except in runoff fields.  Results reviewed
   by land and ocean groups.

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository): ccsm3_1_beta39
	and ccsm3_1_beat39 + fmd06_clm3_expa_74
   - platform/compilers: bluevista16
   - configuration (CPP ifdefs): ccsm B2 case
   - build-namelist command (or complete namelist):
   - MSS location of output: /CCSM/csm/b31.001, /TCRAIG/csm/b31.001r1

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================

NOTE (1/11/07):  This note documents a commit done by nanr (r2316) that committed 
	changes to /tools/mksurfdata files without a tag.  Changes introduced fmax variable to mksrfdat.F90.
	mkfmax.F90 was added in clm3_expa_84.  Changes were only to /tools and not to clm code.

M	/tools/mksrfdat.F90
	
===============================================================
Tag name: clm3_expa_75
Originator(s): mvertens	
Date: Tue Oct 24 21:10:59 MDT 2006
One-line Summary: sequential and concurrent ccsm now have same flux sign convention

Purpose of changes: To have consistent flux sign convention in sequential and concurrent ccsm.
As a result, lnd_comp_mct.F90 now has same flux sign convention as clm_csmsMod.F90
(i.e. fluxes are positive downwards).

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none
 
Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: mvertens

List all subroutines eliminated: nonen

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
   M  lnd/clm2/src/main/clm_time_manager.F90
      - Removed write statement to fort.30

   M  lnd/clm2/src/main/lnd_comp_mct.F90
      - Changed sign convention of fluxes sent to driver to be consistent 
        with those used by concurrent ccsm

Summary of testing:

  no offline or ccsm tests were done
  ran cam testing suite successfully (see ChangeLog for cam3_3_37)

Summarize any changes to answers: See ChangeLog for cam3_3_37
	
===============================================================
===============================================================
Tag name: clm3_expa_74
Originator(s): mvertens
Date: Mon Oct  2 20:16:52 MDT 2006
One-line Summary: removed SCAM if-defs from lnd_comp_mct.F90

Purpose of changes: Let SCAM driver decide if clm has a land point
   rather than putting that decision in lnd_comp_mct.F90.

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: erik

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
  M lnd_comp_mct.F90
    - removed SCAM if-defs

Summary of testing:

  bluesky: all CAM tests passed using this lnd_comp_mct.F90
  tempest: all CAM tests passed using this lnd_comp_mct.F90
  bangkok/lf95: all CAM tests passed using this lnd_comp_mct.F90

Summarize any changes to answers: NONE
	
===============================================================
===============================================================
Tag name: clm3_expa_73
Originator(s): mvertens
Tue Sep 26 08:33:48 MDT 2006
One-line Summary: removed use of mpicom as cam module variable

Purpose of changes: to make determination of clm mpi commmunicator
   self contained

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: 
  clm namelist in cam-standalone mode has changed
  clm namelist in offline and ccsm mode has not changed

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: tcraig, robj, eaton

List all subroutines eliminated: 
  
  D  src/main/do_restwrite.F90

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

  M  src/main/histFileMod.F90
     - removed COUP_CAM if-def for setting if_writrest flag
  M  src/main/program_csm.F90
     - initialize mpi communicator group and iam, masterproc and npes in this module
  M  src/main/controlMod.F90
     - added ditme_out to scam_clm_default_opts call 
       this should have been done when the cam time manager was no longer used by clm
  M  src/main/lnd_comp_mct.F90
     - removed lnd_export_init (using only lnd_export now) 
     - now passing LNDID, mpicom as input argument to lnd_init_mct
     - mct_gsmap_init now used to set clm gsmap (rather than seq_init_setgsmap_init)
  M  src/main/program_off.F90
     - initialize mpi communicator group and iam, masterproc and npes in this module
  M  src/main/spmdMod.F90
     - masterproc, iam, npes and mpicom are now module variables
     - mpi no longe intialized in spmd_init
     - clm communicator pased in as argument

Summary of testing:

  bluesky:
    - ran test_batch.csh and verified that all tests passed successfully
	 when compared to clm3_expa_69
    - ran cam3_3_31 sandbox (not checked in yet) using clm3_expa_73 code changes 
         and verified that all tests passed successfully when compared to cam3_3_30
    - ran ESR.T31_g35.B.bluesky using ccsm3_1_beta36 and the clm3_expa_73 code base
         and verified that results were bfb when compared to ccsm3_1_beta36
  tempest:
    - ran cam3_3_31 sandbox (not checked in yet) using clm3_expa_73 code changes 
         and verified that all tests passed successfully when compared to cam3_3_30
  bangkok/lf95:
    - ran cam3_3_31 sandbox (not checked in yet) using clm3_expa_73 code changes 
         and verified that all tests passed successfully when compared to cam3_3_30

CLM tag used for the baseline comparison tests if applicable: clm3_expa_69

Summarize any changes to answers: Results are bfb
	
===============================================================
===============================================================
Tag name: clm3_expa_72
Originator(s): mvertens
Date: Sun Sep 24 17:40:41 MDT 2006
One-line Summary: removed spaces before #include in controlMod.F90

Purpose of changes: fixed spaces before #include in controlMdd.F90
   this caused problems on lightning with CCSM build (where the
   c preprocessor is invoked independently 

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none
 
Describe any substantial timing or memory changes: nonen

Code reviewed by: mvertens

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
 M src/main/controlMod.F90
    - removed spaces before #include (introduced in clm3_epxa_70)

Summary of testing:

  bluesky: none
  tempest: none
  bangkok/lf95: none

Summarize any changes to answers: Answers are bfb
	
===============================================================
===============================================================
Tag name: clm3_expa_71
Originator(s): jwolfe
Date: Wed Sep 20 12:09:10 MDT 2006
One-line Summary: fixed single executable problem on lightning

Purpose of changes: to fix single executable ccsm problem on lightning

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: jwofle

List all subroutines eliminated: none

List all subroutines added and what they do: one

List all existing files that have been modified, and describe the changes:
  program_csm.F90
   - call to opm_set_threads only invoked now if cpp variable _OPENMP is defined

Summary of testing:

  bluesky: none
  tempest: none
  bangkok/lf95: none
  lightning/pathscale : ccsm mode  only tested

  Note: this change only effects the driver for COUP_CSM mode and so will
  have no impact on COUP_CAM or OFFLINE mode   

CLM tag used for the baseline comparison tests if applicable:

Summarize any changes to answers: answers are bfb
===============================================================
===============================================================
Tag name: clm3_expa_70
Originator(s): mvertens
Date: Thu Sep 14 12:53:28 MDT 2006
One-line Summary: removed use of cam time manager in COUP_CAM mode

Purpose of changes: To enable clm to only use the clm time manager regardless
   of the modes it is run in

Bugs fixed (include bugzilla ID): #215 will be resolved when clm3_expa_70
   is checked into the cam code base

Describe any changes made to build system: clm.template needed to have
   \$CODEROOT/csm_share/eshr added to Filepath

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: mvertens, erik (briefly)

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:
   M   src/main/clm_comp.F90
         - passed SyncClock as optional argument to clm_init1 and call initialize2 
   M   src/main/initializeMod.F90
         - obtained initialization information from SyncClock if passed in as argument,
           rather than using namelist input. For restart runs, stop date obtained from
           SyncClock if passed in as argument, rather than from namelist input.
         - removed COUP_CAM as CPP if-def
   M   src/main/restFileMod.F90
         - renamed routine that reads in time manager restart information to timemgr_restart_io
   M   src/main/controlMod.F90
         - now use clm_time_manager in all CLM modes (including COUP_CAM)
         - removed call to CAM radiation_get routine
         - ***Note that this assumes that CAM and CLM radiation frequency are identical ***
         - ***Should put this into the CAM build-namelist generation routine - filed as a bug report ***
         - need to put in such a check in the future
         - dtime obtained now from CLM namelist, not CAM time manager
   M   src/main/clm_time_manager.F90
         - put in new optional arguments into timemgr_init and timemgr_restart to use SyncClock values if 
           they are passed in to initialize clock
   M   src/main/lnd_comp_mct.F90
         - passed SyncClock in as argument into clm_init1

Summary of testing:

    bluesky: 
    - ran test_batch.csh and verified that all tests passed successfully
	   when compared to clm3_expa_69
    - ran cam3_3_27 using clm3_expa_70 code changes and verified that 
      all tests passed successfully when compared to cam3_3_27
    - ran ESR.T31_g35.B.bluesky using ccsm3_1_beta36 and the clm3_expa_70 code base
      and verified that results were bfb when compared to ccsm3_1_beta36

Summarize any changes to answers: Results are bfb
	
===============================================================
===============================================================
Tag name: clm3_expa_69
Originator(s): erik, jedwards, jeff
Date: Thu Aug 17 09:54:23 MDT 2006
One-line Summary: Fix perpetual bug and update csm_share

Purpose of changes: Fix bugs in perpetual mode and restat_option="end" when
	running with CAM.

Bugs fixed (include bugzilla ID): 107, 185

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: self

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M bld/offline/tests/CLM_lab.pm
    Put test output for all platforms under "clmtest" directory
M bld/offline/tests/test_batch.csh
    Update version comparing to, abort if error status is not ok.
M src/SVN_EXTERNAL_DIRECTORIES
    Update csm_share to share3_060814
M src/main/ncdio.F90
    Change from Jim Edwards to eliminate use of wrap_nf module (from cam3_3_19 commit)
M src/main/controlMod.F90
    Change from Jeff Lee to make use statement for "shr_inputInfo_mod" all lower-case.
    This is important for the CCSM dependency generator on some platforms.

Summary of testing:

  bluesky: all tests pass
  tempest: T31 debug-mode, spmd=False test fails
  bangkok/lf95: all tests pass

CLM tag used for the baseline comparison tests if applicable: clm3_expa_65, and
                                                              clm3_expa_67 (bangkok)

  Summarize any changes to answers: bit-for-bit

Move branch tag over to trunk from: fixtgrbug2_clm3_expa_68

===============================================================
===============================================================
Tag name: clm3_expa_68
Originator(s): mvertens
Date: Wed Aug  9 16:43:04 MDT 2006
One-line Summary: replaced time_manager.F90 with clm_time_manager.F90

Purpose of changes: To eliminate name space conflicts in the 
	single executable CCSM mplementation. 

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none 

Code reviewed by: erik, mvertens

Externals changed:  

List all subroutines eliminated:

List all subroutines added and what they do: 
	
List all existing files that have been modified, and describe the changes:

- time_manager.F90 has been moved to clm_time_manager.F90
  to eliminate name space conflicts in the single executable CCSM 
  implementation. For stand-alone CAM, clm_time_manager.F90 simply
  uses the cam time_manager.F90 code.	 
- program_csm.F90 has also been modified to put in changes needed	
  for the single executable ccsm implementation.	
	
        M      src/biogeochem/CNCStateUpdate2Mod.F90
	M      src/biogeochem/CASAPhenologyMod.F90
	M      src/biogeochem/CNC13StateUpdate2Mod.F90
	M      src/biogeochem/CNNStateUpdate1Mod.F90
	M      src/biogeochem/DGVMEcosystemDynMod.F90
	M      src/biogeochem/CNBalanceCheckMod.F90
	M      src/biogeochem/CNNStateUpdate3Mod.F90
	M      src/biogeochem/CNFireMod.F90
	M      src/biogeochem/CNMRespMod.F90
	M      src/biogeochem/CASAMod.F90
	M      src/biogeochem/CNPhenologyMod.F90
	M      src/biogeochem/CNCStateUpdate1Mod.F90
	M      src/biogeochem/CNDecompMod.F90
	M      src/biogeochem/STATICEcosysDynMod.F90
	M      src/biogeochem/CNCStateUpdate3Mod.F90
	M      src/biogeochem/CNC13StateUpdate1Mod.F90
	M      src/biogeochem/DGVMMod.F90
	M      src/biogeochem/CNC13StateUpdate3Mod.F90
	M      src/biogeochem/CNAnnualUpdateMod.F90
	M      src/biogeochem/CNNStateUpdate2Mod.F90
	M      src/biogeochem/CNNDynamicsMod.F90
	M      src/biogeochem/CNAllocationMod.F90
	M      src/biogeochem/CNC13FluxMod.F90
	D      src/main/time_manager.F90
	M      src/main/accumulMod.F90
	M      src/main/clm_comp.F90
	M      src/main/driver.F90
	M      src/main/atmdrvMod.F90
	M      src/main/subgridRestMod.F90
	M      src/main/accFldsMod.F90
	M      src/main/initializeMod.F90
	M      src/main/pftdynMod.F90
	M      src/main/iniTimeConst.F90
	M      src/main/histFileMod.F90
	M      src/main/program_csm.F90
	M      src/main/do_restwrite.F90
	M      src/main/clm_csmMod.F90
	M      src/main/restFileMod.F90
	M      src/main/controlMod.F90
	M      src/main/initSurfAlbMod.F90
	A  +   src/main/clm_time_manager.F90
	M      src/main/ndepFileMod.F90
	M      src/main/lnd_comp_mct.F90
	M      src/main/program_off.F90
	M      src/main/do_close_dispose.F90
	M      src/riverroute/RtmMod.F90
	M      src/biogeophys/BalanceCheckMod.F90
	M      src/biogeophys/SurfaceRadiationMod.F90
	M      src/biogeophys/SoilTemperatureMod.F90
	M      src/biogeophys/SnowHydrologyMod.F90
	M      src/biogeophys/Biogeophysics2Mod.F90
	M      src/biogeophys/SurfaceAlbedoMod.F90
	M      src/biogeophys/Hydrology1Mod.F90
	M      src/biogeophys/Hydrology2Mod.F90
	M      src/biogeophys/BiogeophysicsLakeMod.F90
	M      src/biogeophys/SoilHydrologyMod.F90
	M      src/biogeophys/HydrologyLakeMod.F90
	M      src/biogeophys/CanopyFluxesMod.F90
		
Summary of testing: 
        - ran test-model.pl on bluesky and verified that all tests
	  passed successfully when compared to clm3_expa_67
	- ran cam3_3_17 test model suite with clm3_expa_68 code used
	  for clm and verified that all tests passed successfully when 
	  compared to cam3_3_17
	- ran ERS.T31_g35.I.bluesky using ccsm3_1_beta35 and the clm3_expa_68
	  clm code based and verified that results were bfb when compared to
	  ccsm3_1_beta35
	
CLM tag used for the baseline comparison tests if applicable: 

Summarize any changes to answers: results are bfb

===============================================================
Tag name: clm3_expa_67
Originator(s): tcraig
Date: Thu Jul 27 12:50:37 MDT 2006
One-line Summary: Fix tiny bug in controlMod.F90 for lighting compiling 

Purpose of changes: compiler failure associated with inconsistent
	module name related to shr_input vs shr_Input.

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: 

Describe any changes made to the namelist:

List any changes to the defaults for the boundary datasets:

Describe any substantial timing or memory changes: 

Code reviewed by: jeff, mvertens

Externals changed:  

List all subroutines eliminated:

List all subroutines added and what they do: 
	
List all existing files that have been modified, and describe the changes:

src/main/controlMod.F90
-     use shr_InputInfo_mod, only : shr_inputInfo_initType,       &
+     use shr_inputinfo_mod, only : shr_inputInfo_initType,       &
		
Summary of testing: NONE

CLM tag used for the baseline comparison tests if applicable: 

Summarize any changes to answers: should be bit-for-bit

===============================================================
Tag name: clm3_expa_66
Originator(s): tcraig
Date: Tue Jul 25 17:29:37 MDT 2006
One-line Summary: Add topographic downscaling, refactor mid-level infrastructure

Purpose of changes: Add topographic downscaling, improve memory use and scaling,
	step towards supporting nested grids.  Merge fmc12_clm3_expa_64 to trunk.

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: 

Describe any changes made to the namelist: Add two new optional namelist to
	read atm and lnd topography, fatmtop, flndtop

List any changes to the defaults for the boundary datasets: Updated the
	mkgriddata tool to produce an optional topographic dataset.
	Several topo datasets added to inputdata/lnd/clm2/griddata/.
	These datasets have not been added to any scripts as they
	are optional at this point and the scripts don't support 
	downscaling yet "out of the box".

Describe any substantial timing or memory changes: Memory scaling much improved.
	still too many global arrays in domain and decomp.  these will be removed
	in future revisions.

Code reviewed by: 

Externals changed:  

List all subroutines eliminated:
D      src/main/surfFileMod.F90
D      src/main/initSubgridMod.F90
	

List all subroutines added and what they do: 
A  +   src/main/subgridMod.F90
  - code cleanup and merge of deleted subroutines
A  +   src/main/surfrdMod.F90
  - added to isolate routines and eliminate circular use issues
	
List all existing files that have been modified, and describe the changes:
M      tools/mkgriddata/mkvarctl.F90
M      tools/mkgriddata/domainMod.F90
M      tools/mkgriddata/mkgriddata.F90
M      tools/mkgriddata/areaMod.F90
M      tools/mkgriddata/creategridMod.F90
M      tools/mkgriddata/mkvarsur.F90
M      src/biogeochem/CASAMod.F90
M      src/biogeochem/STATICEcosysDynMod.F90
M      src/biogeochem/DGVMMod.F90
M      src/main/clm_varpar.F90
M      src/main/driver.F90
M      src/main/ncdio.F90
M      src/main/atmdrvMod.F90
M      src/main/subgridRestMod.F90
M      src/main/initializeMod.F90
M      src/main/clmtypeInitMod.F90
M      src/main/pftdynMod.F90
M      src/main/iniTimeConst.F90
M      src/main/histFileMod.F90
M      src/main/clm_atmlnd.F90
M      src/main/clm_varsur.F90
M      src/main/clm_csmMod.F90
M      src/main/controlMod.F90
M      src/main/filterMod.F90
M      src/main/clm_varctl.F90
M      src/main/ndepFileMod.F90
M      src/main/initGridCellsMod.F90
M      src/main/lnd_comp_mct.F90
M      src/main/domainMod.F90
M      src/main/decompMod.F90
M      src/main/areaMod.F90
M      src/main/clmtype.F90
M      src/riverroute/RtmMod.F90
M      src/biogeophys/SurfaceAlbedoMod.F90

Merge fmc12_clm3_expa_64 to trunk:
- update mkgrid to add topographic data file generation
- comment out print statement in lnd_comp_mct
- change use of shr_kind_mod in SurfaceAlbedoMod for compiler
  problem on pgi (MVR)
- change clm so memory now dynamically allocated.  LSMLON and LSMLAT
  in preproc.h no longer used except for with SCAM.  MAXPATCH still
  used but could be changed into a namelist input.
- add support for reading topographic datasets and using them
  for downscaling between clm atm and land grids.
- reorganize code to eliminate circular use logic
- rewrite decompInit to improve memory use and scaling
- remove obsolete routines in decompMod.F90
- rename datatype procs to procinfo, now contains only local data
- modify clmtype so all data is local gdc, no more global arrays in
  clmtype!
- update map_type for efficient memory use.  like mct with 1d arrays
  consisting of src, dst, S (COL, ROW, S).  update the internal clm
  atm/lnd mappings to use new datatype.  lnd/rtm and driver/atm
  mapping still using gridmap_type.  this will be updated in future
  versions.
- convert domain from 2d global to 1d global arrays.  add glo 
  decomp which is global 1d indexing like ij to 1d or gsn 
  uncompressed.
- convert wtxy, vegxy, pctspec from 2d to 1d arrays.  migrate many other arrays 
  from 2d global (i,j) to 1d global.  this is for nesting and to eventually
  cut down on number of index mappings in decomp_type
- reorganize order of initialization calls to start thinking about nesting
- add gatm array to domain datatype
- clean up dead code.
- rename initSubgridMod to subgridMod
- move map_indexes to subgridMod, rename get_subgrid_indexees
- rearrange a few subroutines to improve filename hierarchy and use logic
- delete get_sn routines, no longer needed
- update indexing in clm_atmlnd, remove hardwire indexes
- rewrite i/o as needed for 1d global arrays, not 2d
- delete gatherWeightsDGVM from DGVMMod.F90, no longer needed
- rename surfFileMod to surfrdMod.F90
- reduce size of subgrid_type and redefine gcelldc and gcellsn


Summary of testing:

  bluesky: 	clm test passes, cam pretag passes except ccsm
  tempest: 	cam pretag passes
  bangkok/lf95: cam pretag passes except bl153, bl353, bl553 due to code
	changes and resulting binary produced by compiler optimizations.
	also scam fails.

CLM tag used for the baseline comparison tests if applicable: clm3_expa_65, cam3_3_16

  Summarize any changes to answers: NONE bit-for-bit

===============================================================
===============================================================
Tag name: clm3_expa_65
Originator(s): Erik Kluzek
Date: Mon Jul 10 13:52:20 MDT 2006
One-line Summary: Use share clocks and inputinfo object at driver level

Purpose of changes: Use new version of esmf_wrf and csm_share as next step
  in sequential CCSM development.

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: Add ability to use Darwin, add eshr to
Filepath

Describe any changes made to the namelist: Instead of directing namelist from stdin
  explicitly open namelist filename.  Change namelist name from clmexp to clm_inparm.

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: Mariana Vertenstein, Tony Craig, Forrest Hoffman

Externals changed:  csm_share        to share3_060710
		    esmf_wrf_timemgr to esmf_wrf_timemgr_060616

List all subroutines eliminated: None

List all subroutines added and what they do: control_setNL (controlMod.F90) sets the
  namelist filename.

List all existing files that have been modified, and describe the changes:

tools/newcprnc/Makefile
bld/offline/tests/CLM_namelist.pm
bld/offline/tests/CLM_lab.pm
bld/offline/tests/CLM.pm
bld/offline/tests/model_specs.csh
bld/offline/tests/configure.csh
bld/offline/tests/config_machine_specs.csh
bld/offline/tests/CLM_run.pm
bld/offline/tests/test_batch.csh
bld/offline/tests/Makefile
bld/offline/jobscript.csh

    Add eshr to Filepath, add Darwin as a valid platform, don't redirect unit 5 for
namelist. Set MODEL_DATDIR explicitly. Use lnd.stdin as default namelist name.
Add "-g" to Makefile. Change clm namelist from clmexp to clm_inparm. Get test_batch.csh
to work both on bangkok for Linux/Lahey and tempest for SGI. Write out Rootdir file
when configuring build directory.

src/main/time_manager.F90 -- Use dayOfYear_r8 for calc_calday.
src/main/clm_comp.F90 ------ Pass CCSMInit in.
src/main/fileutils.F90 ----- Small changes to how using shr_file_mod.
src/main/initializeMod.F90 - Pass clock in.
src/main/program_csm.F90 --- Change where ESMF_Initialize is done.
src/main/controlMod.F90 ---- Add method to set namelist name, pass clock in and use it.
src/main/clm_varctl.F90 ---- Get rid of cam_ variables.
src/main/lnd_comp_mct.F90 -- Pass in clock and CCSMInit object.

Summary of testing:

  bluesky: 	test-batch.csh -- PASS and CAM and CAM CCSM tests pass.
  tempest: 	test-batch.csh -- PASS and CAM tests pass.
  bangkok/lf95: test-batch.csh -- PASS and CAM tests pass.

CLM tag used for the baseline comparison tests if applicable: clm3_expa_64

  Summarize any changes to answers: NONE bit-for-bit

===============================================================
===============================================================
Tag name: clm3_expa_64
Originator(s): Dani Bundy Coleman <bundy@ucar.edu>
Date: Thu Jun 29 14:44:07 MDT 2006
One-line Summary: dust modifications from Natalie Mahowald

Purpose of changes: update dust code 

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: Mariana Vertenstein <mvertens@ucar.edu>

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:

M      src/biogeochem/DUSTMod.F90
       OLD     dmt_vma = 2.524e-6_r8 ! [m] Mass median diameter analytic       She84 p.75 Table1
       NEW     dmt_vma = 3.500e-6_r8 ! [m] Mass median diameter analytic 

M      src/main/clm_atmlnd.F90
       add land-to-atmosphere communication of fv,ram1 & dust fluxes
       (only active if defined DUST or PROGSEASALT )
M      src/main/lnd_comp_mct.F90
       add land-to-atmosphere communication of fv,ram1 & dust fluxes
       (only active if defined DUST or PROGSEASALT )

Summary of testing:

  bluesky: tested with cam, bfb when DUST and PROGSEASALT not defined
  tempest:
  bangkok/lf95:  tested with cam, bfb when DUST and PROGSEASALT not defined

CLM tag used for the baseline comparison tests if applicable: clm3_expa_63

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
===============================================================
Tag name: clm3_expa_63
Originator(s): Mariana Vertenstein
Date: Fri May 12 16:08:03 MDT 2006  
One-line Summary: introduced mct domains in COUP_CAM mode

Purpose of changes: To introduce generalized mct domains
in COUP_CAM mode for the purposes of generating a sequential 
ccsm 

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none
 
Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: Tony Craig

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
  lnd_comp_mct.f90 
     removed lnd_CheckGrid_mct routine and replaced it with lnd_domain_mct
     each processor sends it local domain information stored in an MCT
     GeneralGrid data structure back to the top level application driver. 
     A global gather is done for the GeneralGrid and domain comparison is
     performed on the master processor.     

Summary of testing:

  bluesky: only cam test suite was run successfully
  tempest: only cam test suite was run successfully
  bangkok/lf95: only cam test suite was run successfully

CLM tag used for the baseline comparison tests if applicable:

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
===============================================================
Tag name: clm3_expa_62
Originator(s): erik, tcraig
Date: Wed May 10 00:06:39 MDT 2006
One-line Summary: merge shrgetput08_clm3_expa_61, fix finemesh bugs

Purpose of changes: changes required for sequential ccsm.  validate
	finemesh is running properly.

Bugs fixed (include bugzilla ID):
	a couple finemesh bugs, not documented.

Describe any changes made to build system: modified makefile slightly
	to set HIDE_MPI when SPMD is FALSE, remove HIDE_SHR_MSG

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: erik, tcraig

List all subroutines eliminated: none

List all subroutines added and what they do: none

List all existing files that have been modified, and describe the changes:
Makefile:
 - remove HIDE_SHR_MSG, not needed anymore
 - add HIDE_MPI if SPMD is FALSE
SVN_EXTERNALS:
 - change csm_share version from share3_051205 to share3_060428
 - change emsf_wrf_timemgr version from esmf_wrf_timemgr_051212 to esmf_wrf_timemgr_060501
fileutils.F90:
 - uses shr_file_mod.F90 routines
 - use shr_file_mod syntax for archive_dir (using mss: prefix)
initializeMod.F90:
 - add pnamer_bin get
program_csm.F90:
 - add ESMF_Initialize call
clm_atmlnd.F90:
 - fix bug in call to grid_maparray for finemesh mapping, only affects finemesh runs.
controlMod.F90:
 - use shr_file_mod syntax for archive_dir (using mss: prefix)
lnd_comp_mct.F90:
 - change call to get_proc_bounds to get_proc_bounds_atm (bug for finemesh runs).
program_off.F90:
 - add calls to ESMF_Initialize and ESMF_Finalize
 
	
Summary of testing:
  bluesky: cam full suite bfb
	   clm full suite not bfb (TS is bfb for 2 days, history file not bfb
	      after ~1.5 days probably due to new esmf time manager, likely roundoff)
  tempest: cam full suite bfb, ccsm build test
  bangkok/lf95: cam full suite bfb
  bluevista : ccsm TER.01a.1.9x2.5_gx1v3.B.bluevista bfb
	      cam finemesh T42half.clim0 test, bfb for 42 timesteps vs cam3_2_49
  lightning : ccsm TER.01a.4x5_gx3v5.B.bluevista bfb

CLM tag used for the baseline comparison tests if applicable: 
  clm3_expa_61, cam3_3_4, ccsm3_1_beta27

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: clm standalone only
    - what platforms/compilers: only bluesky tested
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	assume roundoff.  it's bfb for at least a day.  in cam and ccsm mode they
	are bfb.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?  guess

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================

===============================================================
Tag name: clm3_expa_61
Originator(s): T Craig
Date: Thu Apr 27 01:10:40 MDT 2006
One-line Summary: merge cammct05_clm3_expa_58 onto main trunk,
  modify surface dataset input

Purpose of changes: merge branch

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the boundary datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: myself, developed my MV

List all subroutines eliminated:
  clm_camMod.F90 - interface to cam
  MCT_atmlnd_cpl.F90 - mct migrated to sequential driver
  MCT_lnd_comp.F90 - mct migrated to sequential driver

List all subroutines added and what they do:
  lnd_comp_mct.F90 - interface to sequential driver using mct coupling
	
List all existing files that have been modified, and describe the changes:
  clm_comp.F90 - separate init method into init1, init2
  initializeMod.F90 - separate initialize into initialize1 and 2
  program_csm.F90 - add call to clm_init0
  clm_atmlnd.F90 - PWorley's changes to improve phoenix performance,
    packed arrays in clm_mapa2l and clm_mapl2a interpolation.
  program_off.F90 - add call to clm_init0
  areaMod.F90 - PWorley's changes to improve phoenix performance,
    interpolate packed arrays in gridmap_maparray
  Hydrology2Mod.F90 - remove use of iam

  mksurfdata, several files changed to convert
    mksrf_fgrid_global/regional to mksrf_fgrid and mksrf_gridtype
	
Summary of testing:

  bluesky: clm full suite bfb, cam full suite bfb
  bluevista: ccsm bfb TER.01a.T31_gx3v5.B.bluevista, TER.01a.4x5_gx3v5.B.bluevista
  tempest: cam full suite bfb
  bangkok/lf95: cam full suite bfb

  mksrf tested on bluevista, 7 cases, bfb
	
CLM tag used for the baseline comparison tests if applicable:
  clm3_expa_60, cam3_3_2, ccsm3_1_beta25

changes are bit-for-bit
	
===============================================================

	
===============================================================
Tag name: clm3_expa_60
Originator(s): Forrest Hoffman
Date: Fri Apr 14 11:03:34 EDT 2006
One-line Summary: Rearranged physiology fields, changed CO2 constants, fixed Bug #43

Purpose of changes: Make radiation-related physiology fields standard, prepare code for C-LAMP experiments, and make test-model run on Cray X1E (phoenix)

Bugs fixed (include bugzilla ID): Bug #43

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: Myself

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

nfwrappers.f90:
Changed intent for ncid from intent(in) to intent(out) since it must be
returned to the calling routines.  This fixed Bug #43 which was discovered
on the Cray X1E (phoenix).

ChangeLog:
Added this log entry.

clm_varcon.F90:
Changed co2_ppmv_const to 283.1878_r8 for both CASA' and CN in preparation
for Experiment 1 of the C-LAMP.

histFldsMod.F90
Moved LAISUN, LAISHA, TLAI, TSAI, SLASUN, and SLASHA out of the CN-only
section of the code so that they appear on the regular CLM output files
since the two-leaf radiation code is now standard.  In addition, TLAI and
TSAI were removed from the DGVM-only section of the code since these
output fields are now standard.

Summary of testing:

  cheetah:
Ran test-model for T31, T31cn, T31cnall, T31casa, and T31dgvm with
baseline clm3_expa_59.  T31 and T31dgvm passed all tests.  The others
passed tests 01-05, but not the 06_control test because of the change
in co2_ppmv_const.

  phoenix:
Ran test-model for T31, T31cn, T31cnall, T31casa, and T31dgvm with
baseline clm3_expa_59.  T31 and T31dgvm passed all tests.  The others
passed tests 01-05, but not the 06_control test because of the change
in co2_ppmv_const.

CLM tag used for the baseline comparison tests if applicable: clm3_expa_59

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations: co2_ppmv_const modification changes answers
    - what platforms/compilers: IBM (cheetah) and Cray X1E (phoenix)
    - nature of change (roundoff; larger than roundoff/same climate; new climate): larger than roundoff because of changes in carbon pools

   If bitwise differences were observed, how did you show they were no worse
   than roundoff? cprnc

   * There is no validated climate in these model configurations. *

===============================================================
===============================================================
Tag name: clm3_expa_59
Originator(s): Tony Craig
Date: Wed Apr  5 18:03:23 MDT 2006
One-line Summary: add fatmlndfrc capability

Purpose of changes:  Support new datasets, other minor improvements,
  update mkgrid and mksurf tools for new dataset generation.

Bugs fixed (include bugzilla ID):

Describe any changes made to build system: jobscript.csh modified for
  new surface datasets, change baseline resolution to T31.

Describe any changes made to the namelist: added optional fatmlndfrc
  namelist input for landfrac file on atm grid.

List any changes to the defaults for the boundary datasets:  all new
  grid, frac, and surf datasets generated, located in 
  /fs/cgd/csm/inputdata/lnd/clm2/[griddata,surfdata]

Describe any substantial timing or memory changes: None

Code reviewed by: myself

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

tools/mksurfdata/mkrfdat.F90 - change default output filenames
tools/mksurfdata/mklaiMod.F90 - removed masking since there is no mask anymore
tools/mksurfdata/mkfileMod.F90 - removed read of LANDMASK and LANDFRAC
tools/mksurfdata/creategridMod.F90 - removed write of LANDMASK and LANDFRAC
tools/mksurfdata/Makefile - fix clean bug
tools/mkgriddata/mkgriddata.F90 - add generation of ffracdat file
   force area calculation for ccsm domain files due to noise in scrip areas
   change default output filenames
tools/mkgriddata/mkvarctl.F90 - add support for area recomputation
tools/mkgriddata/mkfileMod.F90 - removed, merged into creategridMod.F90
tools/mkgriddata/areaMod.F90 - add flush(6)
tools/mkgriddata/creategridMod.F90 - add mkfile subroutine
   fix bug in setting of corner points
   handle wrap-around points better with corner points
   add ability to adjust units of area (not automatic)
   add checks for area
   add ability write eigher grid or frac file in write_domain
bld/offline/tests/test_batch.csh - change default version from 53 to 58
   turn on dgvm testing by default
bld/offline/jobscript.csh - change to share queue on bluesky
   run mixed mpi/openmp by default, 2x2
   change default resolution to T31 (was T42)
   update to use new surface datasets
   change default, turn on DUST, RTM, VOC, turn off CN, SUPLN, SUNSHA, STOMATA2
   add unlimit unlimited for AIX
   fix redirection to compile_log.clm output file
src/main/initializeMod.F90 - add fatmlndfrc stuff
   add computation of ldomain%frac and ldomain%mask
src/main/controlMod.F90 - add fatmlndfrc stuff
src/main/clm_varctl.F90 - add fatmlndfrc stuff
src/main/driver.F90 - remove redundant definition of caldayp1
src/main/clmtypeInitMod.F90 - remove landfrac variable for clm3 gridcell_type
src/main/histFileMod.F90 - add indxupsc, jndxupsc indices for upscaling
src/main/program_csm.F90 - move shr_msg_stdio to after MPI_INIT, change
   call so it only redirects log file for masterproc.  this will clean
   up the log file significantly but may lead to error messages ending
   up in stdout.
src/main/surfFileMod.F90 - add fatmlndfrc stuff
src/main/initGridCellsMod.F90 - remove landfrac variable for clm3 gridcell_type
src/main/domainMod.F90 - reorder domain data slightly (nothing changed)
src/main/areaMod.F90 - change default of i_ovr and j_ovr from bigint to -1,
   allows for cleaner writing of indxupsc and jndxupsc in history file.
   change gridmap_setmapsFM to use _a and _l notation instead of _i and _o
src/main/clmtype.F90 - remove landfrac from clm3 gridcell_type

	
Summary of testing:

  Baseline versions, clm3_expa_58, cam3_2_56, ccsm3_1_beta24

  bluesky: clm full suite passes, cam full suite passes
  tempest: cam full suite passes 
  bangkok/lf95: cam full suite passes
  bluevista: ccsm TER.01a B passes for several resolutions, new datasets
     in scripts
	
CLM tag used for the baseline comparison tests if applicable: clm3_expa_58

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Code changes are bfb, but answers may change when using new surface datasets

  Summarize any changes to answers, i.e.,
    - what code configurations: CCSM answers will change with new datasets as
      default datasets are changing.  clm default test is bfb at T31 with new datasets,
      cam will be bfb as current default datasets are not being updated.
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================


===============================================================
Tag name: clm3_expa_58
Originator(s): Forrest Hoffman
Date: Thu Mar  9 17:04:27 EST 2006
One-line Summary: Updates for the Cray X1E and a forcing height error check.

Purpose of changes: Improvements on the Cray X1E and avoiding arithmetic exceptions when the forcing height is below the canopy height.

Bugs fixed (include bugzilla ID): Bug #36

Describe any changes made to build system: jobscript.csh modified for Cray X1E

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: None

Code reviewed by: myself and (for forcing height check code) Mariana Vertenstein

List all subroutines eliminated: None

List all subroutines added and what they do: None

List all existing files that have been modified, and describe the changes:

   jobscript.csh - Modified for Cray X1E and cross-compiler
   inicFileMod.F90 - Added compiler directives for vectorization
   driver.F90 - Commented out CSDs to avoid model hangs caused by write
      statements in science routines within the associated loops
   controlMod.F90 - Changed default clump_pproc to 1 for the Cray (since CSDs
      are not used in driver.F90
   histFldsMod.F90 - Changed type2d='levlak' for the TLAKE field
   CanopyFluxesMod.F90 - Inserted code to check if the forcing height
      is below the canopy height for any pft.  Model will now abort when this
      occurs instead of taking the log() of a negative number.  See Bug #36

Summary of testing:

  bluesky: test-model ran as follows
01_debug_run_SPMD: T31 ran
02_debug_run_nonSPMD: T31 ran
03_start: T31 ran
04_restart: T31 ran
05_norestart_compare_to_restart: T31 ran
06_control: T31 ran
01_debug_run_SPMD: T31cn ran
02_debug_run_nonSPMD: T31cn ran
03_start: T31cn ran
04_restart: T31cn ran
05_norestart_compare_to_restart: T31cn ran
06_control: T31cn ran
01_debug_run_SPMD: T31cnall ran
02_debug_run_nonSPMD: T31cnall ran
03_start: T31cnall ran
04_restart: T31cnall ran
05_norestart_compare_to_restart: T31cnall ran
06_control: T31cnall ran
01_debug_run_SPMD: T31casa ran
02_debug_run_nonSPMD: T31casa ran
03_start: T31casa ran
04_restart: T31casa ran
05_norestart_compare_to_restart: T31casa ran
06_control: T31casa ran
  cheetah:
01_debug_run_SPMD: T31cnall ran
02_debug_run_nonSPMD: T31cnall ran
03_start: T31cnall ran
04_restart: T31cnall ran
05_norestart_compare_to_restart: T31cnall ran
06_control: T31cnall ran
01_debug_run_SPMD: T31 ran
02_debug_run_nonSPMD: T31 ran
03_start: T31 ran
04_restart: T31 ran
05_norestart_compare_to_restart: T31 ran
06_control: T31 ran
01_debug_run_SPMD: T31cn ran
02_debug_run_nonSPMD: T31cn ran
03_start: T31cn ran
04_restart: T31cn ran
05_norestart_compare_to_restart: T31cn ran
06_control: T31cn ran
01_debug_run_SPMD: T31casa ran
02_debug_run_nonSPMD: T31casa ran
03_start: T31casa ran
04_restart: T31casa ran
05_norestart_compare_to_restart: T31casa ran
06_control: T31casa ran
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable: clm3_expa_57

===============================================================
Tag name: clm3_expa_57
Originator(s): Peter Thornton
Date: 31 Jan 2006
One-line Summary: Mods to allow switching between 3 and 4 soil
 organic matter pools

Purpose of changes: New science.

Bugs fixed (include bugzilla ID): bugs in pftdynMod.F90 and ndepfileMod.F90

Describe any changes made to build system:

Describe any changes made to the namelist: Added SOM4 as new CPP directive

List any changes to the defaults for the boundary datasets:

Describe any substantial timing or memory changes: none

Code reviewed by: myself

List all subroutines eliminated:

List all subroutines added and what they do:

List all existing files that have been modified, and describe the changes:
main/clmtype.F90: added soil4c (and 13C equiv.), soil4n states and associated
    flux variables. Also added long name commenting for many previously defined
    variables.
main/clmtypeInitMod.F90: added initialization for new variables
main/CNiniTimeVar.F90: initialize new state variables.
main/histFldsMod.F90: added new variables, and also added long names for 
    many previously defined variables.
main/pftdynMod.F90: bug fix in mpi_bcast, change MPI_REAL8 to MPI_INTEGER.
main/ndepFileMod.F90: bug fix for mpi_bcast, change MPI_REAL8 to MPI_INTEGER.
biogeochem/CNSetValueMod.F90: add code for new state and flux variables.
biogeochem/CNDecompMod.F90: add code to allow either 3 or 4 SOM pools. Default
    behavior is 3 pools, 4-pool behavior triggered by SOM4 CPP directive.
biogeochem/CNCStateUpdate1Mod.F90: handling for new variables.
biogeochem/CNNStateUpdate1Mod.F90: handling for new variables.
biogeochem/CNSummaryMod.F90: handling for new variables.
biogeochem/CNBalanceCheckMod.F90: handling for new variables
biogeochem/CNPrecisionControlMod.F90: handling for new variables
biogeochem/CNC13FluxMod.F90: handling for isotope version of new variables
biogeochem/C13StateUpdate1Mod.F90: handling for new variables
biogeochem/C13SummaryMod.F90: handling for new variables
biogeochem/CNrestMod.F90: handling for new variables, and modify EXIT_SPINUP
    controls
    
Summary of testing:

  bluesky:
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable: in 3-pool mode 
(SOM4 not set), results are bfb with clm3_expa_55.  in 4-pool mode, changes
answers, as expected.

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
bfb under 3-pools is demonstrated at:
http:/www.cgd.ucar.edu/tss/clm/diagnostics/clm3cn/c13/ccsm3_bgc31_I_5a-ccsm3_bgc31_I_2b/setsIndex.html
	
===============================================================
Tag name: clm3_expa_56
Originator(s): Tony Craig
Date: 31 Jan 2006
One-line Summary: Final changes for finemesh implementation.

Purpose of changes: Integrate final changes for finemesh implementation.  These
changes are 100% backward compatable and bfb, but also support use of a finemesh grid.  finemesh implementation has been test in clm and cam.

Bugs fixed (include bugzilla ID):

Describe any changes made to build system: Update Makefile so Depends are regenerated if any code is changed.

Describe any changes made to the namelist: Added one new optional namelist, fatmgrid.  This is a dataset for the coarse grid in clm.  The format is the same as the surface dataset but only needs to include grid variables.

List any changes to the defaults for the boundary datasets:  Generated some new datasets with filled wetland and higher resolution.  Not required and not yet added to default suite of datasets.

Describe any substantial timing or memory changes:

Code reviewed by:

List all subroutines eliminated:

List all subroutines added and what they do:

List all existing files that have been modified, and describe the changes:

tools/mksurfdata:
  mksrfdat.F90,areaMod.F90,creategridMod.F90
bld/offline/Makefile
doc/ChangeLog
 src/main:
clm_comp.F90,driver.F90,clm_camMod.F90,atmdrvMod.F90,clmtypeInitMod.F90,initializeMod.F90,histFileMod.F90,program_csm.F90,clm_atmlnd.F90,clm_csmMod.F90,surfFileMod.F90,controlMod.F90,clm_varctl.F90,initGridCellsMod.F90,MCT_lnd_comp.F90,program_off.F90,domainMod.F90,decompMod.F90,areaMod.F90,clmtype.F90
src/biogeophys/SurfaceAlbedoMod.F90

Code changes:
add pftm to domain datatype and history file
modify program_off and program_cs to use clm_init[1,2], clm_run[1,2]
modify coupling to handle coarse <-> finemesh for standlaone, cam, and
  ccsm.
modify Makefile so depends file is reset whenever there is a code change
add normalized area to history files
add lat_a, lon_a, latdeg_a, londeg_a to clm3 datatype for atm lats/lons.  
  required in SurfaceAlbedo computation where the the zenith angle has
  to be based on the atm (coarse) grid, not the fine clm grid.
merge with clm3_expa_53_brnchT_cam01 tag
	
Summary of testing:

  bluesky: clm full suite bfb, cam full suite bfb, ccsm bfb
  tempest: cam full suite bfb
  bangkok/lf95: cam full suite bfb

CLM tag used for the baseline comparison tests if applicable: clm3_expa_55

IF tag changes answers relative to baseline comparison the
following should be filled in: bfb

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff? bfb

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
Tag name: clm3_expa_55
Originator(s): Peter Thornton
Date: 24 Jan 2006
One-line Summary: Fixes for 13C isotope code, migration from cvs

Purpose of changes:

Bugs fixed (include bugzilla ID):

Describe any changes made to build system:

Describe any changes made to the namelist:

List any changes to the defaults for the boundary datasets:

Describe any substantial timing or memory changes:

Code reviewed by: myself

List all subroutines eliminated:

List all subroutines added and what they do:

List all existing files that have been modified, and describe the changes:
Files modified:
1. CNFireMod.F90
Added initialization of variable mep.

2. CNrestMod.F90
Added EXIT_SPINUP controls on column-level 13C pools

3. C13SummaryMod.F90
Added current and excess maintenance respiration terms to summary MR variable.

4. CNC13FluxMod.F90
Added new routines to calculate 13C fluxes. Litter to column, non-mortality fluxes
at the column level, pft-level gap mortality fluxes, pft and column level fire mortality fluxes,

5. CNEcosystemDynMod.F90
Added calls for C13Flux2, C13Flux3, C13StateUpdate2, and C13StateUpdate3.

6. clm_varcon.F90
Added parameters to define a fixed pre_industrial del13C (set to -6 permil)

Summary of testing:

  bluesky:
  tempest:
  bangkok/lf95:

CLM tag used for the baseline comparison tests if applicable: clm3_expa_40

IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

Changes answers for CN only, and then only for the isotope prognostics.

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
http://www.cgd.ucar.edu/tss/clm/diagnostics/clm3cn/c13/ccsm3_bgc31_I_2a-ccsm3_bgc26_I_1d/setsIndex.html
===============================================================
Tag name: clm3_expa_54
Originator(s): Tony Craig
Date: 17 Jan 2006
One-line Summary: Update infrastructure in support of finemesh, migration from cvs

Purpose of changes: bfb infrastructure changes committed, partial step towards finemesh implementation

Bugs fixed (include bugzilla ID): None

Describe any changes made to build system: None

Describe any changes made to the namelist: None

List any changes to the defaults for the boundary datasets: None

Describe any substantial timing or memory changes: Some memory added for extra coarse grid, atmosphere domain, as well as changes to interpolation datatypes and code.  Redundant memory deleted from some datasets.

Code reviewed by: Mariana Vertenstein

List all subroutines eliminated: 

List all subroutines added and what they do:

List all existing files that have been modified, and describe the changes:

src/main:
initGridIndexMod.F90,lnd2atmMod.F90,CNiniTimeVar.F90,abortutils.F90,clm_comp.F90,driver.F90,clm_camMod.F90,atmdrvMod.F90,subgridRestMod.F90,accFldsMod.F90,clmtypeInitMod.F90,initializeMod.F90,pftdynMod.F90,iniTimeConst.F90,histFileMod.F90,program_csm.F90,clm_atmlnd.F90,clm_varsur.F90,clm_csmMod.F90,restFileMod.F90,surfFileMod.F90,controlMod.F90,initSurfAlbMod.F90,initSubgridMod.F90,clm_varctl.F90,ndepFileMod.F90,initGridCellsMod.F90,MCT_lnd_comp.F90,program_off.F90,domainMod.F90,decompMod.F90,areaMod.F90,clmtype.F90,histFldsMod.F90

src/riverroute:
RtmMod.F90

src/biogeochem:
CASAMod.F90,DUSTMod.F90,CNPhenologyMod.F90,STATICEcosysDynMod.F90,DGVMMod.F90,CNrestMod.F90,VOCEmissionMod.F90,CNNDynamicsMod.F90,CNVegStructUpdateMod.F90

src/biogeophys:
BalanceCheckMod.F90,SurfaceRadiationMod.F90,SoilTemperatureMod.F90,Biogeophysics1Mod.F90,Biogeophysics2Mod.F90,FrictionVelocityMod.F90,Hydrology1Mod.F90,Hydrology2Mod.F90,BiogeophysicsLakeMod.F90,HydrologyLakeMod.F90,BareGroundFluxesMod.F90,CanopyFluxesMod.F90

bld/offline/tests:
CLM_lab.pm,test_batch.csh
	
tools/mksurfdata:
mkdynpftMod.F90,mkgridMod.F90,shr_timer_mod.F90,mklaiMod.F90,mkglacier.F90,mkurban.F90,fileutils.F90,mksoitex.F90,mkfileMod.F90,domainMod.F90,areaMod.F90,creategridMod.F90,mkvarsur.F90,mksrfdat.F90,nanMod.F90,mklanwat.F90,mksoicol.F90,Makefile,mkpftMod.F90

tools/mkgriddata:
mkvarctl.F90,fileutils.F90,mkgriddata.F90,mkfileMod.F90,domainMod.F90,areaMod.F90,creategridMod.F90,mkvarsur.F90,nanMod.F90,Makefile

Code changes:
Merge atm2lnd_state_type, atm2lnd_flux_type.  Same for lnd2atm state/flux.
  Related changes in clm3 and elsewhere in code.
Add domainMod.F90 and domain_type.  Migrate grid data into domain type.
  Instantiate adomain(atm/coarse), ldomain(lnd/finemesh), rdomain(rtm),
  ddomain(atmdrv external data) in model.
Add lats, latn, lonw, lone 2d arrays and associated code changes.
Cleanup areaMod.F90; merging subroutines, removing redundant code, eliminate
  *_point routines.
Remove numlon
Add decomp_type for gcelldc and gcellsn.  Remove redundant data in other
  arrays related to addressing physical space and logical space.
Clean up interface in set_landunit subroutines.  Remove redundant code.
Clean up procs and clumps datatypes, removing redundant data.
Migrate clm3 topology data to pointers from copies
Add gridmap_type for interpolation and associated code and routines to
  support the type.
Add clm_atmlnd.F90 file for upscale/downscale code.  Add clm_mapa2l
  and clm_mapl2a to carry out mapping associated with upscale/downscale.
Add gridmap_setmapsFM for generation of weights for downscale/upscale
  routines.
forc_ndep should not be in atm2lnd_type.
Reuse code as much as possible throughout.
Update mksurfdata, mkgriddata.  Speed code up, bfb, new fields added,
  new input options for files.  Fill with wetland, add PFTDATA_MASK
  field for real/fake land.
Update code to clm3_expa_53
Rename latixy and longxy to latc and lonc.
Remove fullgrid attribute.

Summary of testing:

  bluesky: full clm test, full cam test
  tempest: full cam test
  bangkok/lf95: full cam test

CLM tag used for the baseline comparison tests if applicable: clm3_expa_53

IF tag changes answers relative to baseline comparison the
following should be filled in:  bfb

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff? bfb

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
	
Tag name: clm3_expa_53
Originator(s): Mariana Vertenstein
Date: Fri Dec.16 2005
One-line Summary: Put in MCT communication for cam-clm coupling

Purpose of changes: removed lp_coupling communication and put in
MCT communication interfaces

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none
	
Describe any changes made to the namelist: none

List any changes to the defaults for the input datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: Mariana Vertenstein, Rob Jacob
	
List all subroutines eliminated: none

List all subroutines added and what they do: 
  main/MCT_atmlnd_cpl.F90  
     clm/cam MCT coupling interface - will be moved out of clm code in
     near future	
  main/MCT_lnd_comp.F90
     clm MCT wrapper layer
  main/clm_comp.F90
     module containing wrapper routines that separate clm into chunks of
     code that contain no communication (e.g. clm_run1, clm_run2 has no
     communicaiton). This is needed to satisfy requirement for implementing
     multiple coupling interfaces (e.g. concurrent/MCT, sequential/MCT,
     sequential/ESMF) within ccsm.	
  main/clm_varorb.F90	
     module for orbital parameters 
    (this will be added to program_off.F90 and program_csm.F90)
	
List all existing files that have been modified, and describe the changes:
    clm_camMod.F90 - all coupling still exists here

Summary of testing:
	
  bluesky:
  test-model.pl -res T31      
  test-model.pl -res T31cn    
  test-model.pl -res T31cnall 
  test-model.pl -res T31casa  
  test-model.pl -res T31dgvm  
	
  tempest: No testing

  bangkok/lf95: No testing

CLM tag used for the baseline comparison tests if applicable: clm3_expa_48
  results were bfb with clm3_expa48	
	
IF tag changes answers relative to baseline comparison the
following should be filled in:

  Summarize any changes to answers, i.e.,
    - what code configurations:
    - what platforms/compilers:
    - nature of change (roundoff; larger than roundoff/same climate; new climate): 

   If bitwise differences were observed, how did you show they were no worse
   than roundoff?

   If this tag changes climate describe the run(s) done to evaluate the new
   climate in enough detail that it(they) could be reproduced, i.e.,
   - source tag (all code used must be in the repository):
   - platform/compilers:
   - configuration (CPP ifdefs):
   - build-namelist command (or complete namelist):
   - MSS location of output:

   MSS location of control simulations used to validate new climate:
   
   URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
	
Tag name: clm3_expa_52
Originator(s): Mariana Vertenstein
Date: Tues Dec.12 2005
One-line Summary: Put in scam fix needed in CAM mode

Purpose of changes: clean up svn clm structure

Bugs fixed (include bugzilla ID):

Describe any changes made to build system:
None
	
Describe any changes made to the namelist:
None

List any changes to the defaults for the input datasets:
None

Describe any substantial timing or memory changes:
None

Code reviewed by:
Mariana Vertenstein
	
List all subroutines eliminated:
None

List all subroutines added and what they do:
None

List all existing files that have been modified, and describe the changes:
clm_camMod.F90 (this change was put into cam3_2_41)

Summary of testing:
No testing done

CLM tag used for the baseline comparison tests if applicable:
NA
	
IF tag changes answers relative to baseline comparison the
following should be filled in:

Summarize any changes to answers, i.e.,
 - what code configurations:
 - what platforms/compilers:
 - nature of change (roundoff; larger than roundoff/same climate; new climate): 

If bitwise differences were observed, how did you show they were no worse
than roundoff?

If this tag changes climate describe the run(s) done to evaluate the new
climate in enough detail that it(they) could be reproduced, i.e.,
 - source tag (all code used must be in the repository):
 - platform/compilers:
 - configuration (CPP ifdefs):
 - build-namelist command (or complete namelist):
 - MSS location of output:

MSS location of control simulations used to validate new climate:

URL for LMWG diagnostics output used to validate new climate:
	
===============================================================
	
Tag name:  clm3_expa_51
Originator(s): mvr
Date: Tues Dec.12 2005
One-line Summary: removed src/utils dir

Purpose of changes: should've been done with external setup in prev tag

Bugs fixed (include bugzilla ID): none

Describe any changes made to build system: none

Describe any changes made to the namelist: none

List any changes to the defaults for the input datasets: none

Describe any substantial timing or memory changes: none

Code reviewed by: mvr, mvertens

List all subroutines eliminated: 
D      src/utils

List all subroutines added and what they do: 
none

List all existing files that have been modified, and describe the changes:
none
	
Summary of testing:

bluesky: none
tempest: none
bangkok/lf95: none

CLM tag used for the baseline comparison tests if applicable:

IF tag changes answers relative to baseline comparison the
following should be filled in:

Summarize any changes to answers, i.e.,
 - what code configurations:
 - what platforms/compilers:
 - nature of change (roundoff; larger than roundoff/same climate; new climate):

If bitwise differences were observed, how did you show they were no worse
than roundoff? b4b

If this tag changes climate describe the run(s) done to evaluate the new
climate in enough detail that it(they) could be reproduced, i.e.,
 - source tag (all code used must be in the repository):
 - platform/compilers:
 - configuration (CPP ifdefs):
 - build-namelist command (or complete namelist):
 - MSS location of output:

MSS location of control simulations used to validate new climate:

URL for LMWG diagnostics output used to validate new climate:

===============================================================
Tag name: clm3_expa_50
Originator(s): Mariana Vertenstein
Date: Tues Dec.12 2005
One-line Summary: Updated external definitions for utils

Purpose of changes: clean up svn clm structure

Bugs fixed (include bugzilla ID):

Describe any changes made to build system:
None
	
Describe any changes made to the namelist:
None

List any changes to the defaults for the input datasets:
None

Describe any substantial timing or memory changes:
None

Code reviewed by:
NA
	
List all subroutines eliminated:
None

List all subroutines added and what they do:
None

List all existing files that have been modified, and describe the changes:
None

Summary of testing:
No testing done

CLM tag used for the baseline comparison tests if applicable:
NA
	
IF tag changes answers relative to baseline comparison the
following should be filled in:

Summarize any changes to answers, i.e.,
 - what code configurations:
 - what platforms/compilers:
 - nature of change (roundoff; larger than roundoff/same climate; new climate): 

If bitwise differences were observed, how did you show they were no worse
than roundoff?

If this tag changes climate describe the run(s) done to evaluate the new
climate in enough detail that it(they) could be reproduced, i.e.,
 - source tag (all code used must be in the repository):
 - platform/compilers:
 - configuration (CPP ifdefs):
 - build-namelist command (or complete namelist):
 - MSS location of output:

MSS location of control simulations used to validate new climate:

URL for LMWG diagnostics output used to validate new climate:

===============================================================
	
Tag name: clm3_expa_49
Originator(s): Mariana Vertenstein
Date: Mon Dec 12 2005
One-line Summary: Updated clm with changes put into cam3_2_38

Purpose of changes:
Cray-X1E OpenMP/CSD compatibility modifications.
	
Bugs fixed (include bugzilla ID): 
None

Describe any changes made to build system:
None	
	
Describe any changes made to the namelist:
None	
	
List any changes to the defaults for the input datasets:
None	
	
Describe any substantial timing or memory changes:
None	
	
Code reviewed by:
Mariana Vertenstein	
	
List all subroutines eliminated:
None
	
List all subroutines added and what they do:
None
	
List all existing files that have been modified, and describe the changes:
- Allowed coexistence of OpenMP and CSD's on Cray-X1E provided they do not operate
  on same loop index
- Removed nested OpenMP capability
	
src/main: 
   areaMod.F90
   driver.F90
   histFileMod.F90
   atmdrvMod.F90
	
src/riverroute: 
   RtmMod.F90
	
tools/mksurfdata
   mkdynpftMod.F90 
   mklaiMod.F90 
   mkpftMod.F90 
   mksoitex.F90
   mkglacier.F90
   mklanwat.F90
   mksoicol.F90
   mkurban.F90
	
Summary of testing:

bluesky:
test-model.pl -res T31      
test-model.pl -res T31cn    
test-model.pl -res T31cnall 
test-model.pl -res T31casa  
test-model.pl -res T31dgvm  
	
tempest: No testing

bangkok/lf95: No testing

CLM tag used for the baseline comparison tests if applicable:
clm3_expa_48 (results were bfb)	
	
IF tag changes answers relative to baseline comparison the
following should be filled in:
	
Summarize any changes to answers, i.e.,
 - what code configurations:
 - what platforms/compilers:
 - nature of change (roundoff; larger than roundoff/same climate; new climate): 
	
If bitwise differences were observed, how did you show they were no worse
than roundoff?

If this tag changes climate describe the run(s) done to evaluate the new
climate in enough detail that it(they) could be reproduced, i.e.,
  - source tag (all code used must be in the repository):
  - platform/compilers:
  - configuration (CPP ifdefs):
  - build-namelist command (or complete namelist):
  - MSS location of output:
	
MSS location of control simulations used to validate new climate:
	
URL for LMWG diagnostics output used to validate new climate:
	
===============================================================

clm3_expa_48
Originator: forrest (Forrest Hoffman)
Date: Fri Dec  2 06:50:57 MST 2005
Model: CLM
Version: CLM3.expa.48
One-line Summary: Added bug fix for reading TpoolC in CASA, split long line in DGVM, and modified Makefiles for Cray X1E
Requires change in build system: yes
Modified Makefile for the Cray X1E and the newcprnc build
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM (cheetah)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:

1. Fixed TpoolC initialization not to overwrite pools if they were read from
   initial dataset.
2. Split a long line in DGVMEstablishmentMod.F90
3. Updated Makefile for Cray X1E
4. Updated test system for use on Cray X1E and changed netCDF path for ORNL IBM
5. Replaced cprnc.f90 with cprnc.F90 in newcprnc and modified its Makefile to
   use CPP for this file.  NOTE: This was tested only on the IBM and Cray X1E,
   and may require minor Makefile modifications for other platforms.

Ran the following tests on IBM (cheetah):
./test-model.pl -res T31      -c $HOME/CCSM/clm3_expa_47
./test-model.pl -res T31cn    -c $HOME/CCSM/clm3_expa_47
./test-model.pl -res T31cnall -c $HOME/CCSM/clm3_expa_47
./test-model.pl -res T31casa  -c $HOME/CCSM/clm3_expa_47

===============================================================

clm3_expa_47
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Nov 25 10:26:47 MST 2005
Model: CLM
Version: CLM3.expa.47
One-line Summary: updated to wrf esmf time manager interfaces
Requires change in build system: yes
Makefile is modified	
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
1) Update offline clm to new wrf esmf time manager interfaces.
   This change has already been made in the cam code base.
   This change also implies that the ESMF prototye time manager code
   is no longer needed. The new time manager interfaces are identical
   to the latest ESMF library. 	   
2) Testing done:
   Verified that the following tests passed and were also bfb 
   with clm3_expa_46.
   ./test-model.pl -res T31      
   ./test-model.pl -res T31cn    
   ./test-model.pl -res T31cnall 
   ./test-model.pl -res T31casa  
   Note - CCSM testing with this code base must still be done.	
===============================================================
	
===============================================================

clm3_expa_46
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Nov 11 12:50:40 MST 2005
Model: CLM
Version: CLM3.expa.46
One-line Summary: put in change to csoilc and change in CanopyFluxesMod.F90
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: none
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: Yes (new-physics)
Changes made:

1) The following two coding changes were made
In CanopyFluxesMod.F90

  w = exp(-2*(elai(p)+esai(p)))  
     changed to 
  w = exp(-(elai(p)+esai(p)))

In clm_varcon.F90

   real(r8) :: csoilc = 0.0025   !Drag coefficient for soil under canopy
      changed to 
   real(r8) :: csoilc = 0.004    !Drag coefficient for soil under canopy

2) The following simulation documents the changes 
   (relative to the clm3 release)- see:

http://www.cgd.ucar.edu/ccr/dlawren/research/hydrology/vh_ncs_lai-hyd_cona/sets.htm
	
   hyd_cona  : is the released version of clm3
   vh_ncs_lai: is new hydrology without csoil changes with new lai dataset
	
(contact David Lawrence for more details)	
	
3) No other tests were run since the changes were so straightforward
===============================================================
	
===============================================================

clm3_expa_45
Originator: mvertens ( Mariana Vertenstein)
Date: Wed Oct 26 15:13:28 MDT 2005
Model: CLM
Version: CLM3.expa.45
One-line Summary: updated to share3_051025 and ESMF_0_0_8 and modified clm_camMod.F90
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Mat Rothstein
Changes answers: no (bit-for-bit) 
Name of tests cases on NCAR Mass-Store: 
  see following diagnostic output for cam control simulation
	
     /MVERTENS/csm/cam3_2_29_fv4x5dom (cam3_2_29 with changes to clm_camMod.F90)
         vs 
      /MVERTENs/csm/cam3_2_29_cam3_2_29_fv4x5dom_0 (cam3_2_29 with no changes)

      http://www.cgd.ucar.edu/~mvertens/AMWG_diag/cam3229_fv4x5dom-cam3229_fv4x5dom_0/
         and also comparison relative to last fv control run done:
      http://www.cgd.ucar.edu/~mvertens/AMWG_diag/cam3_2_29_fv4x5dom-cam321_fv4x5dom_1

1)Modified clm_camMod.F90 so that cam and clm grid do not have to be bfb. 
  The tolerance is that the grid latitudes/longitudes grids match to 1.e-12. 
o  The fractional land however, must be identical.
2) updated csm_share to share3_051025 (this removes need for autopromotion)
   in share code and modified clm Makefiles to remove autopromotion	
3) updated esmf prototype code to ESMF_0_0_8	
4) Testing done (following tests passed successfully)
 ./test-model.pl -res T31cnall -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_44
 ./test-model.pl -res T31      -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_44
 ./test-model.pl -res T31cn    -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_44
===============================================================
	
===============================================================

clm3_expa_44
Originator: mvertens ( Mariana Vertenstein)
Date: Mon Oct 17 09:49:04 MDT 2005
Model: CLM
Version: CLM3.expa.44
One-line Summary: fixed bug in initializeMod.F90 for linux systems
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM, SGI, Linux
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
1) Fixed bug in initializeMod.F90 so that all cam tests could
   pass on linux platform. This was done as part of the cam3_2_28
   checkin.	
	
===============================================================
===============================================================

clm3_expa_43
Originator: mvertens ( Mariana Vertenstein)
Date: Thu Oct 13 20:25:37 MDT 2005
Model: CLM
Version: CLM3.expa.43
One-line Summary: put in fixes to get all cam tests working and bfb with basline cam
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM, SGI, Linux
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
1) Put in changes to cam_clmMod.F90 to reset the clm grid
to the cam grid. This was done to ensure bfb answers. Given
the number of interface changes that went into clm3_expa_42,
it seemed that isolating the effects of permitting clm to have
a grid that was roundoff level different should be done.
Only a few lines of code need to be changed in order to remove
this restriction. A climate simulation will be done to verify
the effect of permitting grid independence to the roundoff level.
2) Put in fixe to restFileMod.F90 to get cam branch test to
work on tempest.
3) Files changed:
   clm_camMod.F90
   inicFileMod.F90
   restFileMod.F90
4) Testing done - ran cam test-driver.sh with cam3_2_25 and clm3_expa_43 
on bluesky, tempest and bangkok with BL_ROOT=cam3_2_24.	All tests passed
successfully.	
===============================================================
	
===============================================================

clm3_expa_42
Originator: mvertens ( Mariana Vertenstein)
Date: Tue Oct 11 09:21:49 MDT 2005
Model: CLM
Version: CLM3.expa.42
One-line Summary: put in changes to remove need for autopromotion of floats
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Changes made:

1) Nearly every file in CLM was modified in order to 
explicitly type variables and constants in order to 
enable the removal of autopromotion of reals in the Makefile.
Note that this change was already incorporated into the clm
version corresponding to cam3_2_23.

Tom Henderson's tool "addrealkind" was used to change "real"
declarations to "real(r8)" and to add "_r8" to all floating
point constants that were not already typed. These changes
were not incorporated into csm_share or utils/esmf.

2) Updated clm_camMod.F90 so that it was consistent with cam3_2_23.
Put in a tentative change to clm_cam_CheckGrid routine so that
BFB changes with the current version of cam could be produced.
Effectively, the cam grid still overrides the clm grid, even
though the differences in the grids were only on the order of
1.e-13 for latitudes (no differences in longitudes). A climate simulation
will have to be done to verify that making the grids independent does
not change the climate.

3) Testing done	
   Ran the following tests successfully:	 
 ./test-model.pl -res T31cnall -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_41
 ./test-model.pl -res T31      -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_41
 ./test-model.pl -res T31cn    -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_41
 ./test-model.pl -res T31casa  -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_41
 ./test-model.pl -res T31dgvm
===============================================================
	
===============================================================

clm3_expa_41
Originator: mvertens ( Mariana Vertenstein)
Date: Sun Oct  2 12:51:03 MDT 2005
Model: CLM
Version: CLM3.expa.41
One-line Summary: changed and simplified clm/cpl6 initializaiton
Requires change in build system: no
Tested to work coupled with CCSM: yes (Tony Craig)
Tested to work with CAM: no
Machines tested: IBM, SGI
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Tony Craig
Changes answers: no (bit-for-bit)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:
	
1) CLM/CPL6 initialization has been changed so that clm no longer
receives the grid and landfrac/landmask from the coupler, but rather
reads it in from its surface dataset and sends it to the coupler.
The coupler in turn then checks for consistency between the land/atm
grid and the land fractions received.
As part of this, an offline tool has now been constructed by Tony
Craig that will generate the landfrac and grid appropriate for running
on a given ocn/atm resoloution. CLM now no longer will permit fsurdat
to be set to blanks.	
The following files were modified:
    main/clm_csmMod.F90
    main/driver.F90
    main/program_csm.F90
    main/histFileMod.F90	
    biogeochem/DGVMMod.F90	

2) tools/mksurfdata has been modified so that grids can only be
   read in for the purposes of generating surface datasets. A
   new directory - tools/mkgriddata - has been created to enable
   the generation of regular offline clm grids. The functionality
   of grid generation and surface dataset generation has thereby
   been separated. There are complete README files in both directories
   that specify the new namelist settings for generating surface
   datasets and grids.	
	
3) Testing done:
   ran test-model.pl -c clm3_expa_40 and verifed that results were
   bfb in the default non-CN case. Further testing in coupled mode
   will be done by Tony Craig.
	
===============================================================
===============================================================

clm3_expa_40
Originator: jeff ( Yen-Huei Lee)
Date: Thu Sep 29 15:26:28 MDT 2005
Model: CLM
Version: CLM3.expa.40
One-line Summary: bug fix restFilemod.F90
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Compaq
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:

 

===============================================================
===============================================================
clm3_expa_39
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Sep  9 13:55:43 MDT 2005
Model: CLM
Version: CLM3.expa.39
One-line Summary: made restart files netcdf
Requires change in build system: no
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
	
1) Made all restart data netcdf - EXCEPT for history file restarts
   (this still binary - they are used for restart runs only, not for branch runs).
   The effect of this change is that inicFileMod.F90 now only contains code for
   doing perpetual runs in CAM mode.
   Initial files and restart files are still written - but they are the same - 
   ****EXCEPT FOR THE TIME STEP AT WHICH THE ARE OUTPUT***.

   In the current code, the restart file
        casename.clm2.r.1998-01-01-00000.nc
   is written on model date 1998-01-01-00000, whereas the initial file
        casename.clm2.r.1998-01-01-00000.nc 
   is written on model date 1997-12-31-84600 

   There is a fundamental difference between restart runs and initial runs in clm.
   On a restart run (assuming 1800 sec time steps), the restart file 
        casename.clm2.r.1998-01-01-00000.nc
   will be used to determine the time step 
        1998-01-01-01800 
   whereas on an initial run the same restart file (for this tag) will be 
   used to determine the timestep
        1998-01-01-00000
   This is because the restart code increments the time step as part 
   (by calling advance_timestep()) as part of the time manager initialization.
   Note that when running in OFFLINE mode, clm also increments the time step
   for an initial run, so that all initial runs start at time step 1. In 
   CAM and CSM mode, all initial runs start at time step 0. 

   -----------------------------------------------------------------
   THE FOLLOWING THINGS ARE IMPORTANT TO NOTE:
   -----------------------------------------------------------------

   o) initsurfalb will be called either when nsrest is 0 if:
      - finidat = ' ' 
      - finidat /= ' ' and albd and albi are not on the initial (or restart) dataset

   o) restart and initial datasets can now be used interchangeably to start up a run
      Assuming you wanted to start up a run at 1998-01-01-00000 from another run
      with case "casename"
      a) Initial runs: finidat should point to 
        - the restart dataset casename.clm2.r.1998-01-01-00000.nc in OFFLINE mode
          (this would have been written out at 1999-01-01-00000)
        - the initial dataset casename.clm2.i.1998-01-01-00000.nc in CAM or CSM mode
          (this would have been written out at 1997-12-31-84600)
      b) Branch runs: nrevsn should point to 
        - the resart filename (CURRENTLY WITHOUT the .nc suffix)
         (this was done to maintain backwards compatibility) 

   o) The current code base is completly backwards compatible with older versions
      of the code in terms of doing intitial runs. It is NOT backwards compatible with restart
      files produced by older versions of the code. 

2) The following routines were changed.

      biogeochem/CNrestMod.F90         (added)
      biogeochem/DGVMMod.F90
      biogeochem/DGVMRestMod.F90
      biogeophys/BiogeophysRestMod.F90 (added)
      main/CNrestMod.F90               (removed)
      main/abortutils.F90
      main/accFldsMod.F90
      main/accumulMod.F90
      main/Attic/clm_camMod.F90
      main/clm_csmMod.F90
      main/controlMod.F90
      main/driver.F90
      main/histFileMod.F90
      main/Attic/histFldsMod.F90
      main/inicFileMod.F90
      main/Attic/initSurfAlbMod.F90
      main/initializeMod.F90
      main/Attic/ncdio.F90
      main/program_csm.F90
      main/program_off.F90
      main/restFileMod.F90
      main/subgridRestMod.F90           (added)
      main/Attic/time_manager.F90
      riverroute/RtmMod.F90
      riverroute/Attic/RunoffMod.F90

3) The automated tests were modified to now run both CASA and DGVM.
   (A new DGVM control run needs to be performed).
   Ran the following tests successfully:

  Offline:
  -------------------
  ./test-model.pl -res T31cnall -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_38
  ./test-model.pl -res T31      -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_38
  ./test-model.pl -res T31cn    -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_38
  ./test-model.pl -res T31casa  -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_38
  ./test-model.pl -res T31dgvm  

  Note that ./test-model.pl -res T31cnall now points to finidat obtained from the CCSM
  BGC case ccsm3_bgc19_F_2: ccsm3_bgc19_F_2.clm2.i.1900-01-01-00000.c050905.nc
  This initial dataset does not contain all the information that an initial dataset 
  produced by clm3_expa_19 would have. 

  CCSM:
  -------------------
  Checked out two versions of the ccsm tag ccsm3_0_brnchT_bgc19 tags and updated
  the clm version in one checkout to clm3_expa_38 and the other to clm3_expa_39.
  Created two test cases 
        ccsm3_bgc19_F_2_mod1 - used ccsm3_0_brnchT_bgc19 with clm3_expa_38 clm
        ccsm3_bgc19_F_2_mod2 - used ccsm3_0_brnchT_bgc19 with clm3_expa_39 clm
  Verified that running the output after a month was bfb with the two cases.
  (Note that ccsm3_bgc_19 will not give bit-for-bit with 
  ccsm3_0_brnchT_bgc19 with clm3_expa_38 clm - this needs to be looked into).
  Also verified that ccsm3_bgc19_F_2_mod2 gave bfb restarts (ran 1 month, restarted
  and ran another month).
      	
	
===============================================================
===============================================================

clm3_expa_38
Originator: thornton ( Peter Thornton)
Date: Wed Aug 17 10:21:19 MDT 2005
Model: CLM
Version: CLM3.expa.38
One-line Summary: Added C13 isotopes to CN code
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Neil Suits
Changes answers: the non-isotope results are bit-for-bit against clm3_expa_37, 
	except that the variable xsmrpool has been added as a new carbon state
        variable, replacing some of the functionality of the cpool variable.
        So comparisons against clm3_expa_37 will differ in cpool, but this 
        does not change the behavior of the rest of the prognostic pools. 
Changes made:
This work was carried out by Peter Thornton and Neil Suits over multiple
working sessions during summer 2005. 
The following files were modified to include C13 isotopes:
 1. biogeochem/CNAllocationMod.F90
 2. biogeochem/CNBalanceCheckMod.F90
 3. biogeochem/CNCStateUpdate1Mod.F90
 4. biogeochem/CNDecompMod.F90
 5. biogeochem/CNEcosystemDynMod.F90
 6. biogeochem/CNPrecisionControlMod.F90
 7. biogeochem/CNSetValueMod.F90
 8. biogeochem/CNSummaryMod.F90
 9. biogeochem/C13SummaryMod.F90
10. biogeochem/CNC13FluxMod.F90
11. biogeochem/CNC13StateUpdate1Mod.F90
12. biogeochem/CNC13StateUpdate2Mod.F90
13. biogeochem/CNC13StateUpdate3Mod.F90
14. biogeophys/BareGroundFluxesMod.F90
15. biogeophys/CanopyFluxesMod.F90
16. csm_share/shr/shr_const_mod.F90
17. main/CNiniSpecial.F90
18. main/CNiniTimeVar.F90
19. main/CNrestMod.F90
20. main/atmdrvMod.F90
21. main/clm_camMod.F90
22. main/clm_csmMod.F90
23. main/clm_varcon.F90
24. main/clmtype.F90
25. main/clmtypeInitMod.F90
26. main/histFldsMod.F90

The overall logic was to add new instances of the carbon state and carbon flux
derived types at the pft and column level to hold the c13 variables.
Discrimination is calcualted in CanopyFluxes(), and the state variable update
routines are based on the C13/(C13+C12) ratios for the upstream pools.  There
is now a C13 state and C13 flux associated with each of the origianl C state
and C flux variables. A number of new pps and pepv variables have also been
added as diagnostics for the C13 discrimination during assimilation.

This code passed the clm offline test suite as:
test-model.pl -res T31 -c clm3_expa_37
whith the caveat as above for bfb comparisons against expa_37 for cpool.

 
===============================================================
===============================================================

clm3_expa_37
Originator: thornton ( Peter Thornton)
Date: Thu Aug 11 12:37:40 MDT 2005
Model: CLM
Version: CLM3.expa.37
One-line Summary: CN hydrology mods and a few other C4MIP mods
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit:yes 
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes for CN, no for non-CN
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:
1. Added CN control in CanopyFluxesMod.F90 to use the original formulation for local variable w in calculation of csoilcn.
2. Added CN control in clm_varcon.F90 to use original value of csoilc (0.004)
3. Added CN control to SurfaceRunoff() in SoilHydrologyMod.F90 to eliminate the use of infiltration enhancement factor.
4. Modified CNFireMod.F90 to set the number of steps for fire period averaging to its maximum value from the start of the run. Avoids transient fire algorithm behavior at the start of a new run launching from spun-up initial conditions.

Tested with: 
test-model.pl -res T31cnoff -c clm3_expa_36 (passed)
test-model.pl -res T31 (passed)


===============================================================
===============================================================

clm3_expa_36
Originator: forrest (Forrest Hoffman)
Date: Thu Jul 21 13:26:51 MDT 2005
Model: CLM
Version: CLM3.expa.36
One-line Summary: Modified PLAI and PET calculations in CASA' and made minor bug fixes
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: yes, on Cray X1E (phoenix)
Tested to work with CAM: no
Machines tested: IBM (cheetah)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes for CASA' only (same-physics)
Name of tests cases on NCAR Mass-Store:
Changes made:

1. Fix PLAI calculation in CASA'
   Added an initialization of stress factors in CASAPhenology for every
   timestep.
2. Fix PET calculate in CASA'
   Changed surface pressure variable used to forc_pbot which is required for
   CCSM configuration.  Moved the call to CASAPot_Evptr back down into casa()
   subroutine because of a bug on the Cray X1E which caused crashes in some
   configurations.
3. Moved calculation of watopt, watdry, sz, watoptc, watdryc, and szc for
   CASA' to initCASA() since they need to be calculated only once.
4. Removed nstep>1 requirement for CASA' routines by moving them to a later
   stage in driver (after Biogeophysics2).
5. Moved a vector directive in CASAMod.
6. Broke two long lines (write statements) in clm_csmMod which cause problems
   for the Cray compilers.
7. Replaced the second t_startf() around the call to driver2() in program_csm
   to a t_stopf().

Ran test-model on IBM (cheetah) for T31cnoff, T31cnoffallpfts, T31, and
T31allpfts.

===============================================================
===============================================================

clm3_expa_35
Originator: mvertens ( Mariana Vertenstein)
Date: Tue May 31 11:25:06 MDT 2005
Model: CLM
Version: CLM3.expa.35
One-line Summary: bug fixes 
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: kyesno
Code reviewed by: myself
Changes answers: no (bit-for-bit) (see below)
Changes made:
1) clm_csmMod.F90 - changed error check for differences in landfrac to
   not stop if differences are greater than 1.e-12 and the landfrac is
   smaller than 1.e-8.
2) clm_camMod.F90 - replaced all_to_all with all2all in lp_coupling
   subroutines due to character length limitations of subroutine names
   on sgi (tempest)
3) iniTimeConst.F90, surfFileMod.F90 - put in bug fixes for SCAM mode 
4) mkarbinitMod.F90 - put in bug fix for soilpsi calculation that
   only occurs for CN mode
5) modified many of the  routines in tools/mksurfdata so that lsmlon
   and lsmlat are no longer parameters - but are read dynamically
   from the input grid file
6) Testing done:
   Successfully ran
   test-model.pl -res T31cnoff   -c clm3_expa_34 (bfb)
   test-model.pl -res T31        -c clm3_expa_34 (only difference was SOILPSI)
   test-model.pl -res T31allpfts -c clm3_expa_34 (only difference was SOILPSI)
===============================================================
	
===============================================================

clm3_expa_34
Originator: thornton ( Peter Thornton)
Date: Tue May 24 14:29:04 MDT 2005
Model: CLM
Version: CLM3.expa.34
One-line Summary: Limit on negative N leaching, fix units for NEE to coupler
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Compaq
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself, Jeff Lee
Changes answers: Yes (new-physics)
Changes made:
1. Added a new limit in CNNDynamicsMod.F90, CNNLeaching(), to prevent 
   negative sminn_leached fluxes.
2. Added a new conversion in clm_csmMod.F90 to put the NEE flux sent
   to the coupler from gC/m2/s to kg CO2/m2/s.
===============================================================
===============================================================
clm3_expa_33
Originator: mvertens ( Mariana Vertenstein)
Date: Wed May 11 21:07:39 MDT 2005
Model: CLM
Version: CLM3.expa.33
One-line Summary: made driver.F90 into a module with two run phases
Requires change in build system: no
Tested to work coupled with CCSM: yes (see below)
Tested to work with CAM:  yes (see below)
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) (offline) or Yes (same-to-roundoff) (cam, ccsm)
Changes made:
	
1) modified driver.F90 so that it is not a module containing
   subroutines driver1 and driver2. This is a step necessary to make
   clm an ESMF gridded component. The commmunication calls in CCSM
   mode have now been moved out of driver and into program_csm.F90.
   Routine driver1 contains the code executed between the CCSM send
   and receive calls. Routine driver2 contains the history and restart
   updates, as well as calls to the DGVM and RTM drivers (if the CPP
   tokens are defined). This involved mods to program_off.F90,
   program_csm.F90 and clm_camMod.F90.

2) modified the interface to initialize and driver so that declination
   angles and calendar day were passed in (caldayp1, declinp1) rather
   than the orbital parameters (eccen, obliqr, lambm0, mvelpp). This
   also involved mods to SurfaceAlbedo.F90 and DGVMMod.F90.

3) modified clm_camMod.f90 and program_csm.F90 so that the grid
   received from cam or the coupler would no longer overwrite the clm
   grid if differences were less than 1.e-6. Now, if differences in
   the corresponding grids are greater than 1.e-6, the model will
   stop, otherwise, the clm grid read in will be used. This leads to
   round-off level differences in cam and clm compared to the case when
   the grids were over-written.

4) Modifed clm_varsur.F90 so that external grid information was
   removed and moved to the appropriate component model.

5) Summary of modified files:
   biogeochem/DGVMMod.F90,v
   biogeophys/SurfaceAlbedoMod.F90,v
   main/clm_camMod.F90,v
   main/clm_csmMod.F90,v
   main/clm_varsur.F90,v
   main/driver.F90,v
   main/initSurfAlbMod.F90,v
   main/initializeMod.F90,v
   main/program_csm.F90,v
   main/program_off.F90,v
   main/surfFileMod.F90,v

6) Summary of testing done:

   offline testing (on bluesky - ran following tests successfully):
     test-model.pl -res T31cnoff        -c clm3_expa_31
     test-model.pl -res T31             -c clm3_expa_31
     test-model.pl -res T31allpfts      -c clm3_expa_31

   cam3_1_7 with (clm3_expa_32 with above mods): on bluesky ran
     test_driver.sh successfully and showed that results were only to
     roundoff when compared with cam3_1_7 run with clm3_expa_29

   ccsm3_0_brnchT_bgc10 with (clm3_expa_32 with above mods) on bluesky
     showed that TER.TER.01a.T31_gx3v5.I.bluesky32 passed and that
     results were only different to roundoff when compared to
     ccsm3_0_brnchT_bgc10.
	
===============================================================
===============================================================

clm3_expa_32
Originator: thornton ( Peter Thornton)
Date: Tue May 10 14:16:45 MDT 2005
Model: CLM
Version: CLM3.expa.32
One-line Summary: Mod to Surface Radiation to avoid divide-by-zero under dynamic pft
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself, Sam Levis, Mariana Vertenstein
Changes answers: no (bit-for-bit) 
Changes made:
1. A one-line change to SurfaceRadiationMod.F90, adding a new test on gdir(p)
   > 0.0 in block to assess sunlit and shaded lai.  Corrects a divide-by-zero
   problem encountered under dynamic PFTs with diagnostic (default) canopy
   model.

===============================================================
===============================================================

clm3_expa_31
Originator: thornton ( Peter Thornton)
Date: Mon May  9 12:45:03 MDT 2005
Model: CLM
Version: CLM3.expa.31
One-line Summary: migrate CN mods for C4MIP to head of branch
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit:yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers:non-CN is BFB w/ 29, CN has new physics
Changes made:
1. Mods in CNDecompMod.F90 to implement accelerated decomposition spinup
   algorithm. Also required some mods in restart read in CNrestMod.F90.
2. Mods in CNNDynamicsMod.F90 to implement new N fixation algorithm.
3. Setting the CN default CO2 concentration to the C4MIP spinup value, in 
   clm_varcon.F90.
4. Mods in surfFileMod.F90 to test for deciduous temperate types in the
   tropics, under allpfts mode.
5. Using the CLM algorithm for rresis in CanopyFluxesMod.F90, instead of
   the LSM algorithm that was introduced at tag clm3_expa_27.
6. Adopting the mods for csoilc (the mid-point mods from clm3_expa_29) for
   use in CN.
7. Adopting the surface runoff treatment introduced by David Lawrence in
   clm3_expa_27 for use in CN.  THis is slightly different than the version
   used in clm3_expa_23.
8. Passed offline test-model suite for res: T31cnoff (BFB w/ expa_29), 
   T31allpfts, and T31. 

===============================================================
===============================================================

clm3_expa_30
Originator: thornton ( Peter Thornton)
Date: Sun May  8 23:20:27 MDT 2005
Model: CLM
Version: CLM3.expa.30
One-line Summary: merge CN mods for C4MIP to head of branch
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Changes are BFB in non-CN mode, new physics in CN mode.
Changes made:
1. Due to a tagging error, clm3_expa_30 is identical with clm3_expa_29.
===============================================================
===============================================================

clm3_expa_29
Originator: mvertens ( Mariana Vertenstein)
Date: Wed May  4 14:05:30 MDT 2005
Model: CLM
Version: CLM3.expa.29
One-line Summary: incorporated csoilc changes provided by David Lawrence
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: None
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself, Peter Thornton
Changes answers: Yes (new-physics)
Changes made:
In clm_varcon.F90 changed
   old: real(r8) :: csoilc = 0.001    !Drag coefficient for soil under canopy [-]
   new: real(r8) :: csoilc = 0.0025   !Drag coefficient for soil under canopy [-]

In CanopyFluxesMod.F90 changed
   old: w = exp(-3._r8*(elai(p)+esai(p)))
   new: w = exp(-2._r8*(elai(p)+esai(p)))
===============================================================
	
===============================================================

clm3_expa_28
Originator: mvertens ( Mariana Vertenstein)
Date: Wed May  4 13:08:48 MDT 2005
Model: CLM
Version: CLM3.expa.28
One-line Summary: updated code to have different soil colors classes dependent on surface dataset
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Keith Oleson, Peter Thornton
Changes answers: no (bit-for-bit)
Changes made:
1) modified clm_varpar.F90, clm_varcon.F90 and iniTimeConst.F90 so that new and 
   old soil color classes could be used
2) modified pftdynMod.F90 to fix bug
3) modified initialize.F90 in order for CNiniTimeVar to always be called.
   (this fixes a qflx_drain not initialized problem that occured when initial files were read)
4) modified RtmMod.F90 to set tempgp and fluxout at ghost latitudes (0 and rtmlat+1) to zero.
   Thise setting assumes that the river routing data has no communication across the
   poles - this is true for the river routing file rdirc.05.
5) modified tools/mksrfdata code so that it could generate either new or old soil color classes
   based on input from raw datasets
6) changed testing scripts so that T31 tests would be done by default
7) following tests were run
   ./test-model.pl -res T31        -c clm3_expa_27
   ./test-model.pl -res T31cnoff   -c clm3_expa_27
   ./test-model.pl -res T31allpfts -c clm3_expa_27
===============================================================
	
===============================================================

clm3_expa_27
Originator: thornton ( Peter Thornton)
Date: Tue Apr 26 14:29:20 MDT 2005
Model: CLM
Version: CLM3.expa.27
One-line Summary: Mods to make sun/shade canopy and soil hydrology changes the default
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no 
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, David Lawrence
Changes answers: Yes (new-physics)
Changes made:

1. Removed old SurfaceRadiation(), and moved SurfaceRadiationSunShade() 
   to SurfaceRadiation() as the new default subroutine.  Eliminated SUNSHA cpp
   directive.
2. Removed old Stomata() and moved StomataCN() to Stomata() as the new default
   subroutine.  Eliminated STOMATA2 cpp directive.
3. Changed the default treatment of BTRAN to the LSM approach, and added watdry
   and watopt as new variables in data structure.  This was part of the suite of
   changes recommended by David Lawrence.
4. Made the simple canopy interception correction suggested by Thornton the
   default behavior (new_fpi = old_fpi * 0.25)
5. Modified csoilcn to reduce ground evaporation under canopies, as suggested
   by David Lawrence.
6. Modified drainage() to eliminate drainage from mid-layer soils, both wet
   and dry.
7. Eliminate exponential decrease in saturated hydraulic conductivity (hksat)
   with depth, change in iniTimeConst().
8. Modify surface runoff from dry soils, introducing a function of rooting
   fraction in the top three layers. Change recommended by David Lawrence.
9. Testing done: The following tests all passed:
	test-model.pl -res T42
	test-model.pl -res T42allpfts
	test-model.pl -res T42cnoff
10. These changes were also compared with the earlier simulations done by David
   Lawrence and Peter Thornton, and found to give consistent results. 
	
===============================================================
===============================================================
clm3_expa_26
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Apr 22 10:47:01 MDT 2005
Model: CLM
Version: CLM3.expa.26
One-line Summary: updated to new timing library
Requires change in build system: no
Tested to work coupled with CCSM: yes
Tested to work with CAM: yes (with cam interface changes)
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
1) Code Changes
utils/timing
   - uptdated to new timing library changes put in by Jim Rosinski
clm_camMod
   - removed parallel and streaming directives which should not be in clm-model interfaces
     (these were removed from the clm_csmMod.F90 as well)
   - moved call to radiation_get from initext.F90 to here to keep the interface simple
   - removed orbital parameters from the clm_camRun interface to keep the interface simple
clm_varcon, iniTimeConst
   - made albdry, albsat allocatable arrays and initialized them in iniTimeConst
     depending on the presence and value of mxsoil_color in the input surface dataset
controlMod, clm_varctl
   - removed csm_dtime
   - removed local time_manager variables for COUP_CAM mode and only permitted those
     to be in the namelist when running through COUP_CSM or OFFLINE mode (only local varialbe
     dtime was kept)
   - removed allocate_all_vegpfts, rank_veg_pfts as a namelist variables
     ***when maxpatch_pft is set to numpft+1 then allocate_all_vegpfts is always true***
   - removed all msrf_***_*** namelist variables
program_off, program_csm
   - removed old copyright notice
   - put in changes to be compatible with new timing library
restFileMod
   - removed get_nstep for COUP_CAM mode
   - removed csm_dtime
surfFileMod
   - put in changes of fullgrid that were introduced in cam3_0_28 to work with reduced grid
   - removed rank_veg_pfts logic and introduced allocate_all_vegpfts

2) Updated test-model.pl related code to correspond to above changes

3) Testing done
   Ran following tests successfully on bluesky:
     test-model.pl -res T42        -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_25
     test-model.pl -res T42allpfts -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_25
     test-model.pl -res T42cnoff   -c /fis/cgd/cseg/people/mvertens/src/clm/clm3_expa_25
   Ran cam testing suite on bluesky and bankgok with cam interface changes
   and this code and all tests successfully passed
===============================================================
	
===============================================================

clm3_expa_25
Originator: forrest (Forrest Hoffman)
Date: Wed Mar 30 23:47:17 MST 2005
Model: CLM
Version: CLM3.expa.25
One-line Summary: CASA' bug fixes and Cray X1 changes
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM (cheetah) and x86 Linux (anchorage)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:

Modified jobscript.csh to add selection of Programming Environment for Cray X1
and to support cross compiling.

Modified test_batch.csh to add selection of Programming Environment for Cray X1.

Fixed minor bugs in CASA' code and added co2flux variable and history field
in the CASA configuration for flux to the atmosphere (instead of re-using the
fco2 variable).

Removed CSDs around the allocation loop in filterMod.F90.

Ran test-model on IBM (cheetah) and x86 Linux (anchorage); bit-for-bit with clm3_expa_24.

===============================================================
===============================================================

clm3_expa_24
Originator: jeff ( Yen-Huei Lee)
Date: Fri Mar 18 11:01:33 MST 2005
Model: CLM
Version: CLM3.expa.24
One-line Summary: pass co2 flux to atm
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Compaq
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) or Yes (same-to-roundoff, same-physics, new-physics)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:

M /src/main/clm_csmMod.F90
M /src/main/lnd2atmMod.F90

        (Put your detailed description of the changes you made here...)
       (You will get your edited copy e-mailed to you.)

===============================================================
===============================================================

clm3_expa_23
Originator: thornton ( Peter Thornton)
Date: Thu Mar 10 11:32:02 MST 2005
Model: CLM
Version: CLM3.expa.23
One-line Summary: CLM Coupling mods to pass CO2 to CLM from CAM, through cpl6
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: Jeff Lee, Mariana Vertenstein, myself
Changes answers: no (bit-for-bit)
Changes made:

Modifications to allow passing CO2 concentration from CAM to CLM, through cpl6, in CCSM coupled mode.
1. new namelist variable in CLM: co2_type.  'constant' = use co2 value from clm_varcon.F90.  'diagnostic' = use co2 concentration passed from CAM in the co2_diag field.  'prognostic' = use CO2 concentration passed from CAM in the co2_prog field.  both co2_diag and co2_prog are 2d fields.
2. modifications to the communications code that allows passing the new fields in from CAM.
3. Tested for BFB against clm3_expa_22.

===============================================================
===============================================================

clm3_expa_22
Originator: thornton ( Peter Thornton)
Date: Fri Mar  4 14:29:36 MST 2005
Model: CLM
Version: CLM3.expa.22
One-line Summary: Changes to soil hydrology to improve plant water availability for CLM-CN
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes (new-physics)
Changes made:
1. Removed exponential decrease in saturated hydraulic condicutivity with depth (modified iniTimeConst.F90)
2. Set smpmax = -2.57e5 (=-2.5Mpa) in clmtypeInit.F90, to better agree with the observed soil water potential at stomatal closure for most trees and grasses.  The original value was -1.55e5 (=-1.5MPa), which is a wetter soil than is observed to cause complete stomatal closure for most species.  The new value is still not negative enough for drought-tolerant species like semiarid shrubs.
3. Modified the qflx_over (surface runoff) term, keeping the components unchanged that relate to impermeable and saturated soils, but turning off this flux entirely for unsaturated soils.
4. Modified the qflx_drai (drainage flux) term (in SoilHydrology) to turn off the mid-layer drainage for both saturated and unsaturated fractions.  Remaining drainage terms are for drainage out of the bottom soil layer, and for drainage in excess of saturation in any layer.
5. Changed the implementation of rooting distribution from exponential to linear, with a bottom layer specified differently for woody and non-woody vegetation.  Woody vegetation is now set to decrease rooting distribution linearly with depth, ending at zero rooting for the bottom of the last soil layer.  Non-woody vegetation also decreases rooting distribution linearly with depth, ending at zero distribution at the bottom of layer 8 (of 10).  This gives a bottom for woody vegetation at 3.43 m, and a bottom for non-woody vegetation at 1.38 m.  THis change improves the access of both trees and grasses to water in deeper soil layers, compared to the original exponential depth distribution.

===============================================================
===============================================================

clm3_expa_21
Originator: thornton ( Peter Thornton)
Date: Fri Feb 18 12:42:48 MST 2005
Model: CLM
Version: CLM3.expa.21
One-line Summary: Mods in prep for C4MIP runs: dynamic N deposition, changed N fixation, moved order of calls in driver
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes (new-physics)
Changes made:
1. Implemented dynamic N deposition through single netcdf file with annual
timeseries.  Turn on with namelist variable fndepdyn = <filename>
2. Moved call to EcosystemDyn to the end of the timestep in driver, before mass balance checks, which are before Surface Albedo.  This changes answers slightly
because soil temperature is used in CNEcosystemDyn, and is being updated in
Biogeophysics2, which used to be called after ecosystemdyn, but is now called
before. No compelling science reason for doing this one way vs the other,
but doing it this way cleans up the order of calls in driver.
3. Moved the initialization of mass balance checking to the front of the
timestep, for C and N, which was done for water in expa_17.  This is in prep
for dynamic shifting of C and N mass due to dynamic landcover information.
Note that this code does not yet implement the C and N mass shifting required 
for mass balance under dynamic pft weight.  THat will come in my next tag.
4. Modified N fixation to use a siongle global constant instead of relating
it to NPP.  This speeds up the spinup, but it leaves unresolved the problem of
hpw to dynamically estimate a value for Nfix.
5. Modified tools/mksurfdata/mkpftMod.F90 to remove the commenting around the
complete PFT list that I had put in during testing for expa_17.  This will only 
affect use of the offline tool for creating new surface datasets.

Testing done:
ran test-model on bluesky (IBM).
Did extensive testing for restart and MPI/OMP configurations with the
dynamic N deposition capability.
===============================================================
===============================================================

clm3_expa_20
Originator: mvertens ( Mariana Vertenstein)
Date: Thu Feb 10 15:14:44 MST 2005
Model: CLM
Version: CLM3.expa.20
One-line Summary: 
Requires change in build system: no
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) (yes for CCSM relative to clm3_expa_19)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:
1) Put in changes from clm3_expa_16->clm3_expa_17 for clm_clmsMod.F90 back -
   these changes were inadvertently removed in clm3_expa_18	  
2) Testing done:
   Checked out ccsm3_0_brnchT_bgc1 and used clm code from
   clm3_expa_17 and clm3_expa_20 for tests
   verified that TER.01a.T31_gx3v5.I.bluesky
   was bfb when	clm3_expa_20 code and clm3_expa_17 code 
   was used for clm (note that when using clm3_expa_17 code, 
   cpl_fields_mod.F90 from ccsm3_0_1_beta03 had to be used for the test)	
	
===============================================================
===============================================================

clm3_expa_19
Originator: forrest (Forrest Hoffman)
Date: Mon Jan 31 10:09:45 MST 2005
Model: CLM
Version: CLM3.expa.19
One-line Summary: Changes for CASA model version and vector mods for recent code changes
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM (cheetah), x86 Linux (anchorage)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:

Changes for CASA model version and vector mods for recent code changes

CASA-related changes:
1. Added pft-level clayfrac(:) variable which, like sandfrac(:), contains
   the first level clay fractions.  These are now set in iniTimeConst for
   all pfts since the sand3d(i,j,l) and clay3d(i,j,l) variables from which
   they are obtained are local to that subroutine.
2. Moved call to pftdyn_wbal_init() outside ifdef so that column-level
   h2ocan_loss(:) is initialized in all configurations since it is always
   used in Hydrology1Mod.F90.
3. Removed CASA from ifdef line so that water balance routines are
   performed in the CASA configuration with dynamic landuse.

Vector and performance mods:
1. Removed loop exits in BalanceCheckMod.F90 which prevented
   vectorization.
2. Modified filter construction loop in SurfaceAlbedoMod.F90 for
   vectorization.
3. Added vector directives for filter loop recently added to filterMod.F90
4. Added OpenMP and Cray Streaming directives to loop over clumps in
   filterMod.F90 since setFilters() is called repeatedly in dynamic
   landuse configuration.
5. Vectorized pftdynMod.F90.

Ran test-model on IBM (cheetah) and x86 Linux (anchorage) comparing with
clm3_expa_18.

===============================================================
===============================================================

clm3_expa_18
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Jan 28 16:59:10 MST 2005
Model: CLM
Version: CLM3.expa.18
One-line Summary: put in new interface in clm_csmMod.F90 for BGC generalization
Requires change in build system: no
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes (CCSM)
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself, Rob Jacob
Changes answers: no (bit-for-bit) 
Changes made:
Changed clm_csmMod.F90 and csm_share/cpl/cpl_fields_mod.F90 so
that indexing of fields would occur via MCT prompting commands
rather than through parameters.	
===============================================================
===============================================================

clm3_expa_17
Originator: thornton ( Peter Thornton)
Date: Mon Jan 24 10:21:26 MST 2005
Model: CLM
Version: CLM3.expa.17
One-line Summary: modifications to allow water conservation with dynamic pft weights
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes (new-physics)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:

Added code that references the pft weight shifts introduced in
clm3_expa_16, and alters state and flux variables to maintain water
mass balance across the weight shift.
1. added routine pftdyn_wbal, called from driver(), that calculates
   the necessary changes in state and flux variables.  The only state variable
   affected are the pft and column level h2ocan (intercepted water stored on
   canopy).  For timesteps in which weight of a PFT increases, the water
   state is spread over the increased area, resulting in lower h2ocan
   concentration, but conserved mass.  For increases from zero weight in the
   previous timestep, the previous h2ocan mass is controlled to be zero.
   For timesteps in which a pft weight is decreasing, the h2ocan mass
   associated with the lost area is transferred to to top of the snow/soil
   column, through a flux in parallel with throughfall. Weight shifting is
   constrained to occur on albedo timesteps.
2. Beginning water balance for the timestep is assessed prior to the weight
   shift, and the end balance is assessed following the weight shift.  Since
   the water balance is assessed at the column level, using pft-level h2ocan
   states that have been averaged to the column based on the new pft weights,
   this ordering will catch mass balance errors associated with incorrectly
   accounting for the pft-level changes in h2ocan mass.
3. pftdyn_interp() is also modified from clm3_expa_16, so that now if a 
   pftdyn dataset is specified and the current model time is before the first
   year of the pftdyn dataset, the first year of the pftdyn dataset is used
   until the model time enters the pftdyn dataset time range.  Likewise, if
   the model time is after the final year of the pftdyn dataset, pft weights
   from the last year of the pftdyn dataset are used for the rest of the 
   simulation.
===============================================================
===============================================================

clm3_expa_16
Originator: mvertens ( Mariana Vertenstein)
Date: Tue Dec 21 13:38:17 MST 2004
Model: CLM
Version: CLM3.expa.16
One-line Summary: incorporated dynamic land use functionality
Requires change in build system: yes (see notes below)
Tested to work coupled with CCSM: no
Tested to work with CAM: yes (no comparison made however)
Machines tested: IBM, Linux(lf95)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Peter Thornton
Changes answers: no (bit-for-bit) 
Changes made:
1) removed generation of surface datasets as part of CLM and created offline tool
   see $ROOTDIR/tools/mksurfdata and look at README file in this directory

2) parameters:
   clm_varpar.F90 - the paramater maxpatch_pft is now set to a cpp token MAXPATCH_PFT
   (note that the cpp token can be set to numpft+1)

3) namelist:
   namelist addition - the following variables have been added to the namelist
     rank_vegpfts, allocate_all_vegpfts, fpftdyn  
   - the following defaults are set for these variables
     fpftdyn = ' '
     if (maxpatch_pft == numpft+1) then	
        allocate_all_vegpfts = .true.
        rank_vegpfts = .false.
     else
        allocate_all_vegpfts = .false.	
        rank_vegpfts = .true. 
     end if
   - if fpftdyn is non-blank: 
      - the dynamic landuse dataset specified by fpftdyn is used at
        every time step to read in and interpolate the weights and 
        a new call to setFilters is done after the weights are read in
      - rank_vegpfts must be false and allocate_all_vegpfts must be true
        if fpftdyn is non-blank
      - SCAM, DGVM and CASA cannot be defined if fpftdyn dyn is non-blank
   - the following namelist options can still be read in (for backwards compatibility)
     but currently do not do anything
        mksrf_fvegtyp, mksrf_fsoitex, mksrf_fsoicol, mksrf_flanwat, &
        mksrf_fglacier, mksrf_furban, mksrf_flai, mksrf_offline_fgrid, &
        mksrf_offline_edgen, mksrf_offline_edgee, mksrf_offline_edges, &
        mksrf_offline_edgew, mksrf_offline_fnavyoro

4) surfFileMod.F90:
   this routine has been completely rewritten in order to facilitate the
   addition of dynamic land use (fpftdyn)
   the public interface - surfrd now contains the following logic:

   surfrd(veg, wtxy)
       call surfrd_get_grid(ncid) 
       call surfrd_wtxy_special(ncid, pctspec, veg, wtxy)
   #if (! defined DGVM)     
       if (rank_vegpfts) then
          call surfrd_wtxy_veg_rank(ncid, pctspec, veg, wtxy)
       else
          call surfrd_wtxy_veg_all(ncid, pctspec, veg, wtxy)
       end if
   #else
       call surfrd_wtxy_veg_dgvm(pctspec, veg, wtxy)
   #endif

   routine surfrd_get_grid reads in grid information from the surface dataset
   and if COUP_CAM or COUP_CSM are defined - compares this grid information
   with that obtained from either the CAM or CSM via the arrays 
   (ext_longxy, ext_latixy, etc)

5) any calculations involving weights have been removed from inicFileMod.F90
   and restFileMod.F90 and put into DriverInitMod.F90. All future coding should
   maintain this requirement the inicFileMod.F90 and restFileMod.F90 do not
   need updated weights for any calculations.

6) initializeMod.F90:
   this routine was completely rewritten in order to facilitate the addition
   of dynamic land use (fpftdyn). New documentation in the routine should help
   the readability:

7) iniTimeConst.F90:
   The following arrays are now local to iniTimeConst.F90 which obtains their
   values in a separate read from the surface dataset. This was done to conserve
   memory as higher resolutions CLM versions are implemented.
     soic2d(lsmlon,lsmlat)         ! read in - soil color
     sand3d(lsmlon,lsmlat,nlevsoi) ! read in - soil texture: percent sand
     clay3d(lsmlon,lsmlat,nlevsoi) ! read in - soil texture: percent clay
     ndep(lsmlon,lsmlat)           ! read in - annual nitrogen deposition rate (gN/m2/yr)

8) iniTimeVar.F90
   this routine has been split up into module mkarbinitMod.f90 and initSurfAlbMod.F90.
   
9) COUP_CAM
   atm_lndMod.F90 and lp_coupling.F90 have been combined into a new module - 
   clm_camMod.F90. All the routines in lp_coupling.F90 are now private to clm_camMod.F90.

10) testing done:
   # summary of tests:
   # T42       : CN on , allocate_all_vegpfts = .true. , maxpatch_pft=4
   # T42cnoff  : CN off, allocate_all_vegpfts = .false., maxpatch_pft=4
   # T42allpfts: CN on , allocate_all_vegpfts = .true. , maxpatch_pft=numpft+1
   # DGVM      : CN off, allocate_all_vegpfts = .false., maxpatch_pft=10
   all final tests were done on ibm and linux(lf95)
   - ran test-model.pl               -c clm3_expa_14 successfully (ibm, linux)
   - ran test-model.pl -res T42cnoff -c clm3_expa_14 successfully (ibm, linux)
   - ran test-model.pl -res DGVM     -c clm3_expa_14 successfully (ibm)
   - verified that ccsm3_0_1_beta03_clm3_expa_16 and ccsm3_0_1_beta03_clm3_expa_14
     were bfb for TSM.01a.T31_gx3v5.I.blackforest
   - verified that ccsm3_0_1_beta03_clm3_expa_16 TER.01a.T31_gx3v5.F.blackforest passed
   - ran test-model.pl successfully cam (cam3_0_21_clm3_expa_16) but did not
     compare to cam3_0_31 (***this still needs to be done***)
   - created dynamic landuse dataset for 1980 and 1981 that had identical
     pft information as the corresponding surface dataset - verified
     that interpolation	was working correctly - however, was not able
     to introduce roundoff level changes for a long time period when
     these dynamic datatset was used since the interpolation introduced
     roundoff level changes in the weights which corrpespondingly
     introduced higher than roundoff level changes in the simulation
     due to the averaging of pft->col weights.	      
===============================================================
	
===============================================================

clm3_expa_15
Originator: forrest (Forrest Hoffman)
Date: Mon Dec 20 14:33:59 MST 2004
Model: CLM
Version: CLM3.expa.15
One-line Summary: CN and subgridAve vector modifications and CASA' flux initialization fix
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM (blackforest and cheetah), i386 Linux (anchorage)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Mariana Vertenstein
Changes answers: no (bit-for-bit) except on Cray X1
Changes made:

CN Vector Modifications
-----------------------
Modified all CN source files in biogeochem/ and main/ to provide vector
performance of code on Cray X1.  Performed offline model validation test on
Cray X1 compared by Peter Thornton against results from the IBM.

subgridAve Vector Modifications
-------------------------------
Modified the subgrid averaging routines to provide vector performance since
they must now be called every timestep for dynamic prescribed vegetation.
CPP_VECTOR must be defined for these code sections to be used; otherwise, the
more compact non-vector version is compiled.

CASA' Flux and Carbon Pool Initialization
-----------------------------------------
fco2, fnpp, and Cflux are now initialized to 0._r8 in initCASA() so that
they are scaled correctly up to the gridcell level.  Vegetation and wood
carbon pools are now scaled either by 1.0 or 0.0 since CASA initial carbon
pool file contains values in terms of vegetation percent averages.

test-model was run on blackforest and cheetah (IBMs) and anchorage (Linux).
test-model no longer runs correctly on the Cray X1, but the validation
demonstrated correct results on the Cray X1.

===============================================================
===============================================================

clm3_expa_14
Originator: mvertens ( Mariana Vertenstein)
Date: Tue Nov 16 15:08:17 MST 2004
Model: CLM
Version: CLM3.expa.14
One-line Summary: bug fix in clm_csmMod.F90
Requires change in build system: no
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: see (clm3_expa_13)
Changes made:
1) put in a bug fix that enabled coupled mode to work
2) testing done:	
   validated that coupled mode gave bfb answers with clm3_expa_12 
   when old pft dataset and maxpatch_pfts were used (did F case and K case).
   validated that using maxpatch_pft = 17 worked and gave restarts
   (needed to create a new T31 surface format dataset to do this)	
===============================================================
	
===============================================================

clm3_expa_13
Originator: mvertens ( Mariana Vertenstein)
Date: Mon Nov  1 09:48:45 MST 2004
Model: CLM
Version: CLM3.expa.13
One-line Summary: added allocation for all pfts on new surface dataset
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Linux(lf95)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Peter Thornton
Changes answers:  Yes (same-to-roundoff) - climate validation is needed
Changes made:
	
1) Introduced a new clm namelist, allocate_all_vegpfts, that if set to
   true will reserve memory for numpft+1 pfts on the vegetated
   landunit. This namelist setting is only valid when the new format
   surface dataset is used (with all possible pfts present on the
   gridcell). This namelist setting is not valid in DGVM mode.

2) Changed the calculations so that are done only on pfts where the
   weight relative to the gridcell is greater than 0.

3) Changed the history file code so that if xy output is requested,
   the history buffer is always on the gridcell level and mapping to
   the gridcell is done for every history field at every timestep.

4) loops that went from 1,maxpatch_pft were modified to go from
   1,max_pft_per_col where max_pft_per_col is set to numpft+1 in 
   clm_varpar.F90.
   
5) Changes were as follows:

  o) modified clm_varpar so that 

     integer, parameter :: max_pft_per_gcell = (numpft+1) + 4 + maxpatch_cft
     integer, parameter :: max_pft_per_col   = numpft+1

  o) The following files were change so that calculations were only done
     if the pft weight relative to the gridcell was > 0.

      biogeochem/CNFireMod.F90
      biogeochem/CNGapMortalityMod.F90
      biogeochem/CNPhenologyMod.F90
      biogeochem/DUSTMod.F90
      biogeophys/BalanceCheckMod.F90
      biogeophys/Biogeophysics2Mod.F90
      biogeophys/DriverInitMod.F90
      biogeophys/SoilHydrologyMod.F90
      biogeophys/SoilTemperatureMod.F90
      biogeophys/SurfaceAlbedoMod.F90
      biogeophys/Attic/SurfaceRadiationMod.F90
      main/CNiniTimeVar.F90
      main/clm_csmMod.F90
      main/lnd2atmMod.F90
      main/subgridAveMod.F90

   o) Rewrote CanopyFluxesMod.F90 so that calls to 
      Stomata, StomataCN and FrictionVelocity would not result in array copies
      (modified Stomata and StomataCN to point to clm3 type arrays rather than
      passing these in as arguments).  Also changed calculations so that
      they were only done if the pft weight relative to the gridcell was > 0.

   o) Removed unnecesary variables from DGVMMod.F90

   o) Changed biogeochem/STATICEcosysDynMod.F90 so that logic is more extensible
      in setting mlai, msai, mhvt, mhvtb to non-zero values 

   o) Removed the Error check: global sum fld_o = global sum fld_i in areaMod.F90.
      this resulted in erroneous error messages when running with a reduced grid.

   o) Added allocate_all_vegpfts to clm_varctl.F90 and controlMod.F90. 
      By default this is set to .false.

   o) Modified FilterMod.F90 so that pft filters are only calculated where the
      pft weights relative to the gridcell are greater than 0.

   o) Modified histFileMod.F90 so that history buffer is at the gridcell level
      when xy output is requested. Also 1d history buffer is only updated when
      the weight relative to the gridcell is greater than 0. Also, modified
      histFldsMod.F90 so that RSSHA, RSSUN are now time averaged fields
      and TSNOW, SNOWLIQ and SNOWICE are now instantaneous fields.
 
   o) Modified inicFileMod.F90 so that T_REF2M was added. 

   o) Modified initSubGridMod so that npfts_per_lunit = numpft+1 if allocate_all_vegpfts
      is true.

   o) Modified mlai.F90, mkpft.F90 and mksrfdatMod.F90 so that only new surface data format
      is created.

6) Testing Done:

   incorporated allocate_all_pfts=.true. as default in test-model.pl

   linux (lf95) (anchorage)
      ran test-model.pl               successfully (CN on , full alloc on )
      ran test-model.pl -res T42cnoff successfully (CN off, full alloc on )
      ran test-model.noalloc.pl       successfully (CN on , full alloc off)

      Comparing the diagnostic output from for alloc-on and alloc-off for CN on,
      the output was the same for first 5 time steps and then started diverging. 
      A climate simulation needs to be done to verify that the roundoff level 
      differences results in the same climate.

   ibm-sp (blackforest)
      ran test-model.noalloc.pl and test-model.pl (CN is on)
         diagnostic output was the same for the first 3 timesteps and then started diverging
      ran test-model.noalloc.pl -res T42cnoff and test-model.pl -res T42CNoff (CN is off)
         diagnostic output was the same for the first 8 timesteps and then started diverging
      ran test-model.noalloc.pl -res T42cnoff compared with clm3_expa_12
         verified that only roundoff differences appeared in the history file fields accept
         for RSSHA, RSSUN, TSNOW, SNOWLIQ, SNOWICE (see above)
      ran test-model.hist1d.pl 
      ran test-model.noalloc.hist1d.pl compared with clm3_expa_12 
	 1d history file output was identical except for TSNOW, SNOWLIQ and SNOWICE 
	
   sgi-irix64 (tempest)
      ran test-model.noalloc.pl and test-model.pl (CN is on)
         diagnostic output was the same for the first 3 timesteps and then started diverging
      ran test-model.pl -res T42cnoff (CN is off)
      ran test-model.noalloc.pl -res DGVM 

   ***Note*** testing must still be done for COUP_CSM and COUP_CAM model
   ***Note*** more testing needs to be done with DGVM to validate answers 
   ***Note*** did not test generation of surface datasets, this must also be done
	
===============================================================
===============================================================

clm3_expa_12
Originator: thornton ( Peter Thornton)
Date: Mon Oct 18 13:03:57 MDT 2004
Model: CLM
Version: CLM3.expa.12
One-line Summary: Moved surface albedo call to end of driver loop.
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: yes
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: Yes
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: Mariana Vertenstein, Peter Thornton
Changes answers: Yes (new-physics)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
ccsm3_K_sa1, ccsm3_K_sa2, ccsm3_K_cnsa1, ccsm3_K_cnsa2
Changes made:

Merged loop1 and loop2 in clm driver. Now surface albedo is called at the
end of the loop, and csm_send is called after the loop. This change is the
first step in getting all updates to prognostic variables moved to the end
of the timestep, in preparation for water and carbon isotope code.

===============================================================
===============================================================

clm3_expa_11
Originator: forrest (Forrest Hoffman)
Date: Mon Sep 20 11:49:36 MDT 2004
Model: CLM
Version: CLM3.expa.11
One-line Summary: Added experimental CASA' carbon cycle model to CLM.  Renamed *_transfer* variables in CN code to *_xfer* and modified history field names to match.
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: yes
Machines tested: IBM (cheetah and blackforest), x86 Linux (anchorage), Cray X1 (phoenix)
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself, Jasmin John
Changes answers: no (bit-for-bit)
Changes made:

Added the CASA' carbon cycle model to the CLM code.  CASA' can be used by
compiling with the CASA and SUNSHA cpp variables set.  It can not be used
with either DGVM or CN enabled.

Renamed all *_transfer* variable in the CN code to *_xfer* and modified
history field names consistently, so *_TRANSFER* fields became *_XFER* fields.

Ran test-model on cheetah, blackforest, anchorage, and phoenix.

===============================================================
===============================================================
	
clm3_expa_10
Originator: mvertens ( Mariana Vertenstein)
Date: Wed Aug 25 11:10:34 MDT 2004
Model: CLM
Version: CLM3.expa.10
One-line Summary: put in new subgrid initialization interface
Requires change in build system: no (unless a new crop landunit is desired)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit) (except for roundoff on 2d history files)
Changes made:
1) Removed cpp variable NOCOMPETE from code.
2) Added namelist variable create_crop_landunit.  
   This permits the user to decide if a separate crop landunit is to
   be created with the new surface dataset format (where all pfts appear).
   By default create_crop_andunit is set to .false.
   Removed logic that tied the use of new surface dataset format to the presence
   of a separate crop landunit.
   modified files:
     main/controlMod.F90
     main/surfFileMod.F90
     min/clm_varctl.F90.
3) Unified interface to create gridcells and landunits.
   modified files:
     main/Attic/decompMod.F90
     main/histFileMod.F90
     main/inicFileMod.F90
     main/Attic/initGridCellsMod.F90
   added files:
     main/initGridIndexMod.F90
     main/initSubgridMod.F90
   - all logic to create new landunits now goes in module initSubGridMod.F90.
   - If a new landunit (landunit_xxx) is to be created
      o subroutine get_gcell_info should be modified to contain logic for landunit_xxx
      o a new subroutine set_landunit_xxx should be added to the module
      o a new call to set_landunit_xxx should be added in subroutine initGridCells in 
        module subroutine initGridCellsMod.F90

       call set_landunit_veg_compete( &
            ltype=xxx, wtxy=wtxy, vegxy=vegxy, &
            i=i      , j=j      , gi=gi      , li=li      , ci=ci      , pi=pi, &
            i_sn=i_sn, j_sn=j_sn, gi_sn=gi_sn, li_sn=li_sn, ci_sn=ci_sn, pi_sn=pi_sn, &
            nump=nump, numc=numc, numl=numl, &
            land1d_sn_gi=land1d_sn_gi, cols1d_sn_li=cols1d_sn_li, cols1d_sn_gi=cols1d_sn_gi, &
            pfts1d_sn_ci=pfts1d_sn_ci, pfts1d_sn_li=pfts1d_sn_li, pfts1d_sn_gi=pfts1d_sn_gi)

       note - the only thing that is unique about this call is the setting of ltype.
4) Testing done
   a) ran test-model.pl (with CN on) and verified that code is bfb with clm3_expa_9.
      Note, however, that the 2d history output will have roundoff differences with 
      respect to clm3_expa_9 due to the new calculation of the weights in initSubGridMod.F90.
      Also verified that the initial datasets created with clm3_exap_10 were bfb with clm3_expa_9.
   b) verified that clm3_expa_10 is bfb with clm3_expa_9 when create_crop_landunit=.true..
      and a new format surface dataset is used 
      (fsurdat = '/fs/cgd/csm/inputdata/lnd/clm2/srfdata/csm/surface-data.128x064_atm.gx1v3_ocn.allpfts_c040426.nc).
===============================================================
===============================================================

clm3_expa_9
Originator: thornton ( Peter Thornton)
Date: Sat Aug 14 01:09:21 MDT 2004
Model: CLM
Version: CLM3.expa.9
One-line Summary: Added constraint preventing zero height in CNVegStructUpdateMod.F90
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: Yes (new-physics)
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:
Fixed a bug in CNVegStructUpdateMod.F90 that caused divide-by-zero in
FrictionVelocity when htop -> 0.0, causing z0m -> 0.0. Added constraint so that
htop is always greater than 0. Bug only appeared in fire simulation when deadstemc
was forced very low by fire.
===============================================================
===============================================================

clm3_expa_8
Originator: mvertens ( Mariana Vertenstein)
Date: Thu Aug 12 15:35:51 MDT 2004
Model: CLM
Version: CLM3.expa.8
One-line Summary: merged in changes from clm3_deva_10 to clm3_deva_21 except for removal of DUST code
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Changes made:
1) Brought clm_exp branch up to date with clm3_deva_21
   (branch was created starting from clm3_deva_10)
2) Testing done:
   Ran test-model.pl at T42 on IBM and verified that it was 
   bfb with clm3_expa_7
===============================================================
===============================================================

clm3_expa_7
Originator: thornton ( Peter Thornton)
Date: Wed Aug  4 13:29:18 MDT 2004
Model: CLM
Version: CLM3.expa.7
One-line Summary: Added fire to CN code, other minor mods
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: Yes (new-physics)
Changes made:
1. Added Thonicke fire algorithm, working mainly from 2001 paper. Modifications
   to that algorithm made to represent fire occurrence on every timestep, instead of
   as an annual process. Set cpp variable NOFIRE in job script to eliminate the 
   effects of fire algorithm (results bit-for-bit with previous code).
2. Modified CNPrecisionControlMod.F90 to truncate C and N state variables when they
   go below a specified threshold value.  Tracking these modifications in new
   truncation state variables, which accumulate the net changes over a run.
3. Moved CN state update calls and summary call into CNEcosysdyn, from driver.
   (bit-for-bit)
===============================================================
===============================================================

clm3_expa_6
Originator: thornton ( Peter Thornton)
Date: Fri Jul 16 13:17:43 MDT 2004
Model: CLM
Version: CLM3.expa.6
One-line Summary: Added initial file capability for CN code
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: yes (some bug fixes)
Changes made:

1. Added all required fields on initial file for CN start from spunup values
2. (bug fix) Added pepv%tampsum_npp and pepv%annsum_npp to CNSetPepv()
3. (bug fix) Added pepv%prev_leafc_to_litter and pepv%prev_frootc_to_litter
   to CNiniTimeVar().
4. Added totlitn, totsomn, totecosysn, totcoln to column loop of
   CNiniTimeVar(). Added dispvegn, storvegn, totvegn, totpftn to 
   pft loop of CNiniTimeVar().
5. set all c and n state and flux variables to 0.0 on special landunits, instead of spval.  
6. (bug fix) Added missing (p) to frac_veg_nosno in CNiniSpecial().
7. Modified treatment of AGNPP and BGNPP so that they correspond better to
   likely measurements of above and belowground NPP, in CSummary().
8. modified setting for noveg pft rootfr from spval to 0.0

===============================================================
===============================================================

clm3_expa_5
Originator: thornton ( Peter Thornton)
Date: Thu Jul  1 15:37:19 MDT 2004
Model: CLM
Version: CLM3.expa.5
One-line Summary: added two files that were omitted from clm3_expa_4 tag
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Compaq
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Changes made:
added two files (CNNdynamicsMod.F90 and ndepFileMof.F90) that
were omitted from the clm3_expa_4 tag

===============================================================
===============================================================

clm3_expa_4
Originator: thornton ( Peter Thornton)
Date: Tue Jun 29 09:30:18 MDT 2004
Model: CLM
Version: CLM3.expa.4
One-line Summary: Added NDep input, NFix, NLeaching, NSummary
Requires change in build system: no
Modifications to finish the N cycle
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: Yes 
Changes made:
1. Added routine to read a new surface dataset for N deposition (optional)
2. Added routine to estimate biological N fixation as a function of annual NPP
3. Added N leaching routine, function of mineral N concentration and drainage flow
4. Added new N cycle summary variables as standard history file outputs (with CN on)
5. Turned on bulk denitrification (previously implemented, but constant set to 0)
6. Fixed problem with current datasets where temperate deciduous forest was being assigned
   in the tropics - the phenology algorithm for temperate deciduous doesn't work in this case
   because of daylength constraints.  These pfts are now set on initialization to seasonal
   deciduous types.  Solves high-LAI problem in tropics.
7. Fixed bug in calculation of diagnostic total carbon (previously excluded coarse woody debris).
8. Added coarse woody debris decomposition fluxes (previously turned off).
===============================================================
===============================================================

clm3_expa_3
Originator: thornton ( Peter Thornton)
Date: Thu May 27 15:01:39 MDT 2004
Model: CLM
Version: CLM3.expa.3
One-line Summary: Merged Thornton's CN code onto clm_exp branch
Requires change in build system: no
(one-line description of changes: Makefile, include files, directories, etc.)
(Detailed description below)
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Compaq
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Changes made:
Merged Thornton's CN code from branch clm2_deva_41_brnch_cn onto the new
clm_exp branch.  Tested that the results are BFB for 1-day run against 
clm3_expa_2 with all CN options turned off, and tested that results are
BFB for 1-day run against the final tag on the original CN branch
(clm3_expa_2_brnchT_cn3_9) with all CN options turned on.

===============================================================
===============================================================

clm3_expa_2
Originator: mvertens ( Mariana Vertenstein)
Date: Fri Apr 30 10:21:42 MDT 2004
Model: CLM
Version: CLM3.expa.2
One-line Summary: removed cpl/ code directory from csm_share/ 
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: none
Tested that restarts are bit-for-bit: no
Tested that different domain decompositions match bit-for-bit: no
Code reviewed by: myself
Changes answers: no (bit-for-bit) 
Name of tests cases on NCAR Mass-Store: (For changes that change answers)
Changes made:
Removed cpl/ code directory from csm_share/ - this is never needed
	
===============================================================
===============================================================

clm3_expa_1
Originator: erik ( Erik Kluzek)
Date: Wed Apr 28 14:33:52 MDT 2004
Model: CLM
Version: CLM3.expa.1
One-line Summary: Start of clm_exp experimental development branch -- same as clm3_deva_10
Requires change in build system: no
Tested to work coupled with CCSM: no
Tested to work with CAM: no
Machines tested: IBM, SGI, Linux
Tested that restarts are bit-for-bit: yes
Tested that different domain decompositions match bit-for-bit: yes
Code reviewed by: myself
Changes answers: no (bit-for-bit)
Changes made:

This is the start of the clm_exp experimental development 
branch. This version is the same as clm3_deva_10 which was checked
into clm_dev by Mariana Vertenstein on April 27th, 2004.
===============================================================
===============================================================
===============================================================





















